/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDStd.c                                                     //
'**  '// Version        :   1.02                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#include "CDeviceDStd.h"

static uint8 DeviceGUID[16] = {0xBC, 0xFC, 0xDB, 0x75, 0xD5, 0x73, 0x45, 0x7e, 
                               0x82, 0xE0, 0xCA, 0xCD, 0xDD, 0x3D, 0x4B, 0x1E};

#define CDEVDSTD_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CDeviceDStd_TypVersionsTbl, \
                      CDEVDSTD_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CDeviceDStd_TypVersionsTbl[CDEVDSTD_MEMBER_MAX] = {
    100, 102, /*CDEVICEDSTD_DateTime*/
    100, 102, /*CDEVICEDSTD_RunTime*/
    100, 102, /*CDEVICEDSTD_ModelName*/
    100, 102, /*CDEVICEDSTD_SerialNumber*/
    100, 102, /*CDEVICEDSTD_DeviceGUID*/
    101, 102, /*CDEVICEDSTD_ModelNumber*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CDeviceDStd_Init(CDeviceDStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CDeviceDStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmDEVICE, GnDATA, CDEVDSTD_SpSTANDARD);

        /*Set the DeviceGUID*/
        memcpy(pObject->m_DeviceGUID, DeviceGUID, sizeof(pObject->m_DeviceGUID));
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CDeviceDStd_Reset(CDeviceDStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Initialize the Object*/
        if(bInit)
        {
            CDeviceDStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CDeviceDStd_SizeAll(const CDeviceDStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CDEVDSTD_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16);            /* CRC bytes */

        return CDEVDSTD_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CDeviceDStd object into the buffer passed in.
*********************************************************************************/
boolean CDeviceDStd_Serialize(const CDeviceDStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CDeviceDStd_SizeAll(pObject) - CDEVDSTD_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CDEVDSTD_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CDEVDSTD_STATIC_DATA_SIZE);

        /* Set the m_DateTime */
        Put_MOIBTIME(&pTemp, pObject->m_DateTime);

        /* Set the m_RunTime */
        WriteInt32(&pTemp, pObject->m_RunTime);

        /* Set the m_ModelName */
        for(index = 0; index < sizeof(pObject->m_ModelName)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, pObject->m_ModelName[index]); 
        }

        /* Set the m_SerialNumber */
        for(index = 0; index < sizeof(pObject->m_SerialNumber)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, pObject->m_SerialNumber[index]); 
        }

        /* Set the m_DeviceGUID */
        for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
        {
            WriteInt8(&pTemp, pObject->m_DeviceGUID[index]); 
        }

        /* Set the m_ModelNumber */
        for(index = 0; index < sizeof(pObject->m_ModelNumber)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, pObject->m_ModelNumber[index]); 
        }

        /* Set the CRC */
        CRCSize = CDeviceDStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CDeviceDStd object passed in.
*********************************************************************************/
boolean CDeviceDStd_Deserialize(CDeviceDStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint16  Version;
        uint16  StructSize;
        uint32  ElementsUsed;
        uint16  StoredCRC;
        uint16  CalcCRC;
        uint32  CRCSize;
        uint32  ClassID;
        uint32  index;

        /* Calculate the CRC */
        CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
        CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

        /* Get the stored CRC */
        StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

        /* Check the CRC */
        if (CalcCRC == StoredCRC)
        {
            /* Verify the Family and Genus match */
            ClassID = ReadInt32(&pTemp);
            if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
            {
                /* Set the ClassID to update the species */
                pObject->ClassID = ClassID;

                /* Get the size of the payload */
                if(IsExtended_ClassID(pObject->ClassID))
                    ElementsUsed = ReadInt32(&pTemp);
                else
                    ElementsUsed = ReadInt16(&pTemp);

                /* Get the Version */
                Version = ReadInt16(&pTemp);
                ElementsUsed -= sizeof(uint16);

                if(Version <= CDEVDSTD_OBJECT_VERSION)
                {
                    /* Store the dequeued version */
                    pObject->SrcVersion = Version;

                    /* Get the DataBitField */
                    SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                    ElementsUsed -= sizeof(uint8);

                    /* Get the size of the static structure */
                    StructSize = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if((StructSize) &&
                       (CDEVDSTD_VERSION_STATUS(CDEVDSTD_DateTime, pObject->SrcVersion)))
                    {
                        /* Get the m_DateTime */
                        pObject->m_DateTime = Get_MOIBTIME(&pTemp);
                        ElementsUsed -= MOIB_TIME_SIZE;
                        StructSize -= MOIB_TIME_SIZE;
                    }
                    if((StructSize) &&
                       (CDEVDSTD_VERSION_STATUS(CDEVDSTD_RunTime, pObject->SrcVersion)))
                    {
                        /* Get the m_RunTime */
                        pObject->m_RunTime = ReadInt32(&pTemp);
                        ElementsUsed -= sizeof(uint32);
                        StructSize -= sizeof(uint32);
                    }
                    if((StructSize) &&
                       (CDEVDSTD_VERSION_STATUS(CDEVDSTD_ModelName, pObject->SrcVersion)))
                    {
                        /* Get the m_ModelName */
                        for(index = 0; index < sizeof(pObject->m_ModelName)/sizeof(ansichar); index++)
                        {
                            pObject->m_ModelName[index] = ReadInt8(&pTemp);
                        }
                        ElementsUsed -= sizeof(pObject->m_ModelName);
                        StructSize -= sizeof(pObject->m_ModelName);
                    }
                    if((StructSize) &&
                       (CDEVDSTD_VERSION_STATUS(CDEVDSTD_SerialNumber, pObject->SrcVersion)))
                    {
                        /* Get the m_SerialNumber */
                        for(index = 0; index < sizeof(pObject->m_SerialNumber)/sizeof(ansichar); index++)
                        {
                            pObject->m_SerialNumber[index] = ReadInt8(&pTemp);
                        }
                        ElementsUsed -= sizeof(pObject->m_SerialNumber);
                        StructSize -= sizeof(pObject->m_SerialNumber);
                    }
                    if((StructSize) &&
                       (CDEVDSTD_VERSION_STATUS(CDEVDSTD_DeviceGUID, pObject->SrcVersion)))
                    {
                        /* Get the m_DeviceGUID */
                        for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
                        {
                            pObject->m_DeviceGUID[index] = ReadInt8(&pTemp);
                        }
                        ElementsUsed -= sizeof(pObject->m_DeviceGUID);
                        StructSize -= sizeof(pObject->m_DeviceGUID);
                    }
                    if((StructSize) &&
                       (CDEVDSTD_VERSION_STATUS(CDEVDSTD_ModelNumber, pObject->SrcVersion)))
                    {
                        /* Get the m_ModelNumber */
                        for(index = 0; index < sizeof(pObject->m_ModelNumber)/sizeof(ansichar); index++)
                        {
                            pObject->m_ModelNumber[index] = ReadInt8(&pTemp);
                        }
                        ElementsUsed -= sizeof(pObject->m_ModelNumber);
                        StructSize -= sizeof(pObject->m_ModelNumber);
                    }
                    if(StructSize)
                    {
                        /* Dequeue the remaining extra bytes of the static struct */
                        pTemp += StructSize;
                        ElementsUsed = ElementsUsed - StructSize;
                    }

                    bResult = TRUE;
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CDeviceDStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Writes the object into an XML file pointed to by the fhnd. Returns the number of
Bytes written into the file.
*********************************************************************************/
uint32 CDeviceDStd_serialize_to_XMLbuf(CDeviceDStd *pObject, char *pBuf)
{
    char Buffer[4096];
    char *Output = Buffer;
    uint32 NewSize   = 0;
    uint32 FinalSize = 0;
    uint32 ZeroSize  = 0;
    uint32 *pSizeCount = &ZeroSize;
    char TimeBuffer[128];
    ansichar GUIDOutput[GUID_STR_SIZE];
    if(pObject == NULL)
        return FinalSize;

    /* If pBuf is NULL, then we don't write anything to it, and just 
    return the potential size */
    if(pBuf != NULL)
    {
        Output = pBuf;
        pSizeCount = &NewSize;
    }

    NewSize = sprintf(Output,
            /*XML formatted Output to file*/
            "<DEFINITION class=\"CDeviceDStd\" version=\"%d\" "
                        "family=\"%d\" genus=\"%d\" species=\"%d\">\n",
            /*---------------------------------------------------------------*/
            /*Data for the related types above.
            uint16 representation Version*/
            CDEVDSTD_OBJECT_VERSION,
            dt_family(pObject->ClassID),
            dt_genus(pObject->ClassID),
            dt_species(pObject->ClassID));

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            /*---------------------------------------------------------------*/
            /* -- MOIB_TIME value YYYY/MM/DD HH:MM:SS --*/
            NewSize = sprintf(Output, "<MEMBER type=\"TIME\" name=\"DateTime\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%s]]></VALUE>\n", MOIBTimeToStr(pObject->m_DateTime, TimeBuffer));
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"RunTime\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", pObject->m_RunTime);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- ansichar pointer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"ansichar\" size=\"32\" name=\"ModelName\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(pObject->m_ModelName[0] != 0)
            {
                NewSize = sprintf(Output, "%s", pObject->m_ModelName);
                FinalSize += NewSize;
                Output += *pSizeCount;
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- ansichar pointer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"ansichar\" size=\"16\" name=\"SerialNumber\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(pObject->m_SerialNumber[0] != 0)
            {
                NewSize = sprintf(Output, "%s", pObject->m_SerialNumber);
                FinalSize += NewSize;
                Output += *pSizeCount;
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- GUID array --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" name=\"DeviceGUID\" size=\"16\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%s]]></VALUE>\n", GUIDToStr(pObject->m_DeviceGUID, GUIDOutput, sizeof(pObject->m_DeviceGUID)));
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- ansichar pointer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"ansichar\" size=\"32\" name=\"ModelNumber\" minversion=\"101\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(pObject->m_ModelNumber[0] != 0)
            {
                NewSize = sprintf(Output, "%s", pObject->m_ModelNumber);
                FinalSize += NewSize;
                Output += *pSizeCount;
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Write the closing members tag*/
            NewSize = sprintf(Output, "</MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*---------------------------------------------------------------*/

            /*Write the closing definition tag*/
            NewSize = sprintf(Output, "</DEFINITION>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

    return FinalSize+1;
}
#endif  /* #if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) */
#if defined(CDEVICEDSTD_TEST_MAIN)
/*Global Declarations*/
CDeviceDStd MyObjectSrc;
CDeviceDStd MyObjectDest;

/*Function Prototypes*/
boolean Serialize_All_Test(void);
void SetObjectProperties(CDeviceDStd *MyObjectSrc);

int main(void)
{
    int   Result, TestID;  

    CDeviceDStd_Init(&MyObjectSrc);
    CDeviceDStd_Init(&MyObjectDest);

    SYS_PRINTF("1. Transfer complete byte stream: source object-->destination object.\n");
    SYS_PRINTF("Selection:");

    Result = scanf("%d", &TestID);

    SetObjectProperties(&MyObjectSrc);

    if(TestID == 1) Serialize_All_Test();
    else{
        SYS_PRINTF("\n\nInvalid Selection.\n\n");
    }

    SYS_PRINTF("\n\nPress any character key and hit enter to continue.\n");
    Result = scanf("%d", &TestID);

};
/*================================================================================
Helper function for setting default values for the test functions
================================================================================*/
void SetObjectProperties(CDeviceDStd *MyObjectSrc)
{
    TOUCH(MyObjectSrc);
}
/*================================================================================
Helper function for writing a byte Stream to a file
================================================================================*/
void WriteToFile(char *Buf, uint32 Size, char *Filename)
{
    FILE    *Fp;
    size_t  Bytes;

    if((Fp  = fopen(Filename, "w+b")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", Filename);
    }

    Bytes = fwrite(Buf, 1, Size, Fp);

    if(Bytes != Size)
    {
        SYS_PRINTF("Error: %d out of %d written to file %s\n", Bytes, strlen(Buf), Filename);
    }
    else
    {
        SYS_PRINTF("%s created\n", Filename);
    }

    if(fclose(Fp))
    {
        SYS_PRINTF("The file %s was not closed\n", Filename);
    }
}
/*================================================================================
Helper function for comparing the two generated xml files.
================================================================================*/
void CompareFiles(char *File1, char *File2)
{
    fpos_t    Pos;
    size_t    SrcLen;
    size_t    DestLen;
    FILE      *Fp1, *Fp2;
    char      *SrcBuf = NULL;
    char      *DestBuf = NULL;
    uint32    i = 0;

    if((Fp1  = fopen(File1, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File1);
    }

    if((Fp2  = fopen(File2, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File2);
    }

    /*Get the current position of the file Stream*/
    fgetpos(Fp1, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp1, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    SrcLen = (size_t)(ftell(Fp1) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp1, &Pos);

    SrcBuf = (char*)SYS_REALLOC(SrcBuf, SrcLen);

    SrcLen = fread(SrcBuf, 1, SrcLen, Fp1);

    /*Get the current position of the file Stream*/
    fgetpos(Fp2, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp2, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    DestLen = (size_t)(ftell(Fp2) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp2, &Pos);

    DestBuf = (char*)SYS_REALLOC(DestBuf, DestLen);
    DestLen = fread(DestBuf, 1, DestLen, Fp2);

    if(DestLen == SrcLen)
    {
        for(i=0; i< DestLen; i++)
        {
            if(DestBuf[i] != SrcBuf[i])
            {
                SYS_PRINTF("File mismatch at i=%d\n", i);
                break;
            }
        }
        if(i == DestLen)
            SYS_PRINTF("%s and %s comparison - PASSED!!!\n", File1, File2);
    }
    else
    {
        SYS_PRINTF("Error - File size mismatch\n");
    }

    if(fclose(Fp1))
    {
        SYS_PRINTF("The file %s was not closed\n",File2);
    }
    if(fclose(Fp2))
    {
        SYS_PRINTF("The file %s was not closed\n", File2);
    }

    SYS_FREE(SrcBuf);
    SYS_FREE(DestBuf);
}
/*================================================================================
Serialize_All_Test
================================================================================*/
boolean Serialize_All_Test(void)
{
    boolean   Result = FALSE;
    uint8     *ByteBuffer = NULL;
    char      *XMLBuffer = NULL;
    uint32    BufferSize;
    fpos_t    Pos;
    FILE      *Stream = NULL;

#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE)
     if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = CDeviceDStd_serialize_to_XMLbuf(&MyObjectSrc, NULL);

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = CDeviceDStd_serialize_to_XMLbuf(&MyObjectSrc, XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    fclose(Stream);
#endif

    /*Size of Object*/
    BufferSize = CDeviceDStd_SizeAll(&MyObjectSrc);

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_MALLOC(BufferSize);
    if(ByteBuffer)
    {
        /*Serialize MyObjectSrc*/
        CDeviceDStd_Serialize(&MyObjectSrc, ByteBuffer);

        /*Write the serialized ByteBuffer into the Serialize_AllSrc.bytestream file*/
        WriteToFile((char*)ByteBuffer, BufferSize, "Serialize_AllSrc.bytestream");

        /*Open Src file*/
        if((Stream  = fopen("Serialize_AllSrc.bytestream", "rb+")) == NULL) 
        {
            SYS_PRINTF("The file Serialize_AllSrc.bytestream was not opened\n");
        }

        /*Get the current position of the file Stream*/
        fgetpos(Stream, &Pos);

        /*Set the file position to the end of the file*/
        fseek(Stream, 0l, SEEK_END);

        /*Get the size by subtracting the end of file - initial position.*/
        BufferSize = (uint32)(size_t)(ftell(Stream) - Pos);

        /*Set the current position back to the original*/
        fsetpos(Stream, &Pos);

        if(BufferSize)
        {
            ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
            if(ByteBuffer != NULL)
            {
                /*Return the bytes read in the file Stream to ByteBuffer*/
                fread(ByteBuffer, 1, BufferSize, Stream);

                /*Deserialize the ByteBuffer into MyObjectDest*/
                BufferSize = CDeviceDStd_Deserialize(&MyObjectDest, (uint8*)ByteBuffer);
            }
        }
        
        if(fclose(Stream))
        {
            SYS_PRINTF("The file Serialize_AllSrc.bytestream was not closed\n");
        }

#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE)
        if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
        {
            SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
        }

        /*Get the size of MyObjectDest in an XML stream*/
        BufferSize = CDeviceDStd_serialize_to_XMLbuf(&MyObjectDest, NULL);

        /*Print start tag of XML stream*/
        fprintf(Stream, "<CMOIBObj>\n");

        if(BufferSize)
        {
            XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
            if(XMLBuffer != NULL)
            {
                /*Serialize MyObjectDest in an XML stream to the XMLBuffer*/
                BufferSize = CDeviceDStd_serialize_to_XMLbuf(&MyObjectDest, XMLBuffer);

                /*Print the XML Stream to file*/
                fprintf(Stream, XMLBuffer);
            }
        }

        /*Print the end tag of the XML stream*/
        fprintf(Stream, "</CMOIBObj>");

        if(fclose(Stream))
        {
            SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
        }
#endif

        BufferSize = CDeviceDStd_SizeAll(&MyObjectDest);
        ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
        if(ByteBuffer)
            CDeviceDStd_Serialize(&MyObjectDest, (uint8*)ByteBuffer);

        /*Write the serialized ByteBuffer into the Serialize_AllDest.bytestream file*/
        WriteToFile((char*)ByteBuffer, BufferSize, "Serialize_AllDest.bytestream");

        /*compare src and dest files*/
        CompareFiles("Serialize_AllSrc.bytestream", "Serialize_AllDest.bytestream");
#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) 
        CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");
#endif
    }

    SYS_FREE(ByteBuffer);
    SYS_FREE(XMLBuffer);

    return((boolean)Result);
}
#endif

/* ---------------------------End of DataClass CDeviceDStd -------------------------------- */

