/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDStd.h                                                     //
'**  '// Version        :   1.02                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CDEVICEDSTD_H)
    #define  CDEVICEDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVDSTDtypSPECIES {
        CDEVDSTD_SpSTANDARD = 0, /*Indicates that this is an object describing the Finished Medical Device. Provides backwards compatibility since all previous uses of this object were not Finished Subsytems(hosts/sensors), but FMDs.*/
        CDEVDSTD_SpHOST = 1, /*Indicates that this is an object describing a host (Compute Engine) subsystem.*/
        CDEVDSTD_SpSENSOR = 2, /*Indicates that this is an object describing a sensor subsystem.*/
        CDEVDSTD_SpALL = 255, /*Indicates that all species are represented. Used solely for the species selector in the CDevicePMsgArguments selector object to request all subsystems device data.*/
        CDEVDSTD_SpMAX
    } CDEVDSTD_SPECIES;

    /*CDeviceDStd Member's Version Enumerations*/
    typedef  enum CDEVDSTDtypVERSIONS {
        CDEVDSTD_DateTime,
        CDEVDSTD_RunTime,
        CDEVDSTD_ModelName,
        CDEVDSTD_SerialNumber,
        CDEVDSTD_DeviceGUID,
        CDEVDSTD_ModelNumber,
        CDEVDSTD_MEMBER_MAX
    } CDEVDSTD_VERSIONS;


/*The following definition is the version.*/
#define CDEVDSTD_OBJECT_VERSION 102

#define CDEVDSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CDEVDSTD_STATIC_DATA_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 16 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 80 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CDeviceDStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    MOIB_TIME          m_DateTime; /* Manufactured date time. This value will remain intialized for ATE failure. */
    uint32             m_RunTime; /* Total on time for the unit since it was manufactured. */
    ansichar           m_ModelName[32]; /* Model Name defined by Manufacturing {31 chars and one termination byte}. */
    ansichar           m_SerialNumber[16]; /* Device serial number {15 chars and one termination byte}. */
    uint8              m_DeviceGUID[16]; /* The GUID of the DDS. It is unique per family of devices. Each unique sensor will have its own GUID as will the FMD. */
    ansichar           m_ModelNumber[32]; /* Model Number defined by Manufacturing {31 chars and one termination byte}. */

}CDeviceDStd;

void    CDeviceDStd_Init(CDeviceDStd *pObject);
void    CDeviceDStd_Reset(CDeviceDStd *pObject, boolean bResetAll, boolean bInit);
uint32  CDeviceDStd_SizeAll(const CDeviceDStd *pObject);
boolean CDeviceDStd_Deserialize(CDeviceDStd *pObject, uint8 *pBuf);
boolean CDeviceDStd_Serialize(const CDeviceDStd *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CDeviceDStd_serialize_to_XMLbuf(CDeviceDStd *pObject, char* pBuf);
#endif

#endif /* #if !defined(CDEVICEDSTD_H) */

