/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrEStd.c                                                        //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.5.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_SIM.xml version 0.1
'*-E************************************************************************/

#include "CErrEStd.h"

const char * const CErrEStd_TypStackErrorTbl[CERR_MAX]={
    "No Error",
    "Invalid Family",
    "Invalid Genus",
    "Invalid Species",
    "Object ID Mismatch",
    "CRC Mismatch",
    "Invalid Entry",
    "Duplicate entry"
};

const char * const CErrEStd_TypProcErrorTbl[CERR_PROC_MAX]={
    "No Error",
    "Unimplemented",
    "Unsupported",
    "No memory",
    "No parameter",
    "Invalid parameter",
    "Range error",
    "No object",
    "Deserialization",
    "Serialization",
    "Context error",
    "Item does not exist"
};

const char * const CErrEStd_TypAppErrorTbl[CERR_APP_MAX]={
    "NO_DESCRIPTION",
    "NO_DESCRIPTION",
    "NO_DESCRIPTION",
};

#define CERR_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CErrEStd_TypVersionsTbl, \
                      CERR_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CErrEStd_TypVersionsTbl[CERR_MEMBER_MAX] = {
    100, 200, /*CERRESTD_ErrClassID*/
    100, 200, /*CERRESTD_ErrorCode*/
    100, 200, /*CERRESTD_Description*/
    100, 200, /*CERRESTD_Data*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CErrEStd_Init(CErrEStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CErrEStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmERROR, GnERROR, CERR_SpERRNONE);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CErrEStd_Reset(CErrEStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Dynamic members*/
        SYS_FREE(pObject->m_Data);
        pObject->m_Data = NULL;
        pObject->m_DataSize = 0;


        /*Initialize the Object*/
        if(bInit)
        {
            CErrEStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CErrEStd_SizeAll(const CErrEStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CERR_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16) + pObject->m_DataSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CERR_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CErrEStd object into the buffer passed in.
*********************************************************************************/
boolean CErrEStd_Serialize(const CErrEStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CErrEStd_SizeAll(pObject) - CERR_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CERR_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CERR_STATIC_DATA_SIZE);

        /* Set the m_ErrClassID */
        WriteInt32(&pTemp, pObject->m_ErrClassID);

        /* Set the m_ErrorCode */
        WriteInt16(&pTemp, pObject->m_ErrorCode);

        /* Set the m_Description */
        for(index = 0; index < sizeof(pObject->m_Description)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, pObject->m_Description[index]); 
        }

        /* Set the m_DataSize */
        WriteInt16(&pTemp, pObject->m_DataSize);

        /* Set the m_Data */
        for(index = 0; index < (pObject->m_DataSize/sizeof(uint8)); index++)
        {
            WriteInt8(&pTemp, pObject->m_Data[index]); 
        }

        /* Set the CRC */
        CRCSize = CErrEStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CErrEStd object passed in.
*********************************************************************************/
boolean CErrEStd_Deserialize(CErrEStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint16  Version;
        uint16  StructSize;
        uint32  ElementsUsed;
        uint16  StoredCRC;
        uint16  CalcCRC;
        uint32  CRCSize;
        uint32  ClassID;
        uint32  index;

        /* Calculate the CRC */
        CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
        CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

        /* Get the stored CRC */
        StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

        /* Check the CRC */
        if (CalcCRC == StoredCRC)
        {
            /* Verify the Family and Genus match */
            ClassID = ReadInt32(&pTemp);
            if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
            {
                /* Set the ClassID to update the species */
                pObject->ClassID = ClassID;

                /* Get the size of the payload */
                if(IsExtended_ClassID(pObject->ClassID))
                    ElementsUsed = ReadInt32(&pTemp);
                else
                    ElementsUsed = ReadInt16(&pTemp);

                /* Get the Version */
                Version = ReadInt16(&pTemp);
                ElementsUsed -= sizeof(uint16);

                if(Version <= CERR_OBJECT_VERSION)
                {
                    /* Store the dequeued version */
                    pObject->SrcVersion = Version;

                    /* Get the DataBitField */
                    SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                    ElementsUsed -= sizeof(uint8);

                    /* Get the size of the static structure */
                    StructSize = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if((StructSize) &&
                       (CERR_VERSION_STATUS(CERR_ErrClassID, pObject->SrcVersion)))
                    {
                        /* Get the m_ErrClassID */
                        pObject->m_ErrClassID = ReadInt32(&pTemp);
                        ElementsUsed -= sizeof(uint32);
                        StructSize -= sizeof(uint32);
                    }
                    if((StructSize) &&
                       (CERR_VERSION_STATUS(CERR_ErrorCode, pObject->SrcVersion)))
                    {
                        /* Get the m_ErrorCode */
                        pObject->m_ErrorCode = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);
                        StructSize -= sizeof(uint16);
                    }
                    if((StructSize) &&
                       (CERR_VERSION_STATUS(CERR_Description, pObject->SrcVersion)))
                    {
                        /* Get the m_Description */
                        for(index = 0; index < sizeof(pObject->m_Description)/sizeof(ansichar); index++)
                        {
                            pObject->m_Description[index] = ReadInt8(&pTemp);
                        }
                        ElementsUsed -= sizeof(pObject->m_Description);
                        StructSize -= sizeof(pObject->m_Description);
                    }
                    if(StructSize)
                    {
                        /* Dequeue the remaining extra bytes of the static struct */
                        pTemp += StructSize;
                        ElementsUsed = ElementsUsed - StructSize;
                    }

                    if((ElementsUsed > 2) &&
                       (CERR_VERSION_STATUS(CERR_Data, pObject->SrcVersion)))
                    {
                        /* Get the m_DataSize */
                        pObject->m_DataSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        /* Get the m_Data */
                        if (pObject->m_DataSize > 0)
                        {
                            pObject->m_Data = (uint8*)SYS_REALLOC(pObject->m_Data, pObject->m_DataSize);
                            if(pObject->m_Data != NULL)
                            {
                                for(index = 0; index < pObject->m_DataSize/sizeof(uint8); index++)
                                {
                                    pObject->m_Data[index] = ReadInt8(&pTemp);
                                }
                                ElementsUsed = ElementsUsed - pObject->m_DataSize;
                            }
                        }
                    }

                    bResult = TRUE;
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CErrEStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Writes the object into an XML file pointed to by the fhnd. Returns the number of
Bytes written into the file.
*********************************************************************************/
uint32 CErrEStd_serialize_to_XMLbuf(CErrEStd *pObject, char *pBuf)
{
    char Buffer[4096];
    char *Output = Buffer;
    uint32 NewSize   = 0;
    uint32 FinalSize = 0;
    uint32 ZeroSize  = 0;
    uint32 *pSizeCount = &ZeroSize;
    uint32 index = 0;
    if(pObject == NULL)
        return FinalSize;

    /* If pBuf is NULL, then we don't write anything to it, and just 
    return the potential size */
    if(pBuf != NULL)
    {
        Output = pBuf;
        pSizeCount = &NewSize;
    }

    NewSize = sprintf(Output,
            /*XML formatted Output to file*/
            "<DEFINITION class=\"CErrEStd\" version=\"%d\" "
                        "family=\"%d\" genus=\"%d\" species=\"%d\">\n",
            /*---------------------------------------------------------------*/
            /*Data for the related types above.
            uint16 representation Version*/
            CERR_OBJECT_VERSION,
            dt_family(pObject->ClassID),
            dt_genus(pObject->ClassID),
            dt_species(pObject->ClassID));

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            /*---------------------------------------------------------------*/
            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"ErrClassID\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", pObject->m_ErrClassID);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint16\" name=\"ErrorCode\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", pObject->m_ErrorCode);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- ansichar pointer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"ansichar\" size=\"20\" name=\"Description\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(pObject->m_Description[0] != 0)
            {
                NewSize = sprintf(Output, "%s", pObject->m_Description);
                FinalSize += NewSize;
                Output += *pSizeCount;
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Pointer to Data Buffer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" size=\"UNBOUNDED\" name=\"Data\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(pObject->m_Data != NULL)
            {
                for(index = 0; index < pObject->m_DataSize/sizeof(uint8); index++)
                {
                    NewSize = sprintf(Output, "%u;", pObject->m_Data[index]); 
                    FinalSize += NewSize;
                    Output += *pSizeCount;
                }
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Write the closing members tag*/
            NewSize = sprintf(Output, "</MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*---------------------------------------------------------------*/

            /*Write the closing definition tag*/
            NewSize = sprintf(Output, "</DEFINITION>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

    return FinalSize+1;
}
#endif  /* #if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) */
#if defined(CERRESTD_TEST_MAIN)
/*Global Declarations*/
CErrEStd MyObjectSrc;
CErrEStd MyObjectDest;

/*Function Prototypes*/
boolean Serialize_All_Test(void);
void SetObjectProperties(CErrEStd *MyObjectSrc);

int main(void)
{
    int   Result, TestID;  

    CErrEStd_Init(&MyObjectSrc);
    CErrEStd_Init(&MyObjectDest);

    SYS_PRINTF("1. Transfer complete byte stream: source object-->destination object.\n");
    SYS_PRINTF("Selection:");

    Result = scanf("%d", &TestID);

    SetObjectProperties(&MyObjectSrc);

    if(TestID == 1) Serialize_All_Test();
    else{
        SYS_PRINTF("\n\nInvalid Selection.\n\n");
    }

    SYS_PRINTF("\n\nPress any character key and hit enter to continue.\n");
    Result = scanf("%d", &TestID);

};
/*================================================================================
Helper function for setting default values for the test functions
================================================================================*/
void SetObjectProperties(CErrEStd *MyObjectSrc)
{
    TOUCH(MyObjectSrc);
}
/*================================================================================
Helper function for writing a byte Stream to a file
================================================================================*/
void WriteToFile(char *Buf, uint32 Size, char *Filename)
{
    FILE    *Fp;
    size_t  Bytes;

    if((Fp  = fopen(Filename, "w+b")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", Filename);
    }

    Bytes = fwrite(Buf, 1, Size, Fp);

    if(Bytes != Size)
    {
        SYS_PRINTF("Error: %d out of %d written to file %s\n", Bytes, strlen(Buf), Filename);
    }
    else
    {
        SYS_PRINTF("%s created\n", Filename);
    }

    if(fclose(Fp))
    {
        SYS_PRINTF("The file %s was not closed\n", Filename);
    }
}
/*================================================================================
Helper function for comparing the two generated xml files.
================================================================================*/
void CompareFiles(char *File1, char *File2)
{
    fpos_t    Pos;
    size_t    SrcLen;
    size_t    DestLen;
    FILE      *Fp1, *Fp2;
    char      *SrcBuf = NULL;
    char      *DestBuf = NULL;
    uint32    i = 0;

    if((Fp1  = fopen(File1, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File1);
    }

    if((Fp2  = fopen(File2, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File2);
    }

    /*Get the current position of the file Stream*/
    fgetpos(Fp1, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp1, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    SrcLen = (size_t)(ftell(Fp1) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp1, &Pos);

    SrcBuf = (char*)SYS_REALLOC(SrcBuf, SrcLen);

    SrcLen = fread(SrcBuf, 1, SrcLen, Fp1);

    /*Get the current position of the file Stream*/
    fgetpos(Fp2, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp2, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    DestLen = (size_t)(ftell(Fp2) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp2, &Pos);

    DestBuf = (char*)SYS_REALLOC(DestBuf, DestLen);
    DestLen = fread(DestBuf, 1, DestLen, Fp2);

    if(DestLen == SrcLen)
    {
        for(i=0; i< DestLen; i++)
        {
            if(DestBuf[i] != SrcBuf[i])
            {
                SYS_PRINTF("File mismatch at i=%d\n", i);
                break;
            }
        }
        if(i == DestLen)
            SYS_PRINTF("%s and %s comparison - PASSED!!!\n", File1, File2);
    }
    else
    {
        SYS_PRINTF("Error - File size mismatch\n");
    }

    if(fclose(Fp1))
    {
        SYS_PRINTF("The file %s was not closed\n",File2);
    }
    if(fclose(Fp2))
    {
        SYS_PRINTF("The file %s was not closed\n", File2);
    }

    SYS_FREE(SrcBuf);
    SYS_FREE(DestBuf);
}
/*================================================================================
Serialize_All_Test
================================================================================*/
boolean Serialize_All_Test(void)
{
    boolean   Result = FALSE;
    uint8     *ByteBuffer = NULL;
    char      *XMLBuffer = NULL;
    uint32    BufferSize;
    fpos_t    Pos;
    FILE      *Stream = NULL;

#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE)
     if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = CErrEStd_serialize_to_XMLbuf(&MyObjectSrc, NULL);

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = CErrEStd_serialize_to_XMLbuf(&MyObjectSrc, XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    fclose(Stream);
#endif

    /*Size of Object*/
    BufferSize = CErrEStd_SizeAll(&MyObjectSrc);

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_MALLOC(BufferSize);
    if(ByteBuffer)
    {
        /*Serialize MyObjectSrc*/
        CErrEStd_Serialize(&MyObjectSrc, ByteBuffer);

        /*Write the serialized ByteBuffer into the Serialize_AllSrc.bytestream file*/
        WriteToFile((char*)ByteBuffer, BufferSize, "Serialize_AllSrc.bytestream");

        /*Open Src file*/
        if((Stream  = fopen("Serialize_AllSrc.bytestream", "rb+")) == NULL) 
        {
            SYS_PRINTF("The file Serialize_AllSrc.bytestream was not opened\n");
        }

        /*Get the current position of the file Stream*/
        fgetpos(Stream, &Pos);

        /*Set the file position to the end of the file*/
        fseek(Stream, 0l, SEEK_END);

        /*Get the size by subtracting the end of file - initial position.*/
        BufferSize = (uint32)(size_t)(ftell(Stream) - Pos);

        /*Set the current position back to the original*/
        fsetpos(Stream, &Pos);

        if(BufferSize)
        {
            ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
            if(ByteBuffer != NULL)
            {
                /*Return the bytes read in the file Stream to ByteBuffer*/
                fread(ByteBuffer, 1, BufferSize, Stream);

                /*Deserialize the ByteBuffer into MyObjectDest*/
                BufferSize = CErrEStd_Deserialize(&MyObjectDest, (uint8*)ByteBuffer);
            }
        }
        
        if(fclose(Stream))
        {
            SYS_PRINTF("The file Serialize_AllSrc.bytestream was not closed\n");
        }

#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE)
        if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
        {
            SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
        }

        /*Get the size of MyObjectDest in an XML stream*/
        BufferSize = CErrEStd_serialize_to_XMLbuf(&MyObjectDest, NULL);

        /*Print start tag of XML stream*/
        fprintf(Stream, "<CMOIBObj>\n");

        if(BufferSize)
        {
            XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
            if(XMLBuffer != NULL)
            {
                /*Serialize MyObjectDest in an XML stream to the XMLBuffer*/
                BufferSize = CErrEStd_serialize_to_XMLbuf(&MyObjectDest, XMLBuffer);

                /*Print the XML Stream to file*/
                fprintf(Stream, XMLBuffer);
            }
        }

        /*Print the end tag of the XML stream*/
        fprintf(Stream, "</CMOIBObj>");

        if(fclose(Stream))
        {
            SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
        }
#endif

        BufferSize = CErrEStd_SizeAll(&MyObjectDest);
        ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
        if(ByteBuffer)
            CErrEStd_Serialize(&MyObjectDest, (uint8*)ByteBuffer);

        /*Write the serialized ByteBuffer into the Serialize_AllDest.bytestream file*/
        WriteToFile((char*)ByteBuffer, BufferSize, "Serialize_AllDest.bytestream");

        /*compare src and dest files*/
        CompareFiles("Serialize_AllSrc.bytestream", "Serialize_AllDest.bytestream");
#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) 
        CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");
#endif
    }

    SYS_FREE(ByteBuffer);
    SYS_FREE(XMLBuffer);

    return((boolean)Result);
}
#endif

/* ---------------------------End of DataClass CErrEStd -------------------------------- */

