/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrEStd.h                                                        //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.5.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_SIM.xml version 0.1
'*-E************************************************************************/

#if !defined(CERRESTD_H)
    #define  CERRESTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    /* AppInternal Errors */
    typedef enum CERRtypAPPERROR {
        CERR_APP_TEST1, 
        CERR_APP_TEST2, 
        CERR_APP_TEST3, 
        CERR_APP_MAX
    } CERR_APPLIST;

    /* WACP Stack Errors */
    typedef enum CERRtypSTACKERROR {
        CERR_NONE = 0,
        CERR_INVL_FAMILY,
        CERR_INVL_GENUS,
        CERR_INVL_SPECIES,
        CERR_OBJECT_ID,
        CERR_CRC_MISMATCH,  
        CERR_INVL_TBL_ENTRY,
        CERR_DUP_ENTRY,
        CERR_MAX
    } CERR_STACKLIST;

    /* WACP Message Processing Errors */
    typedef enum CERRtypPROCERROR {
        CERR_PROC_NONE = 0,
        CERR_PROC_UNIMPL,
        CERR_PROC_UNSUPPORTED,
        CERR_PROC_MEMORY,
        CERR_PROC_NO_PARAM,
        CERR_PROC_INVL_PARAM,
        CERR_PROC_INVL_PARAM_RANGE,
        CERR_PROC_NO_OBJECT,
        CERR_PROC_OBJECT_DESERIALIZE,
        CERR_PROC_OBJECT_SERIALIZE,
        CERR_PROC_CONTEXT,
        CERR_PROC_ITEM_NOT_AVAILABLE,
        CERR_PROC_MAX
    } CERR_PROCLIST;

    typedef  enum CERRtypSPECIES {
        CERR_SpERRNONE = 0, 
        CERR_SpERRWACPSTACK, 
        CERR_SpERRMSGPROC, 
        CERR_SpERRAPPINTERNAL, 
        CERR_SpMAX
    } CERR_SPECIES;

/* Global references */
extern const char * const CErrEStd_TypStackErrorTbl[CERR_MAX];
extern const char * const CErrEStd_TypProcErrorTbl[CERR_PROC_MAX];
extern const char * const CErrEStd_TypAppErrorTbl[CERR_APP_MAX];

    /*CErrEStd Member's Version Enumerations*/
    typedef  enum CERRtypVERSIONS {
        CERR_ErrClassID,
        CERR_ErrorCode,
        CERR_Description,
        CERR_Data,
        CERR_MEMBER_MAX
    } CERR_VERSIONS;


/*The following definition is the version.*/
#define CERR_OBJECT_VERSION 200

#define CERR_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CERR_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 20 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CErrEStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_ErrClassID; /* ClassID of message or object that generated the error */
    uint16             m_ErrorCode; /* Error code from message */
    ansichar           m_Description[20]; /* Error code description */

    /*Dynamic Data*/
    uint8              *m_Data; /*Can contain any data for a received process.*/
    uint16    m_DataSize;

}CErrEStd;

void    CErrEStd_Init(CErrEStd *pObject);
void    CErrEStd_Reset(CErrEStd *pObject, boolean bResetAll, boolean bInit);
uint32  CErrEStd_SizeAll(const CErrEStd *pObject);
boolean CErrEStd_Deserialize(CErrEStd *pObject, uint8 *pBuf);
boolean CErrEStd_Serialize(const CErrEStd *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CErrEStd_serialize_to_XMLbuf(CErrEStd *pObject, char* pBuf);
#endif

#endif /* #if !defined(CERRESTD_H) */

