/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CModuleDStd.h                                                     //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CMODULEDSTD_H)
    #define  CMODULEDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CMODDSTDtypSPECIES {
        CMODDSTD_SpSTANDARD = 0, 
        CMODDSTD_SpHOST, /*The hosting subsystem (i.e Spot LXi or PVSM).*/
        CMODDSTD_SpHARDWARE, 
        CMODDSTD_SpBOOTLOADER, 
        CMODDSTD_SpBOOTRECOVERY, 
        CMODDSTD_SpNIBPMODULE = 16, /*The NIBP module (i.e MODPG)*/
        CMODDSTD_SpNIBPSAFETYALG, 
        CMODDSTD_SpNIBPSTEPALG, 
        CMODDSTD_SpNIBPFASTALG, 
        CMODDSTD_SpNIBPNEONATSTEPALG, 
        CMODDSTD_SpNIBPPOEMALG, 
        CMODDSTD_SpNIBPSTEPAOALG, 
        CMODDSTD_SpTEMPMODULE = 32, /*The Temperature module*/
        CMODDSTD_SpSURETEMPALG, 
        CMODDSTD_SpSPO2MODULE = 40, /*The SPO2 module (i.e SureTemp)*/
        CMODDSTD_SpECGMODULE = 48, /*The ECG module*/
        CMODDSTD_SpMEANS, 
        CMODDSTD_SpSPIROMETRY = 56, /*The Spirometry module*/
        CMODDSTD_SpFRONTEND = 192, 
        CMODDSTD_SpPPP, /*Printer and peripheral processor*/
        CMODDSTD_SpSECUREDIGITALCARD, 
        CMODDSTD_SpALL = 255, /*Indicates that all species are represented. Used solely for the species selector in the CModulePSelector object to request all Modules from the device.*/
        CMODDSTD_SpMAX
    } CMODDSTD_SPECIES;

    /*CModuleDStd Member's Version Enumerations*/
    typedef  enum CMODDSTDtypVERSIONS {
        CMODDSTD_Version,
        CMODDSTD_Description,
        CMODDSTD_MEMBER_MAX
    } CMODDSTD_VERSIONS;


/*The following definition is the version.*/
#define CMODDSTD_OBJECT_VERSION 101

#define CMODDSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CMODDSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 48 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CModuleDStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    ansichar           m_Version[16];
    ansichar           m_Description[32];

}CModuleDStd;

void    CModuleDStd_Init(CModuleDStd *pObject);
void    CModuleDStd_Reset(CModuleDStd *pObject, boolean bResetAll, boolean bInit);
uint32  CModuleDStd_SizeAll(const CModuleDStd *pObject);
boolean CModuleDStd_Deserialize(CModuleDStd *pObject, uint8 *pBuf);
boolean CModuleDStd_Serialize(const CModuleDStd *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CModuleDStd_serialize_to_XMLbuf(CModuleDStd *pObject, char* pBuf);
#endif

#endif /* #if !defined(CMODULEDSTD_H) */

