/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CNumDStd.h                                                        //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CNUMDSTD_H)
    #define  CNUMDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CNUMDSTDtypSTATUSBITS {
        CNUMDSTD_StatusBits_ValidRange = 0, /*sensor specified.*/
        CNUMDSTD_StatusBits_OverRange = 1, /*+++, sensor specified.*/
        CNUMDSTD_StatusBits_UnderRange = 2, /*---, sensor specified.*/
        CNUMDSTD_StatusBits_UndeterminedRange = 3, /*???, sensor specified.*/
        CNUMDSTD_StatusBits_RangeMask = 1027, /*Bit map mask*/
        CNUMDSTD_StatusBits_NoAlarm = 1024, 
        CNUMDSTD_StatusBits_UpperLimitAlarm = 4, 
        CNUMDSTD_StatusBits_LowerLimitAlarm = 8, 
        CNUMDSTD_StatusBits_OtherAlarm = 12, 
        CNUMDSTD_StatusBits_AlarmTypeMask = 1036, /*Bit map mask*/
        CNUMDSTD_StatusBits_NumericActive = 16, 
        CNUMDSTD_StatusBits_Continuous = 2048, 
        CNUMDSTD_StatusBits_SpotOld = 32, 
        CNUMDSTD_StatusBits_SpotRecent = 64, 
        CNUMDSTD_StatusBits_SpotNew = 128, 
        CNUMDSTD_StatusBits_SpotMask = 224, /*Bit map mask*/
        CNUMDSTD_StatusBits_Dubious = 256, /*Sensor specified.*/
        CNUMDSTD_StatusBits_MAX
    } CNUMDSTD_STATUSBITS;

    typedef  enum CNUMDSTDtypSPECIES {
        CNUMDSTD_SpSTANDARD = 0, 
        CNUMDSTD_SpECGHR, 
        CNUMDSTD_SpHRPR, 
        CNUMDSTD_SpNIBPSYS, 
        CNUMDSTD_SpNIBPDIA, 
        CNUMDSTD_SpNIBPMAP, 
        CNUMDSTD_SpNIBPPR, 
        CNUMDSTD_SpIBP1SYS, 
        CNUMDSTD_SpIBP1DIA, 
        CNUMDSTD_SpIBP1MAP, 
        CNUMDSTD_SpIBP1PR, 
        CNUMDSTD_SpIBP2SYS, 
        CNUMDSTD_SpIBP2DIA, 
        CNUMDSTD_SpIBP2MAP, 
        CNUMDSTD_SpIBP2PR, 
        CNUMDSTD_SpIBP3SYS, 
        CNUMDSTD_SpIBP3DIA, 
        CNUMDSTD_SpIBP3MAP, 
        CNUMDSTD_SpIBP3PR, 
        CNUMDSTD_SpSPO2PR, 
        CNUMDSTD_SpSPO2SAT, 
        CNUMDSTD_SpSPO2PI, 
        CNUMDSTD_SpRESPRATE, 
        CNUMDSTD_SpRRBR, 
        CNUMDSTD_SpCO2ENDT, 
        CNUMDSTD_SpCO2INSP, 
        CNUMDSTD_SpCO2BR, 
        CNUMDSTD_SpTEMP1, 
        CNUMDSTD_SpTEMP2, 
        CNUMDSTD_SpDELTAT, 
        CNUMDSTD_SpALL, 
        CNUMDSTD_SpMAX
    } CNUMDSTD_SPECIES;

    /*CNumDStd Member's Version Enumerations*/
    typedef  enum CNUMDSTDtypVERSIONS {
        CNUMDSTD_Value,
        CNUMDSTD_StatusBits,
        CNUMDSTD_MEMBER_MAX
    } CNUMDSTD_VERSIONS;


/*The following definition is the version.*/
#define CNUMDSTD_OBJECT_VERSION 200

#define CNUMDSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CNUMDSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 1 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CNumDStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    int16              m_Value; /* numeric value */
    uint16             m_StatusBits; /* see enumerator */

}CNumDStd;

void    CNumDStd_Init(CNumDStd *pObject);
void    CNumDStd_Reset(CNumDStd *pObject, boolean bResetAll, boolean bInit);
uint32  CNumDStd_SizeAll(const CNumDStd *pObject);
boolean CNumDStd_Deserialize(CNumDStd *pObject, uint8 *pBuf);
boolean CNumDStd_Serialize(const CNumDStd *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CNumDStd_serialize_to_XMLbuf(CNumDStd *pObject, char* pBuf);
#endif

#endif /* #if !defined(CNUMDSTD_H) */

