/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDCO2.c                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#include "CRespDCO2.h"

#define CRSPDCO2_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CRespDCO2_TypVersionsTbl, \
                      CRSPDCO2_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CRespDCO2_TypVersionsTbl[CRSPDCO2_MEMBER_MAX] = {
    200, 200, /*CRESPDCO2_SequenceNumber*/
    200, 200, /*CRESPDCO2_Status*/
    200, 200, /*CRESPDCO2_CO2*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CRespDCO2_Init(CRespDCO2 *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CRespDCO2));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmRESPIRATION, GnDATA, CRSPDCO2_SpCO2);

        /*Initialize sub-objects*/
        CNumDStd_Init(&pObject->CO2);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CRespDCO2_Reset(CRespDCO2 *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Objects to only free allocated memory*/
        if(bResetAll)
        {
            CNumDStd_Reset(&pObject->CO2, TRUE, FALSE);
        }

        /*Initialize the Object*/
        if(bInit)
        {
            CRespDCO2_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CRespDCO2_SizeAll(const CRespDCO2 *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CRSPDCO2_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint32) + CNumDStd_SizeAll(&pObject->CO2);

        Size += sizeof(uint16);            /* CRC bytes */

        return CRSPDCO2_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CRespDCO2 object into the buffer passed in.
*********************************************************************************/
boolean CRespDCO2_Serialize(const CRespDCO2 *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        uint32 ObjectSize;
        uint8  *Buffer = NULL;
        uint32 PayloadSize = CRespDCO2_SizeAll(pObject) - CRSPDCO2_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CRSPDCO2_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CRSPDCO2_STATIC_DATA_SIZE);

        /* Set the m_SequenceNumber */
        WriteInt16(&pTemp, pObject->m_SequenceNumber);

        /* Set the m_Status */
        WriteInt8(&pTemp, pObject->m_Status);

        /*Serialize CO2*/
        ObjectSize = CNumDStd_SizeAll(&pObject->CO2);
        WriteInt32(&pTemp, ObjectSize);
        if(ObjectSize > 0)
        {
            Buffer = (uint8*)SYS_REALLOC(Buffer, ObjectSize);
        }
        if(Buffer != NULL)
        {
            CNumDStd_Serialize(&pObject->CO2, Buffer);
            memcpy(pTemp, Buffer, ObjectSize);
            pTemp += ObjectSize;
        }

        SYS_FREE(Buffer);
        Buffer = NULL;

        /* Set the CRC */
        CRCSize = CRespDCO2_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CRespDCO2 object passed in.
*********************************************************************************/
boolean CRespDCO2_Deserialize(CRespDCO2 *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint16  Version;
        uint16  StructSize;
        uint32  ElementsUsed;
        uint32  ObjectSize;
        uint8   *Buffer = NULL;
        uint16  StoredCRC;
        uint16  CalcCRC;
        uint32  CRCSize;
        uint32  ClassID;

        /* Calculate the CRC */
        CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
        CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

        /* Get the stored CRC */
        StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

        /* Check the CRC */
        if (CalcCRC == StoredCRC)
        {
            /* Verify the Family and Genus match */
            ClassID = ReadInt32(&pTemp);
            if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
            {
                /* Set the ClassID to update the species */
                pObject->ClassID = ClassID;

                /* Get the size of the payload */
                if(IsExtended_ClassID(pObject->ClassID))
                    ElementsUsed = ReadInt32(&pTemp);
                else
                    ElementsUsed = ReadInt16(&pTemp);

                /* Get the Version */
                Version = ReadInt16(&pTemp);
                ElementsUsed -= sizeof(uint16);

                if(Version <= CRSPDCO2_OBJECT_VERSION)
                {
                    /* Store the dequeued version */
                    pObject->SrcVersion = Version;

                    /* Get the DataBitField */
                    SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                    ElementsUsed -= sizeof(uint8);

                    /* Get the size of the static structure */
                    StructSize = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if((StructSize) &&
                       (CRSPDCO2_VERSION_STATUS(CRSPDCO2_SequenceNumber, pObject->SrcVersion)))
                    {
                        /* Get the m_SequenceNumber */
                        pObject->m_SequenceNumber = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);
                        StructSize -= sizeof(uint16);
                    }
                    if((StructSize) &&
                       (CRSPDCO2_VERSION_STATUS(CRSPDCO2_Status, pObject->SrcVersion)))
                    {
                        /* Get the m_Status */
                        pObject->m_Status = ReadInt8(&pTemp);
                        ElementsUsed -= sizeof(uint8);
                        StructSize -= sizeof(uint8);
                    }
                    if(StructSize)
                    {
                        /* Dequeue the remaining extra bytes of the static struct */
                        pTemp += StructSize;
                        ElementsUsed = ElementsUsed - StructSize;
                    }

                    if((ElementsUsed > 2) &&
                       (CRSPDCO2_VERSION_STATUS(CRSPDCO2_CO2, pObject->SrcVersion)))
                    {
                        /*Dequeue the CO2 object*/
                        ObjectSize = ReadInt32(&pTemp);
                        ElementsUsed -= sizeof(uint32);

                        if(ObjectSize > 0)
                        {
                            Buffer = (uint8*)SYS_REALLOC(Buffer, ObjectSize);
                            if(Buffer != NULL)
                            {
                                memcpy(Buffer, pTemp, ObjectSize);
                                CNumDStd_Deserialize(&pObject->CO2, Buffer);
                                pTemp += ObjectSize;
                                ElementsUsed -= ObjectSize;
                            }
                        }
                    }

                    SYS_FREE(Buffer);

                    bResult = TRUE;
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CRespDCO2_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Writes the object into an XML file pointed to by the fhnd. Returns the number of
Bytes written into the file.
*********************************************************************************/
uint32 CRespDCO2_serialize_to_XMLbuf(CRespDCO2 *pObject, char *pBuf)
{
    char Buffer[4096];
    char *Output = Buffer;
    uint32 NewSize   = 0;
    uint32 FinalSize = 0;
    uint32 ZeroSize  = 0;
    uint32 *pSizeCount = &ZeroSize;
    /* Aggregate only */
    char    *pTempBuf = NULL;
    if(pObject == NULL)
        return FinalSize;

    /* If pBuf is NULL, then we don't write anything to it, and just 
    return the potential size */
    if(pBuf != NULL)
    {
        Output = pBuf;
        pSizeCount = &NewSize;
    }

    NewSize = sprintf(Output,
            /*XML formatted Output to file*/
            "<DEFINITION class=\"CRespDCO2\" version=\"%d\" "
                        "family=\"%d\" genus=\"%d\" species=\"%d\">\n",
            /*---------------------------------------------------------------*/
            /*Data for the related types above.
            uint16 representation Version*/
            CRSPDCO2_OBJECT_VERSION,
            dt_family(pObject->ClassID),
            dt_genus(pObject->ClassID),
            dt_species(pObject->ClassID));

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            /*---------------------------------------------------------------*/
            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint16\" name=\"SequenceNumber\" minversion=\"200\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", pObject->m_SequenceNumber);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" name=\"Status\" minversion=\"200\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", pObject->m_Status);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Serialize the CO2 object*/
            NewSize = sprintf(Output, "<MEMBER type=\"OBJECT\" class=\"CNumDStd\" name=\"CO2\" minversion=\"200\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Subtract 1 from the total XML stream size to ignore
            the NULL terminator from the sub-object's XML size.*/
            NewSize = CNumDStd_serialize_to_XMLbuf(&pObject->CO2, NULL) - 1;
            if(pBuf)
            {
                if(NewSize)
                {
                    /*Add 1 to the size to compensate the null terminator
                    that will be output by the sub-object's serialize_to_XMLbuf()*/
                    if(pTempBuf == NULL)
                    {
                        pTempBuf = (char*)SYS_MALLOC(NewSize + 1);
                    }
                    else
                    {
                        pTempBuf = (char*)SYS_REALLOC(pTempBuf, NewSize + 1);
                    }
                    if(pTempBuf != NULL)
                    {
                        NewSize = CNumDStd_serialize_to_XMLbuf(&pObject->CO2, pTempBuf);

                        /*Copy pTempBuf to the XML stream without the
                        NULL terminator*/
                        memcpy(Output, pTempBuf, --NewSize);
                    }
                }
            }

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            SYS_FREE(pTempBuf);

            /*Write the closing members tag*/
            NewSize = sprintf(Output, "</MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*---------------------------------------------------------------*/

            /*Write the closing definition tag*/
            NewSize = sprintf(Output, "</DEFINITION>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

    return FinalSize+1;
}
#endif  /* #if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) */
#if defined(CRESPDCO2_TEST_MAIN)
/*Global Declarations*/
CRespDCO2 MyObjectSrc;
CRespDCO2 MyObjectDest;

/*Function Prototypes*/
boolean Serialize_All_Test(void);
void SetObjectProperties(CRespDCO2 *MyObjectSrc);

int main(void)
{
    int   Result, TestID;  

    CRespDCO2_Init(&MyObjectSrc);
    CRespDCO2_Init(&MyObjectDest);

    SYS_PRINTF("1. Transfer complete byte stream: source object-->destination object.\n");
    SYS_PRINTF("Selection:");

    Result = scanf("%d", &TestID);

    SetObjectProperties(&MyObjectSrc);

    if(TestID == 1) Serialize_All_Test();
    else{
        SYS_PRINTF("\n\nInvalid Selection.\n\n");
    }

    SYS_PRINTF("\n\nPress any character key and hit enter to continue.\n");
    Result = scanf("%d", &TestID);

};
/*================================================================================
Helper function for setting default values for the test functions
================================================================================*/
void SetObjectProperties(CRespDCO2 *MyObjectSrc)
{
    TOUCH(MyObjectSrc);
}
/*================================================================================
Helper function for writing a byte Stream to a file
================================================================================*/
void WriteToFile(char *Buf, uint32 Size, char *Filename)
{
    FILE    *Fp;
    size_t  Bytes;

    if((Fp  = fopen(Filename, "w+b")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", Filename);
    }

    Bytes = fwrite(Buf, 1, Size, Fp);

    if(Bytes != Size)
    {
        SYS_PRINTF("Error: %d out of %d written to file %s\n", Bytes, strlen(Buf), Filename);
    }
    else
    {
        SYS_PRINTF("%s created\n", Filename);
    }

    if(fclose(Fp))
    {
        SYS_PRINTF("The file %s was not closed\n", Filename);
    }
}
/*================================================================================
Helper function for comparing the two generated xml files.
================================================================================*/
void CompareFiles(char *File1, char *File2)
{
    fpos_t    Pos;
    size_t    SrcLen;
    size_t    DestLen;
    FILE      *Fp1, *Fp2;
    char      *SrcBuf = NULL;
    char      *DestBuf = NULL;
    uint32    i = 0;

    if((Fp1  = fopen(File1, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File1);
    }

    if((Fp2  = fopen(File2, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File2);
    }

    /*Get the current position of the file Stream*/
    fgetpos(Fp1, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp1, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    SrcLen = (size_t)(ftell(Fp1) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp1, &Pos);

    SrcBuf = (char*)SYS_REALLOC(SrcBuf, SrcLen);

    SrcLen = fread(SrcBuf, 1, SrcLen, Fp1);

    /*Get the current position of the file Stream*/
    fgetpos(Fp2, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp2, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    DestLen = (size_t)(ftell(Fp2) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp2, &Pos);

    DestBuf = (char*)SYS_REALLOC(DestBuf, DestLen);
    DestLen = fread(DestBuf, 1, DestLen, Fp2);

    if(DestLen == SrcLen)
    {
        for(i=0; i< DestLen; i++)
        {
            if(DestBuf[i] != SrcBuf[i])
            {
                SYS_PRINTF("File mismatch at i=%d\n", i);
                break;
            }
        }
        if(i == DestLen)
            SYS_PRINTF("%s and %s comparison - PASSED!!!\n", File1, File2);
    }
    else
    {
        SYS_PRINTF("Error - File size mismatch\n");
    }

    if(fclose(Fp1))
    {
        SYS_PRINTF("The file %s was not closed\n",File2);
    }
    if(fclose(Fp2))
    {
        SYS_PRINTF("The file %s was not closed\n", File2);
    }

    SYS_FREE(SrcBuf);
    SYS_FREE(DestBuf);
}
/*================================================================================
Serialize_All_Test
================================================================================*/
boolean Serialize_All_Test(void)
{
    boolean   Result = FALSE;
    uint8     *ByteBuffer = NULL;
    char      *XMLBuffer = NULL;
    uint32    BufferSize;
    fpos_t    Pos;
    FILE      *Stream = NULL;

#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE)
     if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = CRespDCO2_serialize_to_XMLbuf(&MyObjectSrc, NULL);

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = CRespDCO2_serialize_to_XMLbuf(&MyObjectSrc, XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    fclose(Stream);
#endif

    /*Size of Object*/
    BufferSize = CRespDCO2_SizeAll(&MyObjectSrc);

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_MALLOC(BufferSize);
    if(ByteBuffer)
    {
        /*Serialize MyObjectSrc*/
        CRespDCO2_Serialize(&MyObjectSrc, ByteBuffer);

        /*Write the serialized ByteBuffer into the Serialize_AllSrc.bytestream file*/
        WriteToFile((char*)ByteBuffer, BufferSize, "Serialize_AllSrc.bytestream");

        /*Open Src file*/
        if((Stream  = fopen("Serialize_AllSrc.bytestream", "rb+")) == NULL) 
        {
            SYS_PRINTF("The file Serialize_AllSrc.bytestream was not opened\n");
        }

        /*Get the current position of the file Stream*/
        fgetpos(Stream, &Pos);

        /*Set the file position to the end of the file*/
        fseek(Stream, 0l, SEEK_END);

        /*Get the size by subtracting the end of file - initial position.*/
        BufferSize = (uint32)(size_t)(ftell(Stream) - Pos);

        /*Set the current position back to the original*/
        fsetpos(Stream, &Pos);

        if(BufferSize)
        {
            ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
            if(ByteBuffer != NULL)
            {
                /*Return the bytes read in the file Stream to ByteBuffer*/
                fread(ByteBuffer, 1, BufferSize, Stream);

                /*Deserialize the ByteBuffer into MyObjectDest*/
                BufferSize = CRespDCO2_Deserialize(&MyObjectDest, (uint8*)ByteBuffer);
            }
        }
        
        if(fclose(Stream))
        {
            SYS_PRINTF("The file Serialize_AllSrc.bytestream was not closed\n");
        }

#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE)
        if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
        {
            SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
        }

        /*Get the size of MyObjectDest in an XML stream*/
        BufferSize = CRespDCO2_serialize_to_XMLbuf(&MyObjectDest, NULL);

        /*Print start tag of XML stream*/
        fprintf(Stream, "<CMOIBObj>\n");

        if(BufferSize)
        {
            XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
            if(XMLBuffer != NULL)
            {
                /*Serialize MyObjectDest in an XML stream to the XMLBuffer*/
                BufferSize = CRespDCO2_serialize_to_XMLbuf(&MyObjectDest, XMLBuffer);

                /*Print the XML Stream to file*/
                fprintf(Stream, XMLBuffer);
            }
        }

        /*Print the end tag of the XML stream*/
        fprintf(Stream, "</CMOIBObj>");

        if(fclose(Stream))
        {
            SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
        }
#endif

        BufferSize = CRespDCO2_SizeAll(&MyObjectDest);
        ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
        if(ByteBuffer)
            CRespDCO2_Serialize(&MyObjectDest, (uint8*)ByteBuffer);

        /*Write the serialized ByteBuffer into the Serialize_AllDest.bytestream file*/
        WriteToFile((char*)ByteBuffer, BufferSize, "Serialize_AllDest.bytestream");

        /*compare src and dest files*/
        CompareFiles("Serialize_AllSrc.bytestream", "Serialize_AllDest.bytestream");
#if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) 
        CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");
#endif
    }

    SYS_FREE(ByteBuffer);
    SYS_FREE(XMLBuffer);

    return((boolean)Result);
}
#endif

/* ---------------------------End of DataClass CRespDCO2 -------------------------------- */

