/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDCO2.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPDCO2_H)
    #define  CRESPDCO2_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

#include "CNumDStd.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPDCO2typSTATUS {
        CRSPDCO2_Status_NONE = 0, /*None specified*/
        CRSPDCO2_Status_INVALID_VALUE = 1, /*Invalid CO2 Value*/
        CRSPDCO2_Status_INITIALIZATION = 2, /*Initialization*/
        CRSPDCO2_Status_OVER_RANGE = 3, /*CO2 value over range*/
        CRSPDCO2_Status_SFM_REQUEST = 4, /*SFM request*/
        CRSPDCO2_Status_SFM_IN_PROGRESS = 5, /*SFM in progress*/
        CRSPDCO2_Status_PURGING_IN_PROGRESS = 6, /*Purging in progress*/
        CRSPDCO2_Status_FILTER_LINE_NO_CONNECT = 7, /*FilterLine not connected*/
        CRSPDCO2_Status_FAULT_BIT = 8, /*Fault Bit. Check Service codes*/
        CRSPDCO2_Status_MAX
    } CRSPDCO2_STATUS;

    typedef  enum CRSPDCO2typSPECIES {
        CRSPDCO2_SpCO2 = 4, /*Default Species.*/
        CRSPDCO2_SpMAX
    } CRSPDCO2_SPECIES;

    /*CRespDCO2 Member's Version Enumerations*/
    typedef  enum CRSPDCO2typVERSIONS {
        CRSPDCO2_SequenceNumber,
        CRSPDCO2_Status,
        CRSPDCO2_CO2,
        CRSPDCO2_MEMBER_MAX
    } CRSPDCO2_VERSIONS;


/*The following definition is the version.*/
#define CRSPDCO2_OBJECT_VERSION 200

#define CRSPDCO2_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CRSPDCO2_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 1 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CRespDCO2
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint16             m_SequenceNumber;
    uint8              m_Status;

    /*Object Instances*/
    CNumDStd           CO2;

}CRespDCO2;

void    CRespDCO2_Init(CRespDCO2 *pObject);
void    CRespDCO2_Reset(CRespDCO2 *pObject, boolean bResetAll, boolean bInit);
uint32  CRespDCO2_SizeAll(const CRespDCO2 *pObject);
boolean CRespDCO2_Deserialize(CRespDCO2 *pObject, uint8 *pBuf);
boolean CRespDCO2_Serialize(const CRespDCO2 *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CRespDCO2_serialize_to_XMLbuf(CRespDCO2 *pObject, char* pBuf);
#endif

#endif /* #if !defined(CRESPDCO2_H) */

