/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDData.h                                                      //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPDDATA_H)
    #define  CRESPDDATA_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

#include "CNumDStd.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPDDTAtypSPECIES {
        CRSPDDTA_SpDATA = 1, /*Default species.*/
        CRSPDDTA_SpMAX
    } CRSPDDTA_SPECIES;

    /*CRespDData Member's Version Enumerations*/
    typedef  enum CRSPDDTAtypVERSIONS {
        CRSPDDTA_EtCO2,
        CRSPDDTA_FiCO2,
        CRSPDDTA_RR,
        CRSPDDTA_MEMBER_MAX
    } CRSPDDTA_VERSIONS;


/*The following definition is the version.*/
#define CRSPDDTA_OBJECT_VERSION 200

#define CRSPDDTA_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CRSPDDTA_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CRespDData
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Object Instances*/
    CNumDStd           EtCO2; /*End Tidal CO2. In mmHg. (FF for invalid value, 100 for overrange. In case of extended CO2 range configuration, 151 for overrange.*/
    CNumDStd           FiCO2; /*Fraction of inspired CO2. In mmHg. (FF for invalid value, 100 for overrange. In case of extended CO2 range configuration, 151 for overrange.*/
    CNumDStd           RR; /*Respiration Rate per minute (FF for invalid value))*/

}CRespDData;

void    CRespDData_Init(CRespDData *pObject);
void    CRespDData_Reset(CRespDData *pObject, boolean bResetAll, boolean bInit);
uint32  CRespDData_SizeAll(const CRespDData *pObject);
boolean CRespDData_Deserialize(CRespDData *pObject, uint8 *pBuf);
boolean CRespDData_Serialize(const CRespDData *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CRespDData_serialize_to_XMLbuf(CRespDData *pObject, char* pBuf);
#endif

#endif /* #if !defined(CRESPDDATA_H) */

