/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDIPI.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPDIPI_H)
    #define  CRESPDIPI_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

#include "CNumDStd.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPDIPItypSPECIES {
        CRSPDIPI_SpPULMONARYINDEX = 2, /*Default species.*/
        CRSPDIPI_SpMAX
    } CRSPDIPI_SPECIES;

    /*CRespDIPI Member's Version Enumerations*/
    typedef  enum CRSPDIPItypVERSIONS {
        CRSPDIPI_PulmonaryIndex,
        CRSPDIPI_MEMBER_MAX
    } CRSPDIPI_VERSIONS;


/*The following definition is the version.*/
#define CRSPDIPI_OBJECT_VERSION 200

#define CRSPDIPI_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CRSPDIPI_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CRespDIPI
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Object Instances*/
    CNumDStd           PulmonaryIndex; /*Integrated pulmonary index. Valid range: 0-10, FF for invalid value*/

}CRespDIPI;

void    CRespDIPI_Init(CRespDIPI *pObject);
void    CRespDIPI_Reset(CRespDIPI *pObject, boolean bResetAll, boolean bInit);
uint32  CRespDIPI_SizeAll(const CRespDIPI *pObject);
boolean CRespDIPI_Deserialize(CRespDIPI *pObject, uint8 *pBuf);
boolean CRespDIPI_Serialize(const CRespDIPI *pObject, uint8 *pBuf);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
uint32  CRespDIPI_serialize_to_XMLbuf(CRespDIPI *pObject, char* pBuf);
#endif

#endif /* #if !defined(CRESPDIPI_H) */

