/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Dt.h                                                              //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** 
'*-E************************************************************************/

#if !defined(DT_H)
    #define  DT_H

/*********************************************************************************************
Helper Class Dt
This class provides some static methods to help manipulate DataClass identifiers and size.
These are implemented as methods instead of macros because methods are type safe and do not
suffer from many of the side-effects of macros.
*********************************************************************************************/

#include "StdVarTyp.h"

#if defined(__cplusplus)
extern "C" {
#endif


/*********************************************************************************
Creates a DataClass identifier from the family, genus and species.
*********************************************************************************/
extern uint32 dt_make_id(uint16 family, uint8 genus, uint8 species);
extern uint16 dt_family(const uint32 id);
extern uint8  dt_genus(const uint32 id);
extern uint8  dt_species(const uint32 id);

#if defined(__cplusplus)
}
#endif

#endif  /* #if !defined(DT_H) */

/*---------------------------------------------------*/
/* End of File */


