/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// DtData.c       :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#include "DtData.h"
#include "Mem.h"

#if defined(TRACE_SERVER_ON)
const char * const FmStringTable[FmMAX + 1] = 
{   
    "FmARCH",
    "FmECG",
    "FmIP",
    "FmTEMP",
    "FmSPO2",
    "FmNIBP",
    "FmICG",
    "FmHEMODYNAMICS",
    "FmCO2",
    "FmIBP",
    "FmCARDIACOUTPUT",
    "FmUI",
    "FmBARCODE",
    "FmCTR",
    "FmPATIENT",
    "FmUSER",
    "FmGLUCOSE",
    "FmBODYMASSINDEX",
    "FmRESPIRATION",
    "FmWEIGHT",
    "FmINSURANCE",
    "FmPHYSICIAN",
    "FmSITE",
    "FmSESSION",
    "FmDEVICE",
    "FmINTERPRETATION",
    "FmHEIGHT",
    "FmSPIRO",
    "FmTRAP",
    "FmRENDEZVOUS",
    "FmCONNECTION",
    "FmWAVESAMPLE",
    "FmWAVE",
    "FmDEV01", 
    "FmDEV02", 
    "FmDEV03", 
    "FmDEV04", 
    "FmDEV05", 
    "FmDEV06", 
    "FmDEV07", 
    "FmDEV08", 
    "FmDEV09", 
    "FmDEV10", 
    "FmDEV11", 
    "FmDEV12", 
    "FmDEV13", 
    "FmDEV14", 
    "FmDEV15", 
    "FmDEV16", 
    "FmDEV17", 
    "FmDEV18", 
    "FmDEV19", 
    "FmDEV20", 
    "FmDEV21", 
    "FmDEV22", 
    "FmDEV23", 
    "FmDEV24", 
    "FmDEV25", 
    "FmDEV26", 
    "FmDEV27", 
    "FmDEV28", 
    "FmDEV29", 
    "FmDEV30", 
    "FmDEV31", 
    "FmDEV32", 
    "FmDEV33", 
    "FmDEV34", 
    "FmDEV35", 
    "FmDEV36", 
    "FmDEV37", 
    "FmDEV38", 
    "FmDEV39", 
    "FmDEV40", 
    "FmDEV41", 
    "FmDEV42", 
    "FmDEV43", 
    "FmDEV44", 
    "FmDEV45", 
    "FmDEV46", 
    "FmDEV47", 
    "FmDEV48", 
    "FmDEV49", 
    "FmDEV50",
    "FmGLOBALMEASUREMENTS",
    "FmLEADIMPEDANCEARRAY",
    "FmLEADIMPEDANCE",
    "FmMEASUREMENTMATRIX",
    "FmLEADMEASUREMENT",
    "FmQRSANNOTARRAY",
    "FmQRSCOMPLEX",
    "FmPACERARRAY",
    "FmPACERINFO",
    "FmDTCOLLECTION",
    "FmWACP",
    "FmFLASH",
    "FmVERSION",
    "FmPRINTER",
    "FmRECORD",
    "FmTCPIP",
    "FmLOCATIONID",
    "FmPAIN",
    "FmCLINICIAN",
    "FmCALIBRATION",
    "FmPATIENTLIST",
    "FmFAX",
    "FmMODULE",
    "FmMODEM",
    "FmNETWORK",
    "FmTEST",
    "FmENCRYPTION",
    "FmTOC",
    "FmBATTERY",
    "FmFILESYS",
    "FmMOIBSTRING",
    "FmERROR",
    "FmCOMMAND_LINE",
    "FmDICTIONARY",
    "FmNUMERIC",
    "FmCHANNEL",
    "FmMAX"
};

const char * const GnStringTable[GnMAX + 1] = 
{   
    "GnDATA",
    "GnCOMMAND",
    "GnEVENT",
    "GnERROR",
    "GnRESERVE_A",
    "GnSTATUS",
    "GnNUMERIC",
    "GnRESERVE_B",
    "GnCONFIG",
    "GnRESERVE_C",
    "GnRESERVE_D",
    "GnREQUEST",
    "GnRESERVE_E",
    "GnRESERVE_F",
    "GnRESERVE_G",
    "GnRESPONSE",
    "GnPARAMETER",
    "GnSTREAM",
    "GnDATAEXT",
    "GnMAX"
};
#endif /* #if defined(TRACE_SERVER_ON) */

/*********************************************************************************
Creates a DataClass identifier from the family, genus and species.
*********************************************************************************/
uint32 MakeClassID(uint16 Family, uint8 Genus, uint8 Species)
{
    return (((uint32)Family << 16) | ((uint16)Genus << 8) | Species);
}

/*********************************************************************************
 Set function for data member species
*********************************************************************************/
void SetFamily(uint32 *ClassID, uint16 new_Family)
{
    *ClassID = ((*ClassID & 0x0000FFFF) | (new_Family << 16));
}

/*********************************************************************************
Returns the family sub-code from an input identifier.
*********************************************************************************/
uint16 GetFamily (const uint8 *pBuf)
{
#if (MEDIA_ENDIANNES == BIG_ENDIAN)
    return (((uint16)pBuf[0]) << 8 | pBuf[1]);
#else
    return (((uint16)pBuf[3]) << 8 | pBuf[2]);
#endif   
}

/*********************************************************************************
 Set function for data member species
*********************************************************************************/
void SetGenus(uint32 *ClassID, uint8 new_Genus)
{
    *ClassID = ((*ClassID & 0xFFFF00FF) | (new_Genus << 8));
}

/*********************************************************************************
Returns the genus sub-code from an input DataClass identifier.
*********************************************************************************/
uint8 GetGenus(const uint8 *pBuf)
{
#if (MEDIA_ENDIANNES == BIG_ENDIAN)
    return (pBuf[2]);
#else
    return (pBuf[1]);
#endif   
}

/*********************************************************************************
 Set function for data member species
*********************************************************************************/
void SetSpecies(uint32 *ClassID, uint8 new_Species)
{
   *ClassID = ((*ClassID & 0xFFFFFF00) | new_Species);
}
/*********************************************************************************
Returns the species sub-code from the input class identifier.
*********************************************************************************/
uint8 GetSpecies(const uint8 *pBuf)
{
#if (MEDIA_ENDIANNES == BIG_ENDIAN)
    return (pBuf[3]);
#else
    return (pBuf[0]);
#endif   
}

/*********************************************************************************
Sets the DataBitField
*********************************************************************************/
void SetDataBitField(byte *DataBitField, uint8 new_DataBitField)
{
    *DataBitField = new_DataBitField;
}

/*********************************************************************************
Returns a boolean value representing the state of the dirtyFlag bit
*********************************************************************************/
boolean IsDirty(byte DataBitField)
{
    return (DataBitField & DIRTY_FLAG_MASK);
}

/*********************************************************************************
Sets the dirtyFlag bit 
*********************************************************************************/
void SetDirty(byte *DataBitField, boolean new_dirtyFlag)
{
    if(new_dirtyFlag)
        *DataBitField |=  DIRTY_FLAG_MASK;       /* Sets the dirtyFlag bit to 1 */
    else
        *DataBitField &= ~DIRTY_FLAG_MASK;       /* Sets the dirtyFlag bit to 0 */
}

/*********************************************************************************
Returns a boolean value representing the state of the validFlag bit
*********************************************************************************/
boolean IsValid(byte DataBitField)
{
    return (DataBitField & VALID_FLAG_MASK);
}

/*********************************************************************************
Sets the valid data bit
*********************************************************************************/
void SetValid(byte *DataBitField, boolean new_validFlag)
{
    if(new_validFlag)
        *DataBitField |=  VALID_FLAG_MASK;       /* Sets the validFlag bit to 1 */
    else
        *DataBitField &= ~VALID_FLAG_MASK;       /* Sets the validFlag bit to 0 */
}
/*********************************************************************************
Returns the CRCsize
*********************************************************************************/
uint32 GetCRCSize(const uint8 *Buffer)
{
    /*Because we have the ability to support variable sized objects
    grab the size of the data from the acutual size found in the 
    Buffer... if you don't the size will be too small because the
    variable strings are not initialized.*/
    uint32 act_size = 0;
  
#if (MEDIA_ENDIANNES == BIG_ENDIAN)
    if(IsExtended_Bytes((uint8*)Buffer))
    {
        act_size = ((((uint32)Buffer[4])<<24) | 
                    (((uint32)Buffer[5])<<16) | 
                    (((uint32)Buffer[6])<<8 ) | 
                    (((uint32)Buffer[7]))) + sizeof(uint32) + sizeof(uint32);
    }
    else
    {
        act_size = ((((uint8)Buffer[4])<<8) | 
                    (((uint8)Buffer[5])))+ sizeof(uint32) + sizeof(uint16);
                    
    }
#else
    if(IsExtended_Bytes(Buffer))
    {
        act_size = ((((uint32)Buffer[7])<<24) | 
                    (((uint32)Buffer[6])<<16) | 
                    (((uint32)Buffer[5])<<8 ) | 
                    (((uint32)Buffer[4]))) + sizeof(uint32) + sizeof(uint32);
    }
    else
    {
        act_size = ((((uint8)Buffer[5])<<8) | 
                    (((uint8)Buffer[4])))+ sizeof(uint32) + sizeof(uint16);
    }
#endif

    return act_size;
}
/*********************************************************************************
Helper Function:
Peforms a comparison between the SrcVersion and the version span in the 
VersionEntry table. Returns TRUE if the SrcVersion falls within the version span
*********************************************************************************/
boolean GetVersionStatus(VersionEntry * pEntryList, uint16 EntryCount, uint16 MemberEnum,
                         uint16 SrcVersion)
{
    /* Verify that the MemberEnum is less than the EntryCount*/
    if(MemberEnum < EntryCount)
    {
        /*Return TRUE if SrcVersion is between min and max versions*/
        if((SrcVersion >= pEntryList[MemberEnum].min_version) &&
           (SrcVersion <= pEntryList[MemberEnum].max_version))
            return(TRUE);        
    }

    return (FALSE);
} 
/*********************************************************************************
Helper Function to return TRUE if a serialized object has a uint32 size identifier
*********************************************************************************/
boolean IsExtended_Bytes(uint8* pBuffer)
{
    return IsExtended_ClassID(ReadInt32(&pBuffer));
}
/*********************************************************************************
Helper Function to return TRUE if a serialized object has a uint32 size identifier
*********************************************************************************/
boolean IsExtended_ClassID(uint32 ClassID)
{
    boolean Result = FALSE;

    if((dt_family(ClassID) == FmSESSION && dt_genus (ClassID) != GnPARAMETER)
       || dt_family(ClassID) == FmDTCOLLECTION
       || dt_genus (ClassID) == GnDATAEXT
       || ClassID == MakeClassID(FmSPIRO, GnDATA, 0)          /*0 = SpSTANDARD*/
       || ClassID == MakeClassID(FmECG, GnDATA, 0)            /*0 = SpPACER*/
       || ClassID == MakeClassID(FmCALIBRATION, GnDATA, 128)  /*128 = SpSPIRO*/
       || ClassID == MakeClassID(FmTEST, GnDATA, 255))        /*255 = SpSESSION - Test ClassID Only*/
    {
        Result = TRUE;
    }

    return Result;
}
/*********************************************************************************
Helper Function to calculate a serialized object's size
*********************************************************************************/
uint32 MOIBSerialSize(uint8* pBuffer, uint8* pSizeWidthOut)
{
    uint32 l_Value = 0;

    /*Check for uint32 Size exceptions*/
    if(IsExtended_Bytes((uint8*)pBuffer)) 
    {
        /*Increment pBuffer past ClassID*/
        pBuffer += sizeof(uint32);

        /*Grab 4 byte size identifier with proper endianess*/
        l_Value = ReadInt32(&pBuffer);

        /*Add 4 bytes to l_Value*/
        l_Value += sizeof(uint32);

        if(pSizeWidthOut)
            *pSizeWidthOut = sizeof(uint32);
    }
    else
    {
        /*Increment pBuffer past ClassID*/
        pBuffer += sizeof(uint32);

        /*Grab 2 byte size identifier with proper endianess*/
        l_Value = ReadInt16(&pBuffer);

        /*Add 2 bytes to l_Value*/
        l_Value += sizeof(uint16);

        if(pSizeWidthOut)
            *pSizeWidthOut = sizeof(uint16);
    }

    /*Return l_Value + length of ClassID*/
    return l_Value + sizeof(uint32);
}
