/*-D*************************************************************************
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'** Support file for DtData Class. Contains the Corporate descriptions for      
'**  Family and Genus. This is a controlled document. 
'**  
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// DtSupport.h :   Family and Genus revision control                 //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(DTSUPPORT_H)
    #define  DTSUPPORT_H

#ifdef __cplusplus
extern "C" {
#endif

/*-D*************************************************************************
For descriptions see related DtSuport.txt found with thisfile in the Corporate
code base. If additions are made please add them to the text file with full 
description of genus type
'*-E************************************************************************/

//           ClassIdentifier
//      FAMILY      GENUS   SPECIES
//  31----------16 15-----8 7-----0

//Family
//typedef [unint16] enum typFAMILY {
typedef  enum typFAMILY {
    FmARCH = 0,
    FmECG,
    FmIP,
    FmTEMP,
    FmSPO2,
    FmNIBP,
    FmICG,
    FmHEMODYNAMICS,
    FmCO2,
    FmIBP,
    FmCARDIACOUTPUT,
    FmUI,
    FmBARCODE,
    FmCTRL,
    FmPATIENT,
    FmUSER,
    FmGLUCOSE,
    FmBODYMASSINDEX,
    FmRESPIRATION,
    FmWEIGHT,
    FmINSURANCE,
    FmPHYSICIAN,
    FmSITE,
    FmSESSION,
    FmDEVICE,
    FmINTERPRETATION,
    FmHEIGHT,
    FmSPIRO,
    FmTRAP,
    FmRENDEZVOUS,
    FmCONNECTION,
    FmWAVESAMPLE,
    FmWAVE,
    FmDEV01, 
    FmDEV02, 
    FmDEV03, 
    FmDEV04, 
    FmDEV05, 
    FmDEV06, 
    FmDEV07, 
    FmDEV08, 
    FmDEV09, 
    FmDEV10, 
    FmDEV11, 
    FmDEV12, 
    FmDEV13, 
    FmDEV14, 
    FmDEV15, 
    FmDEV16, 
    FmDEV17, 
    FmDEV18, 
    FmDEV19, 
    FmDEV20, 
    FmDEV21, 
    FmDEV22, 
    FmDEV23, 
    FmDEV24, 
    FmDEV25, 
    FmDEV26, 
    FmDEV27, 
    FmDEV28, 
    FmDEV29, 
    FmDEV30, 
    FmDEV31, 
    FmDEV32, 
    FmDEV33, 
    FmDEV34, 
    FmDEV35, 
    FmDEV36, 
    FmDEV37, 
    FmDEV38, 
    FmDEV39, 
    FmDEV40, 
    FmDEV41, 
    FmDEV42, 
    FmDEV43, 
    FmDEV44, 
    FmDEV45, 
    FmDEV46, 
    FmDEV47, 
    FmDEV48, 
    FmDEV49, 
    FmDEV50,
    FmGLOBALMEASUREMENTS,
    FmLEADIMPEDANCEARRAY,
    FmLEADIMPEDANCE,
    FmMEASUREMENTMATRIX,
    FmLEADMEASUREMENT,
    FmQRSANNOTARRAY,
    FmQRSCOMPLEX,
    FmPACERARRAY,
    FmPACERINFO,
    FmDTCOLLECTION,
    FmWACP,
    FmFLASH,
    FmVERSION,
    FmPRINTER,
    FmRECORD,
    FmTCPIP,
    FmLOCATIONID,
    FmPAIN,
    FmCLINICIAN,
    FmCALIBRATION,
    FmPATIENTLIST,
    FmFAX,
    FmMODULE,
    FmMODEM,
    FmNETWORK,
    FmTEST,
    FmENCRYPTION,
    FmTOC,
    FmBATTERY,
    FmFILESYS,
    FmMOIBSTRING,
    FmERROR,
    FmCOMMAND_LINE,
    FmDICTIONARY,
    FmNUMERIC,
    FmCHANNEL,
    FmMAX
} FAMILY;

//Genus
//typedef [unint8] enum typGENUS {
typedef enum typGENUS {
    GnDATA = 0,
    GnCOMMAND,
    GnEVENT,
    GnERROR,
    GnRESERVE_A,
    GnSTATUS,
    GnNUMERIC,
    GnRESERVE_B,
    GnCONFIG,
    GnRESERVE_C,
    GnRESERVE_D,
    GnREQUEST,
    GnRESERVE_E,
    GnRESERVE_F,
    GnRESERVE_G,
    GnRESPONSE,
    GnPARAMETER,
    GnSTREAM,
    GnDATAEXT,
    GnMAX
} GENUS;

#if defined( __cplusplus )
}
#endif

#endif /* #if !defined(DTSUPPORT_H) */
