/**************************************************************************** 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CEthCommSvr.h  :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(CETHCOMMSVR_H)
    #define  CETHCOMMSVR_H

#include "Target.h"
#include "Common.h"
#include <winsock.h>

typedef struct EthAddr
{
    /* User configurable */     
    uint16  Protocol;           /* Protocol: IPPROTO_UDP or IPPROTO_TCP */
    boolean bAutoDiscovery;     /* TRUE - Server/Host auto detects client via hardware trigger 
                                 * FALSE - Client must send initial RNDZ connect message.
                                 */ 

    /* Stack modified values */
    uint16  Port;
    char*   pSourceID;
    SOCKET  Socket;
    struct sockaddr_in  ClntAddr;
}EthAddr;

typedef struct CEthCommSvr
{
    SOCKET          TxSocket;
    char            SourceID[ADDR_BUF_SIZE];
    uint16          Port;
    enum STACK_TYPE StackType;
    struct sockaddr_in  DestAddr;
    EthAddr         Config;
    uint16          Protocol;
    boolean         WSAStartFlag;
    HANDLE          ClientExitMutex;
}CEthCommSvr;

void            CEthCommSvr_Init(CEthCommSvr* pObject);
void            CEthCommSvr_Destroy(CEthCommSvr* pObject);
boolean         CEthCommSvr_SetSourceID(CEthCommSvr* pObject, const char* pSourceID);
void            CEthCommSvr_SetConfig(CEthCommSvr* pObject, const EthAddr* pAddr);
boolean         CEthCommSvr_Connect(CEthCommSvr* pObject, uint8 *pSourceID, int PortNum);
boolean         CEthCommSvr_SendMessage(const CEthCommSvr* pObject, const uint8* pBuf, uint32 pBufSize);
uint32 WACPAPI  CEthCommSvr_StartClient(void* pData);

#endif /* #if !defined(CETHCOMMSVR_H) */







