/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFamilyEnum.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.5.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CFAMILYENUM_H)
    #define  CFAMILYENUM_H

    typedef  enum CONNCMDtypSPECIES{
        CONN_CMD_SpSHUTDOWN = 0,
        CONN_CMD_SpMAX
    }CONN_CMD_SPECIES;

    typedef  enum RNDZCCMDtypSPECIES {
        RNDZ_CCMD_SpNONE = 0,
        RNDZ_CCMD_SpTERMINATE,
        RNDZ_CCMD_SpSTART_HOST_PROC,
        RNDZ_CCMD_SpSEND_HOST_READY,
        RNDZ_CCMD_SpMAX
    } RNDZ_CCMD_SPECIES;

    typedef  enum RNDZCRSTtypSPECIES {
        RNDZ_CRST_SpNONE = 0,
        RNDZ_CRST_SpSTART_RNDZ,
        RNDZ_CRST_SpGET_ENCRYPT_KEY,
        RNDZ_CRST_SpMAX
    } RNDZ_CRST_SPECIES;

    typedef  enum RNDZCRSPtypSPECIES {
        RNDZ_CRSP_SpNONE = 0,
        RNDZ_CRSP_SpRNDZ_ACCEPT,
        RNDZ_CRSP_SpSEND_ENCRYPT_KEY,
        RNDZ_CRSP_SpHOST_READY,
        RNDZ_CRSP_SpMAX
    } RNDZ_CRSP_SPECIES;

    /* FmERROR Message Enumerations */
    typedef enum ERRORCRSTtypSPECIES{
        ERROR_CRST_SpGET_ERROR,
        ERROR_CRST_SpMAX
    } ERROR_CRST_SPECIES;

    typedef enum ERRORCRSPtypSPECIES{
        ERROR_CRSP_SpPUT_ERROR,
        ERROR_CRSP_SpMAX
    } ERROR_CRSP_SPECIES;

    /* FmDEVICE Message Enumerations */
    typedef enum DEVICECCMDtypSPECIES{
        DEVICE_CCMD_SpWRITE_CONFIG,
        DEVICE_CCMD_SpWRITE_DATA,
        DEVICE_CCMD_SpENABLE_DISPLAY,
        DEVICE_CCMD_SpSTART_DISPLAY_TEST,
        DEVICE_CCMD_SpRESET,
        DEVICE_CCMD_SpPOWER,
        DEVICE_CCMD_SpBEEP,
        DEVICE_CCMD_SpSAVE_CONFIG,
        DEVICE_CCMD_SpRESTORE_CONFIG,
        DEVICE_CCMD_SpENABLE_AUTO_POWER_DOWN,
        DEVICE_CCMD_SpMAX
    } DEVICE_CCMD_SPECIES;

    typedef enum DEVICECRSTtypSPECIES{
        DEVICE_CRST_SpGET_DEVICEDESCRIPTION,
        DEVICE_CRST_SpGET_CONFIG,
        DEVICE_CRST_SpMAX
    } DEVICE_CRST_SPECIES;

    typedef enum DEVICECRSPtypSPECIES{
        DEVICE_CRSP_SpPUT_DEVICEDESCRIPTION,
        DEVICE_CRSP_SpPUT_CONFIG,
        DEVICE_CRSP_SpMAX
    } DEVICE_CRSP_SPECIES;

    /* FmMODULE Message Enumerations */
    typedef enum MODULECCMDtypSPECIES{
        MODULE_CCMD_SpWRITE_CONFIG,
        MODULE_CCMD_SpWRITE_MODULE_DESC,
        MODULE_CCMD_SpMAX
    } MODULE_CCMD_SPECIES;

    typedef enum MODULECRSTtypSPECIES{
        MODULE_CRST_SpGET_MODULE_DESC,
        MODULE_CRST_SpGET_CONFIG,
        MODULE_CRST_SpMAX
    } MODULE_CRST_SPECIES;

    typedef enum MODULECRSPtypSPECIES{
        MODULE_CRSP_SpPUT_MODULE_DESC,
        MODULE_CRSP_SpPUT_CONFIG,
        MODULE_CRSP_SpMAX
    } MODULE_CRSP_SPECIES;

    typedef enum MODULECEVNTtypSPECIES{
        MODULE_CEVNT_SpHW_MOD_CONNECT,
        MODULE_CEVNT_SpHW_MOD_DISCONNECT,
        MODULE_CEVNT_SpMAX
    } MODULE_CEVNT_SPECIES;

    /* FmTEMP Message Enumerations */
    typedef enum TEMPCRSTtypSPECIES{
        TEMP_CRST_SpGET_TEMP,
        TEMP_CRST_SpMAX
    } TEMP_CRST_SPECIES;

    typedef enum TEMPCRSPtypSPECIES{
        TEMP_CRSP_SpPUT_TEMP,
        TEMP_CRSP_SpMAX
    } TEMP_CRSP_SPECIES;

    typedef enum TEMPCSStypSPECIES{
        TEMP_CSS_SpREPORT_TEMPERATURE,
        TEMP_CSS_SpMAX
    } TEMP_CSS_SPECIES;

    typedef enum TEMPCSTRtypSPECIES{
        TEMP_CSTR_SpSTREAM_TEMPERATURE,
        TEMP_CSTR_SpMAX
    } TEMP_CSTR_SPECIES;

	/* FmRESPIRATION Message Enumerations */
    typedef enum RESPIRATIONCCMDtypSPECIES{
        RESPIRATION_CCMD_SpRESTART_BREATH_ALG,/*Sent when the host determines that there is a 'no breath detected' condition in order to ensure correct EtCO2, FiCO2, and RR calculations upon resumption of breathing.*/
        RESPIRATION_CCMD_SpSET_CALIBRATION_DATE,/*A message to set the calibration date. Requires a CRespCDate object.*/
        RESPIRATION_CCMD_SpSTART_CALIBRATION,/*A message to start the calibration. Requires a CRespCCal object.*/
        RESPIRATION_CCMD_SpSTOP_CALIBRATION,/*A message to stop the calibration. No object required in payload.*/
        RESPIRATION_CCMD_SpFORCE_SFM,/*A command to force SFM. No object required in payload*/
        RESPIRATION_CCMD_SpPUMP_CONTROL,/*A command to enable or disable the pump. Requires a CRespPMsgArg object with species set to SpPUMP*/
        RESPIRATION_CCMD_SpMAX
    } RESPIRATION_CCMD_SPECIES;

    typedef enum RESPIRATIONCRSTtypSPECIES{
        RESPIRATION_CRST_SpGET_BREATH,/*A request to get the breath measurement. No object required in payload*/
        RESPIRATION_CRST_SpGET_AMBIENT_PRESSURE,/*A request to get the ambient pressure. No object required in the payload.*/
        RESPIRATION_CRST_SpGET_MODULE_CONFIG,/*A request to get a module configuration. Requires a CRespPMsgArg object with species set to SpMODULE and IOParameterA set to CONFIG_ITEM to return*/
        RESPIRATION_CRST_SpGET_CALIBRATION_DATE,/*A message to request the calibration date. No object required in payload.*/
        RESPIRATION_CRST_SpGET_CALIBRATION,/*A message to request the calibration status. No object required in payload.*/
        RESPIRATION_CRST_SpGET_EXTENDED_STATUS,/*A message to request the extended status. No object required in payload.*/
        RESPIRATION_CRST_SpGET_CAL_TIME,/*A message to request the remaining hours for calibration. No object required in payload.*/
        RESPIRATION_CRST_SpGET_SERVICE_TIME,/*A message to request the remaining hours for calibration. No object required in payload.*/
        RESPIRATION_CRST_SpGET_LAST_SERVICE_CODE,/*A message to request the last service code. No object required in payload.*/
        RESPIRATION_CRST_SpGET_SERVICE_CODES,/*A message to request the last service code. No object required in payload.*/
        RESPIRATION_CRST_SpMAX
    } RESPIRATION_CRST_SPECIES;

    typedef enum RESPIRATIONCRSPtypSPECIES{
        RESPIRATION_CRSP_SpPUT_BREATH,/*A response to the GET_BREATH message. Returns the breath measurement. Requires a CRespDData object.*/
        RESPIRATION_CRSP_SpPUT_AMBIENT_PRESSURE,/*A response to the GET_AMBIENT_PRESSURE message. Requires a CRespDPressure object.*/
        RESPIRATION_CRSP_SpPUT_MODULE_CONFIG,/*A response to the GET_MODULE_CONFIG message. Requires a CRespPMsgArg object with species set to SpMODULE and IOParameterA set to the CONFIG_ITEM and IOParameterB set to the CONFIG_ITEM value.*/
        RESPIRATION_CRSP_SpPUT_CALIBRATION_DATE,/*A response to the PUT_CALIBRATION_DATE message. Requires a CRespCDate*/
        RESPIRATION_CRSP_SpPUT_CALIBRATION,/*A response to the PUT_CALIBRATION message. Requires a CRespCCal*/
        RESPIRATION_CRSP_SpPUT_EXTENDED_STATUS,/*A response to the PUT_EXTENDED_STATUS message. Requires a CRespPMsgArg with the species set to SpEXTSTATUS.*/
        RESPIRATION_CRSP_SpPUT_CAL_TIME,/*A response to the GET_CAL_TIME message. Requires a CRespPMsgArg object with the appropriate species set (Hours to calibration = SpCALIBRATION_TIME) and IOParameterA contains the calibration time.*/
        RESPIRATION_CRSP_SpPUT_SERVICE_TIME,/*A response to the GET_SERVICE_TIME message. Requires a CRespPMsgArg object with the appropriate species set (Hours to service = SpSERVICE) and IOParameterA contains the service time.*/
        RESPIRATION_CRSP_SpPUT_LAST_SERVICE_CODE,/*A response to the GET_LAST_SERVICE_CODE message. Requires a CRespPMsgArg object with species set to SpSERVICE_CODE*/
        RESPIRATION_CRSP_SpPUT_SERVICE_CODES,/*A response to the GET_SERVICE_CODES message. Requires a CRespDExtStd containing 1 or more CRespPMsgArg objects*/
        RESPIRATION_CRSP_SpMAX
    } RESPIRATION_CRSP_SPECIES;

    typedef enum RESPIRATIONCSStypSPECIES{
        RESPIRATION_CSS_SpREPORT_BREATH_DETECT,/*A message to indicate a breath measurement after a significant breath detection. Requires a CRespDData object*/
        RESPIRATION_CSS_SpREPORT_BREATH,/*A periodic message to indicate a breath measurement. Requires a CRespDData object.*/
        RESPIRATION_CSS_SpREPORT_PI,/*A periodic message (once per second) to indicate a pulmonary index measurement. Requires a CRespDIPI object.*/
        RESPIRATION_CSS_SpMAX
    } RESPIRATION_CSS_SPECIES;

    typedef enum RESPIRATIONCSTRtypSPECIES{
        RESPIRATION_CSTR_SpSTREAM_CO2,
        RESPIRATION_CSTR_SpMAX
    } RESPIRATION_CSTR_SPECIES;

#endif /* #if !defined(CFAMILYENUM_H) */

/*---------------------------------------------------*/
/* End of File */
