/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// MiscUtil.h     :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(MISCUTIL_H)
    #define  MISCUTIL_H

#include "StdVarTyp.h"

#define GUID_STR_SIZE (16*2+4+2+1)

#define CRC_SEED    0xFFFF

/*================================================================================
Method to Calculate the CRC.
================================================================================*/
uint16 CalculateCRC(uint16 CurrentCRC, const uint8 *pBuf, uint32 BufSize);

/*================================================================================
Convert binary GUID to a string 
=================================================================================*/
ansichar* GUIDToStr(const uint8* guid, ansichar* Output, uint16 Size);

/*================================================================================
Helper function to convert a nibble to a char
=================================================================================*/
ansichar nibble_to_char(uint8 nibble);

/*================================================================================
Convert MOIB_TIME struct to a string
=================================================================================*/
ansichar* MOIBTimeToStr(MOIB_TIME sDateTime, ansichar* Output);

#endif  /* #if !defined(MISCUTIL_H) */

/*---------------------------------------------------*/
/* End of File */

