/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFamilyStub.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CFAMILYSTUB_H)
    #define  CFAMILYSTUB_H

#include "Common.h"
#include "CMOMPBaseClass.h"
#include "CFamilyEnum.h"
#include "CDeviceDStd.h"
#include "CDevDPOST.h"
#include "CModuleDStd.h"
#include "CRespDData.h"
#include "CRespDIPI.h"
#include "CRespDCO2.h"
#include "CSpO2DData.h"
#include "CModulePSelector.h"


class CFamilyStub : public CMOMPBaseClass
{ 
private:
    void LoadObjects();

#if defined(DEBUG_PRINT_STATUS)
    /* DEBUG */
    uint32  AckCount;
    uint32  ErrCount;
#endif


public:
    CFamilyStub();
    ~CFamilyStub();

    CMOMPBaseClass* AppInit(CWACPApp *pWACPAppRef, boolean bSvrFlag, char *pServerSourceID);
    uint32 AppEnd(CWACPApp *pWACPAppRef);
    uint32 RecvMessage(char *pSourceID, uint32 ClassID, uint8 *pBuffer);
    uint32 RecvError(char *pSourceID, uint8 ErrorType, uint32 ClassID, uint8 *pBuffer);
    uint32 RecvConnection(char *pSourceID, uint8 ConnType, uint8 *pBuffer);

    CDeviceDStd  *pCDeviceDStd;
    CDevDPOST  *pCDevDPOST;
    CModuleDStd  *pCModuleDStd;
    CRespDData  *pCRespDData;
    CRespDIPI  *pCRespDIPI;
    CRespDCO2  *pCRespDCO2;
    CSpO2DData  *pCSpO2DData;
    CNumDStd  *pCNumDStd;
	CModulePSelector *pCModulePSelector;

};

#define SEND_COMMAND(pSourceID, Family, CommandID, DataBuffer, DataSize, bEncryptionOn) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, Family, GnCOMMAND, CommandID, DataBuffer, DataSize, bEncryptionOn)
#define SEND_REQUEST(pSourceID, Family, RequestID, DataBuffer, DataSize, bEncryptionOn) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, Family, GnREQUEST, RequestID, DataBuffer, DataSize, bEncryptionOn)
#define SEND_RESPONSE(pSourceID, Family, ResponseID, DataBuffer, DataSize, bEncryptionOn) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, Family, GnRESPONSE, ResponseID, DataBuffer, DataSize, bEncryptionOn)
#define SEND_STATUS(pSourceID, Family, StatusID, DataBuffer, DataSize, bEncryptionOn) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, Family, GnSTATUS, StatusID, DataBuffer, DataSize, bEncryptionOn)
#define SEND_EVENT(pSourceID, Family, EventMsgID, DataBuffer, DataSize, bEncryptionOn) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, Family, GnEVENT, EventMsgID, DataBuffer, DataSize, bEncryptionOn)
#define SEND_STREAM(pSourceID, Family, StreamMsgID, DataBuffer, DataSize, bEncryptionOn) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, Family, GnSTREAM, StreamMsgID, DataBuffer, DataSize, bEncryptionOn)
#define SEND_DATAOBJ(pSourceID, ClassID, DataBuffer, DataSize) ((CWACPApp*)pWACPApp)->SendMsg(pSourceID, GetFamily(ClassID), GnDATA, GetSpecies(ClassID), DataBuffer, DataSize, FALSE)
#define SEND_TRAP(pSourceID, MsgClassID, ErrorClassID, ErrorType, ErrorCode, pData, DataSize) ((CWACPApp*)pWACPApp)->SendTrap(pSourceID, MsgClassID, ErrorClassID, ErrorType, ErrorCode, pData, DataSize)
#define SEND_MSGPROC_TRAP(pSourceID, ClassID, ErrorCode) ((CWACPApp*)pWACPApp)->SendMsgProcTrap(pSourceID, ClassID, ErrorCode)

#endif /* #if !defined(CFAMILYSTUB_H) */

/*---------------------------------------------------*/
/* End of File */

