/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmDEVICEStub.cpp                                                 //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmDEVICEStub.h"

CFmDEVICEStub::CFmDEVICEStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmDEVICEStub::~CFmDEVICEStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmDEVICEStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;
    uint8    *ObjBuffer = NULL;
    uint32   ObjSize = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmDEVICE Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_DEVICEDESCRIPTION\n");
                SYS_PRINTF("\t2. GET_CONFIG\n");
                SYS_PRINTF("\t3. GET_POST\n");
                SYS_PRINTF("\t4. GET_DIGITAL_STATE\n");
                SYS_PRINTF("\t5. GET_DEVICE_MODE\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 5))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\nFmDEVICE Contains No Status Messages\n");
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. DEVICE_CCMD_SpWRITE_CONFIG\n");
                SYS_PRINTF("\t2. DEVICE_CCMD_SpWRITE_DEVICEDESCRIPTION\n");
                SYS_PRINTF("\t3. DEVICE_CCMD_SpENABLE_DISPLAY\n");
                SYS_PRINTF("\t4. DEVICE_CCMD_SpSTART_DISPLAY_TEST\n");
                SYS_PRINTF("\t5. DEVICE_CCMD_SpRESET\n");
                SYS_PRINTF("\t6. DEVICE_CCMD_SpPOWER\n");
                SYS_PRINTF("\t7. DEVICE_CCMD_SpBEEP\n");
                SYS_PRINTF("\t8. DEVICE_CCMD_SpSAVE_CONFIG\n");
                SYS_PRINTF("\t9. DEVICE_CCMD_SpRESTORE_CONFIG\n");
                SYS_PRINTF("\t10. DEVICE_CCMD_SpENABLE_AUTO_POWER_DOWN\n");
                SYS_PRINTF("\t11. DEVICE_CCMD_SpSET_DISPLAY_CONTRAST\n");
                SYS_PRINTF("\t12. DEVICE_CCMD_SpSET_BACKLIGHT\n");
                SYS_PRINTF("\t13. DEVICE_CCMD_SpSTART_DIGITAL_TEST\n");
                SYS_PRINTF("\t14. DEVICE_CCMD_SpSET_DEVICE_MODE\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 14))
                    {
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmDEVICE Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. Send CDEVDSTD_SpSTANDARD\n");
                SYS_PRINTF("\t2. Send CDEVDSTD_SpHOST\n");
                SYS_PRINTF("\t3. Send CDEVDSTD_SpSENSOR\n");
                SYS_PRINTF("\t4. Send CDEVDSTD_SpALL\n");
                SYS_PRINTF("\t5. Send CDEVDPST_SpPOST\n");
                SYS_PRINTF("\nEnter DataObject: ");

                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit DataObject Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
                        pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpSTANDARD);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpSTANDARD, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 2:
                    {
                        pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpHOST);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpHOST, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 3:
                    {
                        pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpSENSOR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpSENSOR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 4:
                    {
                        pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpALL);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpALL, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 5:
                    {
                        pStubClass->pCDevDPOST->set_Species(CDEVDPST_SpPOST);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDevDPOST->size_all())) != NULL)
                        {
                            Result = pStubClass->pCDevDPOST->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDPST_SpPOST, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                }
            }
            else if(TestID == 6)
            {
                SYS_PRINTF("\nFmDEVICE Contains No Streams\n");
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */

    /* Clean up the memory allocations */
    SYS_FREE(ObjBuffer);
    ObjBuffer = NULL;
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmDEVICEStub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmDEVICE, GnREQUEST, (uint8)(i%5)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmDEVICEStub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmDEVICE, GnREQUEST, (uint8)(i%5), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmDEVICEStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 14;
    uint8   RqstID = 0;
    uint8   NumRequest = 5;
    uint32  Result;
    uint8   *ObjBuffer = NULL;
    uint32  ObjSize = 0;
    uint8   DataID = 0;
    uint8   NumDataObject = 7;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmDEVICE, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmDEVICE, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all data objects */
    for(DataID = 0; DataID < NumDataObject; DataID++)
    {
        switch(DataID)
        {
            case 0:
            {
                pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpSTANDARD);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpSTANDARD, ObjBuffer, ObjSize);
                }
                break;
            }
            case 1:
            {
                pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpHOST);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpHOST, ObjBuffer, ObjSize);
                }
                break;
            }
            case 2:
            {
                pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpSENSOR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpSENSOR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 3:
            {
                pStubClass->pCDeviceDStd->set_Species(CDEVDSTD_SpALL);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDeviceDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCDeviceDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDSTD_SpALL, ObjBuffer, ObjSize);
                }
                break;
            }
            case 4:
            {
                pStubClass->pCDevDPOST->set_Species(CDEVDPST_SpPOST);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCDevDPOST->size_all())) != NULL)
                {
                    Result = pStubClass->pCDevDPOST->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmDEVICE, GnDATA, CDEVDPST_SpPOST, ObjBuffer, ObjSize);
                }
                break;
            }
        }
    }
    /* clean up */
    SYS_FREE(ObjBuffer);
#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
