/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmRESPIRATIONStub.cpp                                            //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmRESPIRATIONStub.h"

CFmRESPIRATIONStub::CFmRESPIRATIONStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmRESPIRATIONStub::~CFmRESPIRATIONStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmRESPIRATIONStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;
    uint8    *ObjBuffer = NULL;
    uint32   ObjSize = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmRESPIRATION Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_BREATH\n");
                SYS_PRINTF("\t2. GET_AMBIENT_PRESSURE\n");
                SYS_PRINTF("\t3. GET_MODULE_CONFIG\n");
                SYS_PRINTF("\t4. GET_CALIBRATION_DATE\n");
                SYS_PRINTF("\t5. GET_CALIBRATION\n");
                SYS_PRINTF("\t6. GET_EXTENDED_STATUS\n");
                SYS_PRINTF("\t7. GET_CAL_TIME\n");
                SYS_PRINTF("\t8. GET_SERVICE_TIME\n");
                SYS_PRINTF("\t9. GET_LAST_SERVICE_CODE\n");
                SYS_PRINTF("\t10. GET_SERVICE_CODES\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 10))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. REPORT_BREATH_DETECT\n");
                SYS_PRINTF("\t2. REPORT_BREATH\n");
                SYS_PRINTF("\t3. REPORT_PI\n");
                SYS_PRINTF("\nEnter Status ID: ");
                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit Status Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTATUS, RESPIRATION_CSS_SpREPORT_BREATH_DETECT, (uint8*)"STATUS: REPORT_BREATH_DETECT RECEIVED", (uint32)strlen("STATUS: REPORT_BREATH_DETECT RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    case 2:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTATUS, RESPIRATION_CSS_SpREPORT_BREATH, (uint8*)"STATUS: REPORT_BREATH RECEIVED", (uint32)strlen("STATUS: REPORT_BREATH RECEIVED")+1, FALSE);
#endif
						

                        break;
                    }
                    case 3:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTATUS, RESPIRATION_CSS_SpREPORT_PI, (uint8*)"STATUS: REPORT_PI RECEIVED", (uint32)strlen("STATUS: REPORT_PI RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    /* -- Unrecognized StatusID -- */
                    default:
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                        break;
                    }
                }
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. RESPIRATION_CCMD_SpRESTART_BREATH_ALG\n");
                SYS_PRINTF("\t2. RESPIRATION_CCMD_SpSET_CALIBRATION_DATE\n");
                SYS_PRINTF("\t3. RESPIRATION_CCMD_SpSTART_CALIBRATION\n");
                SYS_PRINTF("\t4. RESPIRATION_CCMD_SpSTOP_CALIBRATION\n");
                SYS_PRINTF("\t5. RESPIRATION_CCMD_SpFORCE_SFM\n");
                SYS_PRINTF("\t6. RESPIRATION_CCMD_SpPUMP_CONTROL\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 6))
                    {
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmRESPIRATION Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. Send CRSPDDTA_SpDATA\n");
                SYS_PRINTF("\t2. Send CRSPDIPI_SpPULMONARYINDEX\n");
                SYS_PRINTF("\t3. Send CRSPDCO2_SpCO2\n");
                SYS_PRINTF("\nEnter DataObject: ");

                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit DataObject Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
                        pStubClass->pCRespDData->set_Species(CRSPDDTA_SpDATA);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCRespDData->size_all())) != NULL)
                        {
                            Result = pStubClass->pCRespDData->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnDATA, CRSPDDTA_SpDATA, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 2:
                    {
                        pStubClass->pCRespDIPI->set_Species(CRSPDIPI_SpPULMONARYINDEX);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCRespDIPI->size_all())) != NULL)
                        {
                            Result = pStubClass->pCRespDIPI->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnDATA, CRSPDIPI_SpPULMONARYINDEX, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 3:
                    {
                        pStubClass->pCRespDCO2->set_Species(CRSPDCO2_SpCO2);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCRespDCO2->size_all())) != NULL)
                        {
                            Result = pStubClass->pCRespDCO2->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnDATA, CRSPDCO2_SpCO2, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                }
            }
            else if(TestID == 6)
            {
               char Temp[] = "Test message";

               SYS_PRINTF("\t0. Exit\n");
               SYS_PRINTF("\t1. RESPIRATION_CSTR_SpSTREAM_CO2\n");

               SYS_PRINTF("\nEnter Stream ID: ");

               Result = (uint16)scanf("%d", &CmdRqst);
               if(Result == 1)
               {
                   if(CmdRqst == 0)
                   {
                       SYS_PRINTF("\n\nExit Stream Menu.\n\n");
                       break;
                   }
                   else if((CmdRqst >= 1) && (CmdRqst <= 1))
                   {
                       pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTREAM, (uint8)--CmdRqst, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);
                   }
                   else
                   {
                       SYS_PRINTF("\n\nInvalid Selection.\n\n");
                   }
               }
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */

    /* Clean up the memory allocations */
    SYS_FREE(ObjBuffer);
    ObjBuffer = NULL;
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmRESPIRATIONStub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmRESPIRATION, GnREQUEST, (uint8)(i%10)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmRESPIRATIONStub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnREQUEST, (uint8)(i%10), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmRESPIRATIONStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 6;
    uint8   RqstID = 0;
    uint8   NumRequest = 10;
    uint8   StatID = 0;
    uint8   NumStatus = 3;
    uint8   StrmID = 0;
    uint8   NumStream = 1;
    char    Temp[] = "Test message";
    uint32  Result;
    uint8   *ObjBuffer = NULL;
    uint32  ObjSize = 0;
    uint8   DataID = 0;
    uint8   NumDataObject = 4;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all status */
    for(StatID = 0; StatID < NumStatus; StatID++)
    {
        switch(StatID)
        {
            case RESPIRATION_CSS_SpREPORT_BREATH_DETECT:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTATUS, RESPIRATION_CSS_SpREPORT_BREATH_DETECT, (uint8*)"STATUS: REPORT_BREATH_DETECT RECEIVED", (uint32)strlen("STATUS: REPORT_BREATH_DETECT RECEIVED")+1, FALSE);
#endif
                break;
            }
            case RESPIRATION_CSS_SpREPORT_BREATH:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTATUS, RESPIRATION_CSS_SpREPORT_BREATH, (uint8*)"STATUS: REPORT_BREATH RECEIVED", (uint32)strlen("STATUS: REPORT_BREATH RECEIVED")+1, FALSE);
#endif
                break;
            }
            case RESPIRATION_CSS_SpREPORT_PI:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTATUS, RESPIRATION_CSS_SpREPORT_PI, (uint8*)"STATUS: REPORT_PI RECEIVED", (uint32)strlen("STATUS: REPORT_PI RECEIVED")+1, FALSE);
#endif
                break;
            }
        }
    }

    /* Send all streams */
    for(StrmID = 0; StrmID < NumStream; StrmID++)
        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnSTREAM, StrmID, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);

    /* Send all data objects */
    for(DataID = 0; DataID < NumDataObject; DataID++)
    {
        switch(DataID)
        {
            case 0:
            {
                pStubClass->pCRespDData->set_Species(CRSPDDTA_SpDATA);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCRespDData->size_all())) != NULL)
                {
                    Result = pStubClass->pCRespDData->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnDATA, CRSPDDTA_SpDATA, ObjBuffer, ObjSize);
                }
                break;
            }
            case 1:
            {
                pStubClass->pCRespDIPI->set_Species(CRSPDIPI_SpPULMONARYINDEX);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCRespDIPI->size_all())) != NULL)
                {
                    Result = pStubClass->pCRespDIPI->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnDATA, CRSPDIPI_SpPULMONARYINDEX, ObjBuffer, ObjSize);
                }
                break;
            }
            case 2:
            {
                pStubClass->pCRespDCO2->set_Species(CRSPDCO2_SpCO2);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCRespDCO2->size_all())) != NULL)
                {
                    Result = pStubClass->pCRespDCO2->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmRESPIRATION, GnDATA, CRSPDCO2_SpCO2, ObjBuffer, ObjSize);
                }
                break;
            }
        }
    }
    /* clean up */
    SYS_FREE(ObjBuffer);
#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
