/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmSPO2Stub.cpp                                                   //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmSPO2Stub.h"

CFmSPO2Stub::CFmSPO2Stub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmSPO2Stub::~CFmSPO2Stub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmSPO2Stub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;
    uint8    *ObjBuffer = NULL;
    uint32   ObjSize = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmSPO2 Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_SPO2\n");
                SYS_PRINTF("\t2. GET_CONFIG\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 2))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmSPO2, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. REPORT_SPO2\n");
                SYS_PRINTF("\nEnter Status ID: ");
                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit Status Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmSPO2, GnSTATUS, SPO2_CSS_SpREPORT_SPO2, (uint8*)"STATUS: REPORT_SPO2 RECEIVED", (uint32)strlen("STATUS: REPORT_SPO2 RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    /* -- Unrecognized StatusID -- */
                    default:
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                        break;
                    }
                }
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. SPO2_CCMD_SpSTART_ACQUIRE\n");
                SYS_PRINTF("\t2. SPO2_CCMD_SpSTOP_ACQUIRE\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 2))
                    {
                        pStubClass->SendMsg(pSourceID, FmSPO2, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmSPO2 Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. Send CSP2DDTA_SpDATA\n");
                SYS_PRINTF("\nEnter DataObject: ");

                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit DataObject Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
                        pStubClass->pCSpO2DData->set_Species(CSP2DDTA_SpDATA);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCSpO2DData->size_all())) != NULL)
                        {
                            Result = pStubClass->pCSpO2DData->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmSPO2, GnDATA, CSP2DDTA_SpDATA, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                }
            }
            else if(TestID == 6)
            {
               char Temp[] = "Test message";

               SYS_PRINTF("\t0. Exit\n");
               SYS_PRINTF("\t1. SPO2_CSTR_SpSTREAM_SPO2\n");

               SYS_PRINTF("\nEnter Stream ID: ");

               Result = (uint16)scanf("%d", &CmdRqst);
               if(Result == 1)
               {
                   if(CmdRqst == 0)
                   {
                       SYS_PRINTF("\n\nExit Stream Menu.\n\n");
                       break;
                   }
                   else if((CmdRqst >= 1) && (CmdRqst <= 1))
                   {
                       pStubClass->SendMsg(pSourceID, FmSPO2, GnSTREAM, (uint8)--CmdRqst, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);
                   }
                   else
                   {
                       SYS_PRINTF("\n\nInvalid Selection.\n\n");
                   }
               }
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */

    /* Clean up the memory allocations */
    SYS_FREE(ObjBuffer);
    ObjBuffer = NULL;
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmSPO2Stub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmSPO2, GnREQUEST, (uint8)(i%2)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmSPO2Stub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmSPO2, GnREQUEST, (uint8)(i%2), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmSPO2Stub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 2;
    uint8   RqstID = 0;
    uint8   NumRequest = 2;
    uint8   StatID = 0;
    uint8   NumStatus = 1;
    uint8   StrmID = 0;
    uint8   NumStream = 1;
    char    Temp[] = "Test message";
    uint32  Result;
    uint8   *ObjBuffer = NULL;
    uint32  ObjSize = 0;
    uint8   DataID = 0;
    uint8   NumDataObject = 1;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmSPO2, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmSPO2, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all status */
    for(StatID = 0; StatID < NumStatus; StatID++)
    {
        switch(StatID)
        {
            case SPO2_CSS_SpREPORT_SPO2:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmSPO2, GnSTATUS, SPO2_CSS_SpREPORT_SPO2, (uint8*)"STATUS: REPORT_SPO2 RECEIVED", (uint32)strlen("STATUS: REPORT_SPO2 RECEIVED")+1, FALSE);
#endif
                break;
            }
        }
    }

    /* Send all streams */
    for(StrmID = 0; StrmID < NumStream; StrmID++)
        pStubClass->SendMsg(pSourceID, FmSPO2, GnSTREAM, StrmID, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);

    /* Send all data objects */
    for(DataID = 0; DataID < NumDataObject; DataID++)
    {
        switch(DataID)
        {
            case 0:
            {
                pStubClass->pCSpO2DData->set_Species(CSP2DDTA_SpDATA);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCSpO2DData->size_all())) != NULL)
                {
                    Result = pStubClass->pCSpO2DData->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmSPO2, GnDATA, CSP2DDTA_SpDATA, ObjBuffer, ObjSize);
                }
                break;
            }
        }
    }
    /* clean up */
    SYS_FREE(ObjBuffer);
#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
