/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDevDPOST.cpp                                                     //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#include "CDevDPOST.h"

const MsgEntry CDevDPOST::TypPOSTStatusTbl[] = {
    CDEVDPST_POSTStatus_NONE , "NO_DESCRIPTION",
    CDEVDPST_POSTStatus_IN_PROGRESS , "NO_DESCRIPTION",
    CDEVDPST_POSTStatus_COMPLETE , "NO_DESCRIPTION",
    CDEVDPST_POSTStatus_FAILURE , "NO_DESCRIPTION",
};

#define CDEVDPST_TYPPOSTSTATUSTBL_SIZE \
    (sizeof(TypPOSTStatusTbl)/sizeof(TypPOSTStatusTbl[0]))

const MsgEntry CDevDPOST::TypSpeciesTbl[] = {
    CDEVDPST_SpPOST , "NO_DESCRIPTION",
};

#define CDEVDPST_TYPSPECIESTBL_SIZE \
    (sizeof(TypSpeciesTbl)/sizeof(TypSpeciesTbl[0]))

const VersionEntry CDevDPOST::TypVersionsTbl[] = {
    100, 200, /*CDEVDPOST_DeviceGUID*/
    100, 200, /*CDEVDPOST_SourceID*/
    200, 200, /*CDEVDPOST_POSTStatus*/
    200, 200, /*CDEVDPOST_ErrorList*/
};

/*================================================================================
    CONSTRUCTORS / DESTRUCTORS
================================================================================*/
/*********************************************************************************
  Default constructor
*********************************************************************************/
CDevDPOST::CDevDPOST() : DtData(MakeClassID(FmDEVICE, GnDATA, CDEVDPST_SpPOST))
{
    /*The object starts life clean*/
    SetDataBitField(0);

    /*Initialize SrcVersion*/
    SetSrcVersion(0);

    /*Intialize the structure*/
    memset(&m_structData, 0, sizeof(m_structData));

    /* Initialize all dynamic pointers to NULL */
    m_SourceID = NULL;
    m_SourceIDSize = 0;

    /* Initialize all record members */
    m_ErrorList = NULL;
    m_ErrorListSize = 0;
    m_ErrorListMaxSize = 0;
    m_ErrorListElements = 0;
    bErrorListMaxSize = FALSE;
}
/*********************************************************************************
  Default destructor
*********************************************************************************/
CDevDPOST::~CDevDPOST()
{
    Reset(TRUE);
}
/*********************************************************************************
Resets all members
*********************************************************************************/
void CDevDPOST::Reset(boolean bResetAll)
{
    TOUCH(bResetAll);

    /*Reset dirty and valid flags*/
    SetDataBitField(0);

    /*Reset SrcVersion*/
    SetSrcVersion(0);

    /*Reset static members*/
    memset(&m_structData, 0, sizeof(m_structData));

    /*Reset Dynamic members*/
    SYS_FREE(m_SourceID);
    m_SourceID = NULL;
    m_SourceIDSize = 0;


    /*Reset Record Container(s)*/
    DeleteErrorList();
}
/*---------------------------------
 Static Members
---------------------------------*/
/*********************************************************************************
 Set function for data member DeviceGUID
*********************************************************************************/
void CDevDPOST::SetDeviceGUID(uint8* pBuf, uint16 Length)
{
    /*Clean out the structure field*/
    memset(m_structData.m_DeviceGUID, 0, sizeof(m_structData.m_DeviceGUID));

    /*Check for Null pointer*/
    if(pBuf != NULL)
    {
        /*Check if there is enough room in the structure field*/
        if((sizeof(uint8)*Length) <= sizeof(m_structData.m_DeviceGUID))
        {
            memcpy(m_structData.m_DeviceGUID, pBuf, (sizeof(uint8)*Length));
        }
    }
}
/*********************************************************************************
 Get function for data member DeviceGUID
*********************************************************************************/
uint8* CDevDPOST::GetDeviceGUID(uint16* pSize)
{
    if(pSize)
    {
        *pSize = (uint16)(sizeof(m_structData.m_DeviceGUID)/sizeof(uint8));
    }
    return (uint8*)m_structData.m_DeviceGUID;
}
/*********************************************************************************
 Set function for data member POSTStatus
*********************************************************************************/
void CDevDPOST::SetPOSTStatus(uint32 new_POSTStatus)
{
    m_structData.m_POSTStatus = new_POSTStatus;
}
/*********************************************************************************
 Get function for data member POSTStatus
*********************************************************************************/
uint32 CDevDPOST::GetPOSTStatus()
{
    return (uint32)m_structData.m_POSTStatus;
}
/*---------------------------------
 Dynamic Members
---------------------------------*/
/*********************************************************************************
 Set function for data member SourceID.
*********************************************************************************/
void CDevDPOST::SetSourceID(ansichar* pBuf, uint16 NumElements)
{
    if(pBuf != NULL)
    {
        /*add a byte for the NULL-TERMINATOR*/
        /*Calculate Size in bytes*/
        m_SourceIDSize = (NumElements+1)*sizeof(ansichar);

        /*Allocate memory for the new Buffer*/
        m_SourceID = (ansichar*)SYS_REALLOC(m_SourceID, m_SourceIDSize);

        if(m_SourceID != NULL)
        {
            /*clear out this data block, including the null terminator*/
            memset(m_SourceID, 0, m_SourceIDSize);

            /*Make a copy of the data*/
            memcpy(m_SourceID, pBuf, m_SourceIDSize-sizeof(ansichar));
        }
    }
    else
    {
        /* If incoming data is NULL then treat it as a clear request */
        m_SourceIDSize = 0;
        SYS_FREE(m_SourceID);
        m_SourceID = NULL;
    }
}
/*********************************************************************************
 Get function for data member SourceID
*********************************************************************************/
ansichar* CDevDPOST::GetSourceID(uint16* pSize)
{
    if((pSize) && (m_SourceIDSize))
    {
        *pSize = (uint16)(m_SourceIDSize/sizeof(ansichar))-1;
    }
    return (ansichar*)m_SourceID;
}
/*********************************************************************************
Initializes the container. Deletes any existing items in the container. The argument
Size will used as the max size limit of the container. A size of zero will be used 
to signify that there is no max size limit.
**********************************************************************************/
boolean CDevDPOST::InitErrorList(uint32 Size)
{
    boolean Result = FALSE;

    /*Delete existing container and
    initialize container's members*/
    DeleteErrorList();

    if(Size)
    {
        /*Allocate memory for the container*/
        m_ErrorList = (uint8*)SYS_REALLOC(m_ErrorList, Size * sizeof(uint8));

        if(m_ErrorList != NULL)
            m_ErrorListMaxSize = Size * sizeof(uint8); /*Size in bytes*/

        bErrorListMaxSize = TRUE;

        Result = TRUE;
    }

    return Result;
}
/*********************************************************************************
Appends an item to the containter. If the max size is specified, then pBuffer 
will be appended only if it doesn't exceed the max size. If no max size is 
specified, then the pBuffer is appended without limit checks. NumberElements
is used to specify number of elements that are in pBuffer.
*********************************************************************************/
boolean CDevDPOST::AppendErrorList(uint8 *pBuffer, uint32 Size, uint16 NumberElements)
{
    boolean Result = FALSE;

    if((pBuffer != NULL) && (Size > 0) && (NumberElements > 0))
    {
        if(bErrorListMaxSize)
        {
            /*Verify that the Size + Current Size is within the max size limit*/
            if (Size + m_ErrorListSize <= m_ErrorListMaxSize)
            {
                /*Copy pBuffer*/
                memcpy(&m_ErrorList[m_ErrorListSize], pBuffer, Size);

                /*Calculate new Size*/
                m_ErrorListSize = m_ErrorListSize + Size;

                /*Increment number of elements*/
                m_ErrorListElements = m_ErrorListElements + NumberElements;

                Result = TRUE;
            }
        }
        /*Append pBuffer without restrictions*/
        else
        {
            m_ErrorList = (uint8*)SYS_REALLOC(m_ErrorList, m_ErrorListSize + Size);

            if(m_ErrorList != NULL)
            {
                /*Copy pBuffer*/
                memcpy(&m_ErrorList[m_ErrorListSize], pBuffer, Size);

                /*Calculate Size*/
                m_ErrorListSize += Size;

                /*Increment number of elements*/
                m_ErrorListElements = m_ErrorListElements + NumberElements;

                Result = TRUE;
            }
        }
    }

    return Result;
}
/*********************************************************************************
Free existing container and initialize to NULL. Initializes container's members.
*********************************************************************************/
void CDevDPOST::DeleteErrorList()
{
    SYS_FREE(m_ErrorList);
    m_ErrorList = NULL;
    m_ErrorListMaxSize = 0;
    m_ErrorListSize = 0;
    m_ErrorListElements = 0;
    bErrorListMaxSize = FALSE;
}
/*********************************************************************************
Return pointer to serialized object at Index
*********************************************************************************/
uint8* CDevDPOST::GetErrorListAt(uint16 Index, uint32 *pSize)
{
    if((pSize != NULL) && (m_ErrorList != NULL) && (Index <= m_ErrorListElements))
    {
        uint8  pTempSize = 0;
        uint8* pBuffer = m_ErrorList;

        for(unsigned int i = 0; i < m_ErrorListElements; i++)
        {
            /*Get size of serialized object*/
            *pSize = MOIBSerialSize(pBuffer, &pTempSize);

            if(i == Index)
                return pBuffer;
            else
               /*Increment pBuffer*/
               pBuffer += *pSize;
        }
    }

    return NULL;
}
/*********************************************************************************
Return pointer to the container
*********************************************************************************/
uint8* CDevDPOST::GetErrorList(uint32 *pSize)
{
    if((pSize != NULL) && (m_ErrorListSize))
    {
        *pSize = m_ErrorListSize;
        return m_ErrorList;
    }

    return NULL;
}
/*================================================================================
    INHERITED / OVERIDDEN
================================================================================*/
/*********************************************************************************
Returns the version of the object. 
*********************************************************************************/
uint16 CDevDPOST::getVersion (void)
{
    return (uint16)CDEVDPST_OBJECT_VERSION;
}
/*********************************************************************************
Returns the number of Bytes that would be used by the serialize_payload and
deserialize_payload methods.
*********************************************************************************/
uint32 CDevDPOST::get_payload_size (void)
{
    uint32 Size = 0;
    Size = sizeof(uint16)                /*Object Version*/
            + sizeof(byte)                /*is dirty flag*/
            + sizeof(uint16)                /*Size of the struct*/
            + (uint16)CDEVDPST_STATIC_STRUCT_SIZE;    /*struct data size*/

    /* Get the size of each dynamic member */
    Size += sizeof(uint16) + m_SourceIDSize;

    /*m_ErrorListElements*/
    Size += sizeof(uint16);

    /*Container Buffer*/
    Size += m_ErrorListSize;

    Size += sizeof(uint16);            /* CRC bytes */

    return Size;
}
/*********************************************************************************
Serialize the static data defined by m_structData.
*********************************************************************************/
void CDevDPOST::serialize_static_data(uint8QManager * QMgr)
{
    /* Enqueue only the  members of the Struct.*/
    unsigned int index = 0;

    for(index = 0; index < sizeof(m_structData.m_DeviceGUID)/sizeof(uint8); index++)
    {
        QMgr->put(m_structData.m_DeviceGUID[index]);
    }
    QMgr->put(m_structData.m_POSTStatus);
}
/*********************************************************************************
Deserialize the static data defined by m_structData.
*********************************************************************************/
void CDevDPOST::deserialize_static_data(uint8QManager *QMgr, uint16 StructSize)
{
    /* Dequeue only the  members of the Struct.*/
    unsigned int index = 0;

    if((StructSize) &&
       (CDEVDPST_VERSION_STATUS(CDEVDPST_DeviceGUID)))
    {
        for(index = 0; index < sizeof(m_structData.m_DeviceGUID)/sizeof(uint8); index++)
        {
            QMgr->get(&m_structData.m_DeviceGUID[index]);
            StructSize -= sizeof(uint8);
        }
    }
        if((StructSize) &&
           (CDEVDPST_VERSION_STATUS(CDEVDPST_POSTStatus)))
        {
            QMgr->get(&m_structData.m_POSTStatus);
            StructSize -= sizeof(uint32);
        }
}
/*********************************************************************************
Used to place the data elements of the object into a circular queue. This
excludes the class identifier.
*********************************************************************************/
boolean CDevDPOST::serialize_payload (uint8QManager * QMgr)
{
    uint16    Version = getVersion();
    uint32    index = 0;
    byte      *TailPtr;
    uint32    CRCLen;

    /* Save the start of the byte stream for calculating the CRC */
    TailPtr = (byte*)(QMgr->GetTailPtr());

    /* Enqueue the version */
    QMgr->put(Version);

    /* Enqueue the dirty State*/
    QMgr->put(GetDataBitField());

    /* Enqueue the Static Structure Size */
    QMgr->put((uint16)CDEVDPST_STATIC_STRUCT_SIZE);

    /* Enqueue only the static members of the Struct */
    serialize_static_data(QMgr);

    /* Enqueue variable sized members and their sizes */

    QMgr->put((uint16)m_SourceIDSize);
    if(m_SourceID != NULL)
    {
        for(index = 0; index < (m_SourceIDSize/sizeof(ansichar)); index++)
        {
            QMgr->put((byte)m_SourceID[index]);
        }
    }

    /* Serialize the m_ErrorList */
    QMgr->put(m_ErrorListElements);
    if(m_ErrorList != NULL)
    {
        QMgr->enqueue_array((byte*)m_ErrorList, m_ErrorListSize);
    }

    /* Enqueue the CRC */
    CRCLen = QMgr->get_num_elements() - sizeof(uint16);
    QMgr->put(CalculateCRC(TailPtr,CRCLen));

    return TRUE;
}

/*********************************************************************************
Used to deserialize the data elements of the object from a circular queue. This
excludes the class identifier.
*********************************************************************************/
boolean CDevDPOST::deserialize_payload (uint8QManager * QMgr, uint32 Sz)
{
    /*These data pieces will need to be dequeued*/
    byte      BitField; 
    uint16    Version; 
    uint16    Size = 0; 
    byte      *pHeadPtr;
    uint32    index = 0;
    uint16    CalcCRC;
    uint16    StoredCRC;
    uint32    CRCSize;
    boolean   bResult = FALSE;

    /* Save the start of the byte stream for calculating the CRC */
    pHeadPtr = (byte*)(QMgr->GetHeadPtr());

    /* Calculate the CRC using just the payload and not the CRC Bytes*/
    CRCSize = QMgr->get_num_elements() - sizeof(uint16);
    CalcCRC = CalculateCRC(pHeadPtr, CRCSize);

    /* Index into the byte array to retrieve the stored CRC */
    StoredCRC = ReadInt16(&pHeadPtr[CRCSize]);

    /* Compare the Calculated and Stored CRC */
    if(CalcCRC == StoredCRC)
    {
        /* Dequeue the version */
        QMgr->get(&Version);

        if(Version <= CDEVDPST_OBJECT_VERSION)
        {
            /* Store the dequeued version */
            SetSrcVersion(Version);

            /* Dequeue the dirty State */
            QMgr->get(&BitField);

            SetDataBitField(BitField);

            /* Dequeue the static member struct size */
            QMgr->get(&Size);

            /* Dequeue only the static members of the Struct */
            if(Size <= (uint16)CDEVDPST_STATIC_STRUCT_SIZE)
            {
                deserialize_static_data(QMgr, Size);
#if defined(DEBUG_PRINT)
                if(Size < (uint16)CDEVDPST_STATIC_STRUCT_SIZE)
                {
                    SYS_PRINTF("\nThe source object is smaller than the destination. Some source data will be lost.\n\n");
                }
#endif
            }
            else
            {
                uint8   *NewBuffer;
                NewBuffer = (uint8*)SYS_MALLOC(Sz);

                if(NewBuffer != NULL)
                {
                    deserialize_static_data(QMgr, (uint16)Sz);
#if defined(DEBUG_PRINT)
                    SYS_PRINTF("\nThe Source object is larger than the destination. Some destination data will not be intialized.\n\n");
#endif
                    /* Dequeue the remaining extra bytes of the static struct */
                    QMgr->dequeue_array(NewBuffer, Size - CDEVDPST_STATIC_STRUCT_SIZE);

                    SYS_FREE(NewBuffer);
                }
            }

            if(((QMgr->get_num_used()) > 2) &&
                (CDEVDPST_VERSION_STATUS(CDEVDPST_SourceID)))
            {
                QMgr->get(&m_SourceIDSize);
                if(m_SourceIDSize > 0)
                {
                    /*Allocate memory for the new Buffer*/
                    m_SourceID = (ansichar*)SYS_REALLOC(m_SourceID, m_SourceIDSize);

                    if(m_SourceID != NULL)
                    {
                        for(index = 0; index < (m_SourceIDSize/sizeof(ansichar)); index++)
                        {
                            QMgr->get((byte*)&m_SourceID[index]);
                        }
                    }
                }
                else
                {
                    SYS_FREE(m_SourceID);
                    m_SourceID = NULL;
                }
            }

            if(((QMgr->get_num_used()) > 2) &&
                (CDEVDPST_VERSION_STATUS(CDEVDPST_ErrorList)))
            {
                uint16 TempElements = 0;

                /* Get the m_ErrorListElements */
                QMgr->get(&TempElements);

                if (TempElements > 0)
                {
                    uint8 pSize = 0;
                    uint8* pBuffer = NULL; 
                    uint32 TempSize = 0;
                    unsigned i = 0;

                    pBuffer = (uint8*)QMgr->GetTailPtr();

                    /* Calculate the m_ErrorList size */
                    for(i = 0; i < TempElements; i++)
                    {
                        /*Extract the serialized object's size*/
                        TempSize = MOIBSerialSize(pBuffer, &pSize);

                        /*Increment pBuffer*/
                        pBuffer += TempSize;

                        /*Increment the max size*/
                        m_ErrorListMaxSize += TempSize;
                    }

                    /*Initialize the container with new max size*/
                    if(InitErrorList(m_ErrorListMaxSize))
                    {
                        /*Dequeue entire container*/
                        QMgr->dequeue_array((byte*)m_ErrorList, m_ErrorListMaxSize);
                        m_ErrorListSize = m_ErrorListMaxSize;
                        m_ErrorListElements = TempElements;
                    }
                }
                else
                {
                    /*Delete container*/
                    DeleteErrorList();
                }
            }

            bResult = TRUE;
        }
    }

    if(bResult == FALSE)
    {
        Reset(TRUE);
    }

    return bResult;
}
#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Writes the object into an XML file pointed to by the fhnd. Returns the number of
Bytes written into the file.
*********************************************************************************/
uint32 CDevDPOST::serialize_to_XMLbuf(char *pBuf)
{
    char Buffer[XML_BUFSIZE];
    char *Output = Buffer;
    uint32 NewSize   = 0;
    uint32 FinalSize = 0;
    uint32 ZeroSize  = 0;
    uint32 *pSizeCount = &ZeroSize;
    uint32 index = 0;
    ansichar GUIDOutput[GUID_STR_SIZE];
    char *pEnumName = NULL;

    /* If pBuf is NULL, then we don't write anything to it, and just 
    return the potential size */
    if(pBuf != NULL)
    {
        Output = pBuf;
        pSizeCount = &NewSize;
    }

    NewSize = sprintf(Output,
            /*XML formatted Output to file*/
            "<DEFINITION class=\"CDevDPOST\" version=\"%d\" "
                        "family=\"%d\" genus=\"%d\" species=\"%d\">\n",
            /*---------------------------------------------------------------*/
            /*Data for the related types above.
            uint16 representation Version*/
            getVersion(),
            family(),
            genus(),
            species());

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            /*---------------------------------------------------------------*/
            /* -- GUID array --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" name=\"DeviceGUID\" size=\"16\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%s]]></VALUE>\n", GUIDToStr(m_structData.m_DeviceGUID, GUIDOutput, sizeof(m_structData.m_DeviceGUID)));
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- ansichar pointer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"ansichar\" size=\"UNBOUNDED\" name=\"SourceID\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(m_SourceID)
            {
                NewSize = sprintf(Output, "%s", m_SourceID);
                FinalSize += NewSize;
                Output += *pSizeCount;
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"POSTStatus\" minversion=\"200\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", m_structData.m_POSTStatus);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Serialize m_ErrorList Buffer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"OBJECT\" class=\"ANY_CLASS\" size=\"UNBOUNDED\" name=\"ErrorList\" minversion=\"200\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE>");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if((m_ErrorList != NULL) && (m_ErrorListSize))
            {
                for(index = 0; index < m_ErrorListSize/sizeof(uint8); index++)
                {
                    NewSize = sprintf(Output, "%u;", m_ErrorList[index]); 
                    FinalSize += NewSize;
                    Output += *pSizeCount;
                }

            }

            NewSize = sprintf(Output, "</VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Write the closing members tag*/
            NewSize = sprintf(Output, "</MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(IsValidEnum((MsgEntry*)TypPOSTStatusTbl,
                        CDEVDPST_TYPPOSTSTATUSTBL_SIZE,
                        m_structData.m_POSTStatus))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"POSTStatus\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_POSTStatus)
                {
                    case 0:
                        pEnumName = "POSTSTATUS_NONE";
                        break;
                    case 1:
                        pEnumName = "POSTSTATUS_IN_PROGRESS";
                        break;
                    case 2:
                        pEnumName = "POSTSTATUS_COMPLETE";
                        break;
                    case 3:
                        pEnumName = "POSTSTATUS_FAILURE";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_POSTStatus);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CDEVDPST_POSTSTATUS_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            /*---------------------------------------------------------------*/

            /*Write the closing definition tag*/
            NewSize = sprintf(Output, "</DEFINITION>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

    return FinalSize+1;
}
#endif  /* #if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) */
#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
  The XML Parser makes a callback to this function whenever it encounters a start
  tag for an element. This function checks the string value of that element tag to
  decide what data it holds. It then sets the variable CurrentParsePos to point 
  at the data member corresponding with the tag string value. This CurrentParsePos 
  is used later by the parse_CharacterData() function to determine where the data 
  retrieved by parse_CharacterData() should be placed. 

  It also increments the DepthPtr for the current XML file. This value describes 
  the depth of the currently processed node.

 Ex: DepthPtr = 3:
 1 |-> <TAG1>
 2 |----> <TAG2>
 3 |-------> <TAG3>This element is 3 deep</TAG3>
          </TAG2>
      </TAG1>
*********************************************************************************/
void CDevDPOST::parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts)
{
    TOUCH(Atts);
    XMLParserData *ParserData = (XMLParserData*)UserData;

    /*Increment DepthPtr to track node depth*/
    uint32 *DepthPtr = &ParserData->Depth;
    *DepthPtr += 1;

    if(!validXMLParseFlag)
        return;

#if(DEBUG_PRINT)
    /*Debug information that will print to terminal screen
     *Prints tabspaces matching the DepthPtr, the name of 
     *element tag, and then...(onto parse_CharacterData)*/
    uint32 i;
    fputc('\n', stderr);
    for(i = 0; i < *DepthPtr; i++) fputc('\t', stderr);
    fprintf(stderr, "%-16s", Name);
#endif

    /* This area checks the current encountered tag. if it matches one that was
     * written in the serialize_to_XMLfile() function, then check its attributes
     * and attribute values */
    if((!strcmp("DEFINITION", Name)) && (GetClassAttr() == NULL))
    {
        while (*Atts)
        {
            /*As we parse the XML data, we check to see if the Family, 
             *Genus and Species match the current object. If they do not, 
             *we set validXMLParseFlag to FALSE. This will stop the parser 
             *from handling the additional data, and clear any data 
             *already in our structure.*/
            if(!strcmp(*Atts, "family"))
            {
                if(family() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "genus"))
            {
                if(genus() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "species"))
            {                                     
                if(species() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "version"))
            {
                SrcVersion = (uint16)atol(*++Atts);
                Atts++;
            }
            else Atts += 2;
        }
    }
    /*---------------------------------------------------------------*/
    else if (!strcmp("MEMBER", Name) && (GetClassAttr() == NULL))
    {
        /*Loop through the MEMBER attributes and
         *extract the attribute values*/
        while (*Atts)
        {
            if(!strcmp(*Atts, "name"))
            {
                Atts++;
                if(!strcmp(*Atts, "DeviceGUID"))
                {
                    CurrentParsePos = (void*)&m_structData.m_DeviceGUID;
                }
                else if(!strcmp(*Atts, "POSTStatus"))
                {
                    CurrentParsePos = (void*)&m_structData.m_POSTStatus;
                }
                else if(!strcmp(*Atts, "SourceID"))
                {
                    CurrentParsePos = (void*)&m_SourceID;
                }
                else if(!strcmp(*Atts, "ErrorList"))
                {
                    CurrentParsePos = (void*)&m_ErrorList;
                }
                Atts++;
            }
            else Atts += 2;
        }
    }
    /*---------------------------------------------------------------*/
}
#endif/*TARGET_XML_SUPPORT*/

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
XML HELPER FUNCTION
  The XML Parser makes a callback to this function whenever it encounters
  character data after a start tag. This function also uses CurrentParsePos. This
  CurrentParsePos value has been set previously by the parse_StartElement
  function
*********************************************************************************/
void CDevDPOST::parse_CharacterData(void *UserData, const XML_Char *sTag, int Len)
{
    TOUCH(UserData);
    TOUCH(sTag);
    TOUCH(Len);

    int i = 0;
    XML_Char *pBufStart;
    XML_Char *pBuf;

    /*Check to see if CurrentParsePos is NULL or points to something,
     *and if validXMLParseFlag is still true. If CurrentParsePos is
     *NULL, then this means we have encountered an element tag with 
     *no internal character data, and we pass it.*/
    if((CurrentParsePos && validXMLParseFlag) && (*sTag != '\n'))
    {
        if(CurrentParsePos == (void*)(&m_structData.m_DeviceGUID))
        {
            StrToGuid((char*)sTag, (uint16)Len, m_structData.m_DeviceGUID, sizeof(m_structData.m_DeviceGUID));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_POSTStatus))
        {
            SetPOSTStatus((uint32)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_SourceID))
        {
            SetSourceID((ansichar*)sTag, (uint16)Len);
        }
        else if(CurrentParsePos == (void*)(&m_ErrorList))
        {
            boolean bResult    = FALSE;
            uint8 *pTempBuffer = NULL;
            uint32 NumElements = 0;

            /*Calc Array Length*/
            NumElements = CalcArrayLength(sTag, Len);
            if(NumElements > 0)
            {
                pTempBuffer = (uint8*)SYS_MALLOC(NumElements);

                if(pTempBuffer != NULL)
                {
                    for(pBuf = (XML_Char*)sTag, pBufStart = (XML_Char*)sTag, i = 0; pBuf < sTag + Len; pBuf++)
                    {
                        if(*pBuf == ';')
                        {
                            pTempBuffer[i] = (uint8)atol(pBufStart);
                            pBufStart = pBuf+1;
                            i++;
                        }
                    }

                    if(InitErrorList(NumElements) == TRUE)
                    {
                        bResult = AppendErrorList(pTempBuffer, NumElements, MOIBSerialElements(pTempBuffer, NumElements));
                    }
                }

                SYS_FREE(pTempBuffer);
            }

            if(bResult == FALSE)
            {
                DeleteErrorList();
            }
        }
        /*---------------------------------------------------------------*/
#if(DEBUG_PRINT)
        /*(from parse_StartElement)...picks up from the start
         *element and prints the value following it*/
        fprintf(stderr, " = %s", sTag);
        if(!validXMLParseFlag)
            fprintf(stderr, " - Invalid Data: Stopping parse");
#endif
    }
}
#endif /*TARGET_XML_SUPPORT*/

/*================================================================================
Helper function for setting default values for the test functions
================================================================================*/
void CDevDPOST::SetObjectProperties(CDevDPOST *MyObjectSrc)
{/*Start SetObjectProperties()*/

    TOUCH(MyObjectSrc);
    /*
        MyObjectSrc->SetDeviceGUID();
        MyObjectSrc->SetPOSTStatus();
        MyObjectSrc->SetSourceID();
    */

}/*End SetObjectProperties()*/

/*================================================================================
CDEVDPOST_TEST_MAIN
================================================================================*/
#if defined(CDEVDPOST_TEST_MAIN)

FILE   *Stream;
uint8  *Buffer;
uint32 Size;
uint32 i;
int    Result, TestID;

CDevDPOST *MyObjectSrc = new CDevDPOST();
CDevDPOST *MyObjectDest = new CDevDPOST();

void XML_test();
void Serialize_All_test();

#if defined(_WIN32_WCE)
#if defined(_WCE_CONSOLE)
int WinEntry (void *Args)
{
    _newprintf = ((formatter*)Args)[0];
    _newscanf = ((formatter*)Args)[1];

#else
int WINAPI WinMain(HINSTANCE  hInstance,
                    HINSTANCE  hPrevInstance,
                    LPTSTR     lpCmdLine,
                    int  nCmdShow)
{
#endif
#else
int main(void)
{
#endif /*_WIN32_WCE*/

    SYS_PRINTF("1. Transfer XML from source object-->destination object.\n");
    SYS_PRINTF("2. Transfer complete byte stream: source object-->destination object.\n");
    SYS_PRINTF("Selection:");

    Result = scanf("%d", &TestID);

    MyObjectSrc->SetObjectProperties(MyObjectSrc);

    if(TestID == 1) XML_test();
    else if(TestID == 2)  Serialize_All_test();
    else{
        SYS_PRINTF("\n\nInvalid Selection.\n\n");
    }

    SYS_PRINTF("\n\nPress any character key and hit enter to continue.\n");
    Result = scanf("%d", &TestID);

    return 0;
}
/*================================================================================
Helper function for writing a byte Stream to a file
================================================================================*/
void WriteToFile(char *Buf, uint32 Size, char *Filename)
{
    FILE    *Fp;
    size_t  Bytes;

    if((Fp  = fopen(Filename, "w+b")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", Filename);
    }

    Bytes = fwrite(Buf, 1, Size, Fp);

    if(Bytes != Size)
    {
        SYS_PRINTF("Error: %d out of %d written to file %s\n", Bytes, strlen(Buf), Filename);
    }
    else
    {
        SYS_PRINTF("%s created\n", Filename);
    }

    if(fclose(Fp))
    {
        SYS_PRINTF("The file %s was not closed\n", Filename);
    }
}
/*================================================================================
Helper function for comparing the two generated xml files.
================================================================================*/
void CompareFiles(char *File1, char *File2)
{
    fpos_t    Pos;
    size_t    SrcLen;
    size_t    DestLen;
    FILE      *Fp1, *Fp2;
    char      *SrcBuf = NULL;
    char      *DestBuf = NULL;

    if((Fp1  = fopen(File1, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File1);
    }

    if((Fp2  = fopen(File2, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File2);
    }

    /*Get the current position of the file Stream*/
    fgetpos(Fp1, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp1, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    SrcLen = size_t(ftell(Fp1) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp1, &Pos);

    SrcBuf = (char*)SYS_REALLOC(SrcBuf, SrcLen);

    SrcLen = fread(SrcBuf, 1, SrcLen, Fp1);

    /*Get the current position of the file Stream*/
    fgetpos(Fp2, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp2, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    DestLen = size_t(ftell(Fp2) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp2, &Pos);

    DestBuf = (char*)SYS_REALLOC(DestBuf, DestLen);
    DestLen = fread(DestBuf, 1, DestLen, Fp2);

    if(DestLen == SrcLen)
    {
        for(i = 0; i < DestLen; i++)
        {
            if(DestBuf[i] != SrcBuf[i])
            {
                SYS_PRINTF("File mismatch at i=%d\n", i);
                break;
            }
        }
        if(i == DestLen)
            SYS_PRINTF("%s and %s comparison - PASSED!!!\n", File1, File2);
    }
    else
    {
        SYS_PRINTF("Error - File size mismatch\n");
    }

    if(fclose(Fp1))
    {
        SYS_PRINTF("The file %s was not closed\n",File2);
    }
    if(fclose(Fp2))
    {
        SYS_PRINTF("The file %s was not closed\n", File2);
    }

    SYS_FREE(SrcBuf);
    SYS_FREE(DestBuf);
}
/*================================================================================
XML_test
================================================================================*/
void XML_test()
{
    char   *XMLBuffer = NULL;
    uint32 BufferSize;

    if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = MyObjectSrc->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectSrc->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    /*Delete MyObjectSrc*/
    delete MyObjectSrc;

    /*Close the file*/
    if(fclose(Stream)) 
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    if((Stream  = fopen("XML_SerializeSrc.xml", "rb")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    fpos_t     Pos;

    /*Get the current position of the file Stream*/
    fgetpos(Stream, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Stream, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    BufferSize = (uint32)size_t(ftell(Stream) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Stream, &Pos);

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Return the bytes read in the file Stream to XMLBuffer*/
            fread(XMLBuffer, 1, BufferSize, Stream);

            /*Deserialize the XMLBuffer into MyObjectDest*/
            BufferSize = MyObjectDest->deserialize_from_XMLbuf(XMLBuffer, BufferSize);
        }
    }

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }
    if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
    }

    /*Get the size of MyObjectDest in an XML stream*/
    BufferSize = MyObjectDest->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectDest->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream,"</CMOIBObj>");

    /*Delete MyObjectDest*/
    delete MyObjectDest;

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
    }

    /*Compare the created XML files*/
    CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");

#endif
    /*Free Buffers*/
    SYS_FREE(XMLBuffer);
}
/*================================================================================
Serialize All
================================================================================*/
void Serialize_All_test()
{
    char    *XMLBuffer   = NULL;
    uint8   *ByteBuffer  = NULL;
    uint32  BufferSize;
    fpos_t  Pos;

    if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = MyObjectSrc->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectSrc->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    /*Get the size of MyObjectSrc*/
    Size = MyObjectSrc->size_all();

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_MALLOC(Size);

    /*Serialize MyObjectSrc*/
    MyObjectSrc->serialize_all(ByteBuffer);

    /*Write the serialized ByteBuffer into the Serialize_AllSrc.bytestream file*/
    WriteToFile((char*)ByteBuffer, Size, "Serialize_AllSrc.bytestream");

    /*Delete MyObjectSrc*/ 
    delete MyObjectSrc;

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }

    if((Stream  = fopen("Serialize_AllSrc.bytestream", "rb+")) == NULL) 
    {
        SYS_PRINTF("The file Serialize_AllSrc.bytestream was not opened\n");
    }

    /*Get the current position of the file Stream*/
    fgetpos(Stream, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Stream, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    BufferSize = (uint32)size_t(ftell(Stream) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Stream, &Pos);

    if(BufferSize)
    {
        ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
        if(ByteBuffer != NULL)
        {
            /*Return the bytes read in the file Stream to ByteBuffer*/
            fread(ByteBuffer, 1, BufferSize, Stream);

            /*Deserialize the ByteBuffer into MyObjectDest*/
            BufferSize = MyObjectDest->deserialize_all((uint8*)ByteBuffer);
        }
    }

    if(fclose(Stream))
    {
        SYS_PRINTF("The file Serialize_AllSrc.bytestream was not closed\n");
    }

    if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
    }

    /*Get the size of MyObjectDest in an XML stream*/
    BufferSize = MyObjectDest->size_XML();

    /*Print start tag of XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectDest in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectDest->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
    }

    /*Get the size of MyObjectDest*/
    Size = MyObjectDest->size_all();

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, Size);

    /*Serialize MyObjectDest*/
    MyObjectDest->serialize_all(ByteBuffer);

    /*Write the serialized ByteBuffer into the Serialize_AllDest.bytestream file*/
    WriteToFile((char*)ByteBuffer, Size, "Serialize_AllDest.bytestream");

    /*Delete MyObjectDest*/ 
    delete MyObjectDest;

    /*Free buffers*/
    SYS_FREE(XMLBuffer);
    SYS_FREE(ByteBuffer);

    /*Compare created XML files and bytestream files*/
    CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");
    CompareFiles("Serialize_AllSrc.bytestream", "Serialize_AllDest.bytestream");
}
#endif /*#if defined(CDEVDPOST_TEST_MAIN)*/
/* ---------------------------End of DataClass CDevDPOST -------------------------------- */
