/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDevDPOST.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CDEVDPOST_H)
    #define  CDEVDPOST_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CDEVDPST_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVDPSTtypPOSTSTATUS {
        CDEVDPST_POSTStatus_NONE = 0, /*NONE*/
        CDEVDPST_POSTStatus_IN_PROGRESS = 1, /*POST In Progress*/
        CDEVDPST_POSTStatus_COMPLETE = 2, /*POST Complete Successfully*/
        CDEVDPST_POSTStatus_FAILURE = 3, /*POST Failure*/
        CDEVDPST_POSTStatus_MAX
    } CDEVDPST_POSTSTATUS;

    typedef  enum CDEVDPSTtypSPECIES {
        CDEVDPST_SpPOST = 3, 
        CDEVDPST_SpMAX
    } CDEVDPST_SPECIES;

#define CDEVDPST_POSTSTATUS_STRING \
    (GetMsgString((MsgEntry*)TypPOSTStatusTbl, \
                 CDEVDPST_TYPPOSTSTATUSTBL_SIZE, \
                 m_structData.m_POSTStatus))

#define CDEVDPST_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CDEVDPST_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CDevDPOST Member's Version Enumerations*/
    typedef  enum CDEVDPSTtypVERSIONS {
        CDEVDPST_DeviceGUID,
        CDEVDPST_SourceID,
        CDEVDPST_POSTStatus,
        CDEVDPST_ErrorList,
        CDEVDPST_MEMBER_MAX
    } CDEVDPST_VERSIONS;

#define CDEVDPST_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CDEVDPST_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CDEVDPOST_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CDEVDPOST_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CDEVDPOST_DLLAPI  __declspec(dllimport)
    #else
        #define CDEVDPOST_DLLAPI
    #endif
#endif

class CDEVDPOST_DLLAPI CDevDPOST : public DtData
{
public:
    CDevDPOST();
    ~CDevDPOST();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint8* GetDeviceGUID(uint16* pSize);
    void SetDeviceGUID(uint8* pBuf, uint16 Length);

    uint32 GetPOSTStatus();
    void SetPOSTStatus(uint32 new_POSTStatus);

    ansichar* GetSourceID(uint16* pSize);
    void SetSourceID(ansichar* pBuf, uint16 NumElements);

    boolean    InitErrorList(uint32 Size);
    boolean    AppendErrorList(uint8 *pBuffer, uint32 Size, uint16 NumberElements);
    void       DeleteErrorList(void);
    uint8      *GetErrorListAt(uint16 Index, uint32 *pSize);
    uint8      *GetErrorList(uint32 *pSize);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CDevDPOST *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint8         m_DeviceGUID[16]; /* Contains the GUID of the Device */
            uint32        m_POSTStatus; /* Indicates the POST status */
    }ClassStruct_t;

#define CDEVDPST_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 16 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    ansichar          *m_SourceID; /* Contains the SourceID of the Device */
    uint16            m_SourceIDSize;
    /*Record Data*/
    uint8    *m_ErrorList;
    uint32   m_ErrorListSize;
    uint32   m_ErrorListMaxSize;
    uint16   m_ErrorListElements;
    boolean  bErrorListMaxSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypPOSTStatusTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CDEVDPOST_H) */

/*---------------------------------------------------*/
/* End of File */
