/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDevPMsgArguments.h                                               //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CDEVPMSGARGUMENTS_H)
    #define  CDEVPMSGARGUMENTS_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CDEVPARG_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVPARGtypDEVICEMODE {
        CDEVPARG_DeviceMode_NONE = 0, /*None specified*/
        CDEVPARG_DeviceMode_POWER_UP = 1, /*Power-up (Software reset)*/
        CDEVPARG_DeviceMode_NORMAL = 2, /*Measurement (Normal) mode*/
        CDEVPARG_DeviceMode_STANDBY = 3, /*Standby mode*/
        CDEVPARG_DeviceMode_CALIBRATION = 4, /*Calibration mode*/
        CDEVPARG_DeviceMode_SERVICE = 5, /*Service (Software Download) mode*/
        CDEVPARG_DeviceMode_MAX
    } CDEVPARG_DEVICEMODE;

    typedef  enum CDEVPARGtypSPECIES {
        CDEVPARG_SpMSG_ARGUMENTS = 0, /*Indicates that the object is a message argument rather than a result.*/
        CDEVPARG_SpRESULT = 1, /*Indicates that the object is a Result rather than a message argument. Used with CDevPMsgArguments objects in PUT_DIGITAL_STATE messages*/
        CDEVPARG_SpMAX
    } CDEVPARG_SPECIES;

#define CDEVPARG_DEVICEMODE_STRING \
    (GetMsgString((MsgEntry*)TypDeviceModeTbl, \
                 CDEVPARG_TYPDEVICEMODETBL_SIZE, \
                 m_structData.m_DeviceMode))

#define CDEVPARG_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CDEVPARG_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CDevPMsgArguments Member's Version Enumerations*/
    typedef  enum CDEVPARGtypVERSIONS {
        CDEVPARG_SpeciesSelector,
        CDEVPARG_IOParameterA,
        CDEVPARG_MEMBER_MAX
    } CDEVPARG_VERSIONS;

#define CDEVPARG_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CDEVPARG_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CDEVPMSGARGUMENTS_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CDEVPMSGARGUMENTS_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CDEVPMSGARGUMENTS_DLLAPI  __declspec(dllimport)
    #else
        #define CDEVPMSGARGUMENTS_DLLAPI
    #endif
#endif

class CDEVPMSGARGUMENTS_DLLAPI CDevPMsgArguments : public DtData
{
public:
    CDevPMsgArguments();
    ~CDevPMsgArguments();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint32 GetSpeciesSelector();
    void SetSpeciesSelector(uint32 new_SpeciesSelector);

    uint32 GetIOParameterA();
    void SetIOParameterA(uint32 new_IOParameterA);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CDevPMsgArguments *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_SpeciesSelector; /* Species ID of the device requested. */
            uint32        m_IOParameterA; /* IO parameter for device message. */
    }ClassStruct_t;

#define CDEVPARG_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 2 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypDeviceModeTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CDEVPMSGARGUMENTS_H) */

/*---------------------------------------------------*/
/* End of File */
