/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrEStd.cpp                                                      //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#include "CErrEStd.h"

const MsgEntry CErrEStd::TypAppErrorTbl[] = {
    CERR_APP_NONE  , "NO_DESCRIPTION",
    CERR_APP_POST_FPROM , "NO_DESCRIPTION",
    CERR_APP_POST_SRAM , "NO_DESCRIPTION",
    CERR_APP_POST_EE_FACTORY , "NO_DESCRIPTION",
    CERR_APP_POST_EE_USER , "NO_DESCRIPTION",
    CERR_APP_POST_ADC , "NO_DESCRIPTION",
    CERR_APP_POST_SENSOR , "NO_DESCRIPTION",
    CERR_APP_POST_PRINTER , "NO_DESCRIPTION",
    CERR_APP_POST_RTC , "NO_DESCRIPTION",
    CERR_APP_POST_NO_CAL , "NO_DESCRIPTION",
    CERR_APP_POST_CAL_BAD , "NO_DESCRIPTION",
    CERR_APP_POST_VALVE , "NO_DESCRIPTION",
    CERR_APP_POST_HIGH , "NO_DESCRIPTION",
    CERR_APP_POST_LOG , "NO_DESCRIPTION",
    CERR_APP_POST_EE_PATIENTDATA , "NO_DESCRIPTION",
    CERR_APP_POST_MAX , "NO_DESCRIPTION",
    CERR_APP_POST_ERROR_CHECK , "NO_DESCRIPTION",
    CERR_APP_POST_NOT_RDY , "NO_DESCRIPTION",
    CERR_APP_WRITE_FAILED , "NO_DESCRIPTION",
    CERR_APP_ERASE_FAILED , "NO_DESCRIPTION",
};

#define CERR_TYPAPPERRORTBL_SIZE \
    (sizeof(TypAppErrorTbl)/sizeof(TypAppErrorTbl[0]))

const MsgEntry CErrEStd::TypStackErrorTbl[] = {
    CERR_NONE , "No Error",
    CERR_INVL_FAMILY, "Invalid Family",
    CERR_INVL_GENUS, "Invalid Genus",
    CERR_INVL_SPECIES, "Invalid Species",
    CERR_OBJECT_ID, "Object ID Mismatch",
    CERR_CRC_MISMATCH, "CRC Mismatch",
    CERR_INVL_TBL_ENTRY, "Invalid Entry",
    CERR_DUP_ENTRY, "Duplicate entry",
};

#define CERR_TYPSTACKERRORTBL_SIZE \
    (sizeof(TypStackErrorTbl)/sizeof(TypStackErrorTbl[0]))

const MsgEntry CErrEStd::TypMsgProcErrorTbl[] = {
    CERR_PROC_NONE , "No Error",
    CERR_PROC_UNIMPL, "Unimplemented",
    CERR_PROC_UNSUPPORTED, "Unsupported",
    CERR_PROC_MEMORY, "No memory",
    CERR_PROC_NO_PARAM, "No parameter",
    CERR_PROC_INVL_PARAM, "Invalid parameter",
    CERR_PROC_INVL_PARAM_RANGE, "Range error",
    CERR_PROC_NO_OBJECT, "No object",
    CERR_PROC_OBJECT_DESERIALIZE, "Deserialization",
    CERR_PROC_OBJECT_SERIALIZE, "Serialization",
    CERR_PROC_CONTEXT, "Context error",
    CERR_PROC_ITEM_NOT_AVAILABLE, "Item does not exist"
};

#define CERR_TYPMSGPROCERRORTBL_SIZE \
    (sizeof(TypMsgProcErrorTbl)/sizeof(TypMsgProcErrorTbl[0]))

const MsgEntry CErrEStd::TypSpeciesTbl[] = {
    CERR_SpERRNONE , "NO_DESCRIPTION",
    CERR_SpERRWACPSTACK, "NO_DESCRIPTION",
    CERR_SpERRMSGPROC, "NO_DESCRIPTION",
    CERR_SpERRAPPINTERNAL, "NO_DESCRIPTION",
};

#define CERR_TYPSPECIESTBL_SIZE \
    (sizeof(TypSpeciesTbl)/sizeof(TypSpeciesTbl[0]))

const VersionEntry CErrEStd::TypVersionsTbl[] = {
    100, 100, /*CERRESTD_ErrClassID*/
    100, 100, /*CERRESTD_ErrorCode*/
    100, 100, /*CERRESTD_Description*/
    100, 100, /*CERRESTD_Data*/
};

/*================================================================================
    CONSTRUCTORS / DESTRUCTORS
================================================================================*/
/*********************************************************************************
  Default constructor
*********************************************************************************/
CErrEStd::CErrEStd() : DtData(MakeClassID(FmERROR, GnERROR, CERR_SpERRNONE))
{
    /*The object starts life clean*/
    SetDataBitField(0);

    /*Initialize SrcVersion*/
    SetSrcVersion(0);

    /*Intialize the structure*/
    memset(&m_structData, 0, sizeof(m_structData));

    /* Initialize all dynamic pointers to NULL */
    m_Data = NULL;
    m_DataSize = 0;
}
/*********************************************************************************
  Default destructor
*********************************************************************************/
CErrEStd::~CErrEStd()
{
    Reset(TRUE);
}
/*********************************************************************************
Resets all members
*********************************************************************************/
void CErrEStd::Reset(boolean bResetAll)
{
    TOUCH(bResetAll);

    /*Reset dirty and valid flags*/
    SetDataBitField(0);

    /*Reset SrcVersion*/
    SetSrcVersion(0);

    /*Reset static members*/
    memset(&m_structData, 0, sizeof(m_structData));

    /*Reset Dynamic members*/
    SYS_FREE(m_Data);
    m_Data = NULL;
    m_DataSize = 0;

}
/*---------------------------------
 Static Members
---------------------------------*/
/*********************************************************************************
 Set function for data member ErrClassID
*********************************************************************************/
void CErrEStd::SetErrClassID(uint32 new_ErrClassID)
{
    m_structData.m_ErrClassID = new_ErrClassID;
}
/*********************************************************************************
 Get function for data member ErrClassID
*********************************************************************************/
uint32 CErrEStd::GetErrClassID()
{
    return (uint32)m_structData.m_ErrClassID;
}
/*********************************************************************************
 Set function for data member ErrorCode
*********************************************************************************/
void CErrEStd::SetErrorCode(uint16 new_ErrorCode)
{
    m_structData.m_ErrorCode = new_ErrorCode;

    /* Update the Description if the species is not SpCUSTOM */
    switch (species())
    {
        case CERR_SpERRWACPSTACK:
        {
            if (new_ErrorCode < CERR_MAX)
            {
                SetDescription((ansichar*)CERR_STACK_STRING, (uint16)strlen(CERR_STACK_STRING));
            }
            break;
        }
        case CERR_SpERRMSGPROC:
        {
            if (new_ErrorCode < CERR_PROC_MAX)
            {
                SetDescription((ansichar*)CERR_MSGPROC_STRING, (uint16)strlen(CERR_MSGPROC_STRING));
            }
            break;
        }
        case CERR_SpERRAPPINTERNAL:
        {
            if (new_ErrorCode < CERR_APP_MAX)
            {
                SetDescription((ansichar*)CERR_APP_STRING, (uint16)strlen(CERR_APP_STRING));
            }
            break;
        }
        default:
            break;
    }
}
/*********************************************************************************
 Get function for data member ErrorCode
*********************************************************************************/
uint16 CErrEStd::GetErrorCode()
{
    return (uint16)m_structData.m_ErrorCode;
}
/*********************************************************************************
 Set function for data member Description
*********************************************************************************/
void CErrEStd::SetDescription(ansichar* pBuf, uint16 Length)
{
    /*Clean out the structure field*/
    memset(m_structData.m_Description, 0, sizeof(m_structData.m_Description));

    /*Check for Null pointer*/
    if(pBuf != NULL)
    {
        /*Check if there is enough room in the structure field*/
        if((sizeof(ansichar)*Length) < sizeof(m_structData.m_Description))
        {
            memcpy(m_structData.m_Description, pBuf, (sizeof(ansichar)*Length));
        }
    }
}
/*********************************************************************************
 Get function for data member Description
*********************************************************************************/
ansichar* CErrEStd::GetDescription(uint16* pSize)
{
    if(pSize)
    {
        *pSize = (uint16)(sizeof(m_structData.m_Description)/sizeof(ansichar));
    }
    return (ansichar*)m_structData.m_Description;
}
/*---------------------------------
 Dynamic Members
---------------------------------*/
/*********************************************************************************
 Set function for data member Data.
*********************************************************************************/
void CErrEStd::SetData(uint8* pBuf, uint16 NumElements)
{
    if(pBuf != NULL)
    {
        /*Calculate Size in bytes*/
        m_DataSize = NumElements*sizeof(uint8);

        /*Allocate memory for the new Buffer*/
        m_Data = (uint8*)SYS_REALLOC(m_Data, m_DataSize);

        if(m_Data != NULL)
        {
            /*Make a copy of the data*/
            memcpy(m_Data, pBuf, m_DataSize);
        }
    }
    else
    {
        /* If incoming data is NULL then treat it as a clear request */
        m_DataSize = 0;
        SYS_FREE(m_Data);
        m_Data = NULL;
    }
}
/*********************************************************************************
 Get function for data member Data
*********************************************************************************/
uint8* CErrEStd::GetData(uint16* pSize)
{
    if((pSize) && (m_DataSize))
    {
        *pSize = (uint16)(m_DataSize/sizeof(uint8));
    }
    return (uint8*)m_Data;
}
/*================================================================================
    INHERITED / OVERIDDEN
================================================================================*/
/*********************************************************************************
Returns the version of the object. 
*********************************************************************************/
uint16 CErrEStd::getVersion (void)
{
    return (uint16)CERR_OBJECT_VERSION;
}
/*********************************************************************************
Returns the number of Bytes that would be used by the serialize_payload and
deserialize_payload methods.
*********************************************************************************/
uint32 CErrEStd::get_payload_size (void)
{
    uint32 Size = 0;
    Size = sizeof(uint16)                /*Object Version*/
            + sizeof(byte)                /*is dirty flag*/
            + sizeof(uint16)                /*Size of the struct*/
            + (uint16)CERR_STATIC_STRUCT_SIZE;    /*struct data size*/

    /* Get the size of each dynamic member */
    Size += sizeof(uint16) + m_DataSize;

    Size += sizeof(uint16);            /* CRC bytes */

    return Size;
}
/*********************************************************************************
Serialize the static data defined by m_structData.
*********************************************************************************/
void CErrEStd::serialize_static_data(uint8QManager * QMgr)
{
    /* Enqueue only the  members of the Struct.*/
    unsigned int index = 0;

    QMgr->put(m_structData.m_ErrClassID);
    QMgr->put(m_structData.m_ErrorCode);
    for(index = 0; index < sizeof(m_structData.m_Description)/sizeof(ansichar); index++)
    {
        QMgr->put((byte)m_structData.m_Description[index]);
    }
}
/*********************************************************************************
Deserialize the static data defined by m_structData.
*********************************************************************************/
void CErrEStd::deserialize_static_data(uint8QManager *QMgr, uint16 StructSize)
{
    /* Dequeue only the  members of the Struct.*/
    unsigned int index = 0;

        if((StructSize) &&
           (CERR_VERSION_STATUS(CERR_ErrClassID)))
        {
            QMgr->get(&m_structData.m_ErrClassID);
            StructSize -= sizeof(uint32);
        }
        if((StructSize) &&
           (CERR_VERSION_STATUS(CERR_ErrorCode)))
        {
            QMgr->get(&m_structData.m_ErrorCode);
            StructSize -= sizeof(uint16);
        }
    if((StructSize) &&
       (CERR_VERSION_STATUS(CERR_Description)))
    {
        for(index = 0; index < sizeof(m_structData.m_Description)/sizeof(ansichar); index++)
        {
            QMgr->get((byte*)&m_structData.m_Description[index]);
            StructSize -= sizeof(ansichar);
        }
    }
}
/*********************************************************************************
Used to place the data elements of the object into a circular queue. This
excludes the class identifier.
*********************************************************************************/
boolean CErrEStd::serialize_payload (uint8QManager * QMgr)
{
    uint16    Version = getVersion();
    uint32    index = 0;
    byte      *TailPtr;
    uint32    CRCLen;

    /* Save the start of the byte stream for calculating the CRC */
    TailPtr = (byte*)(QMgr->GetTailPtr());

    /* Enqueue the version */
    QMgr->put(Version);

    /* Enqueue the dirty State*/
    QMgr->put(GetDataBitField());

    /* Enqueue the Static Structure Size */
    QMgr->put((uint16)CERR_STATIC_STRUCT_SIZE);

    /* Enqueue only the static members of the Struct */
    serialize_static_data(QMgr);

    /* Enqueue variable sized members and their sizes */

    QMgr->put((uint16)m_DataSize);
    if(m_Data != NULL)
    {
        for(index = 0; index < (m_DataSize/sizeof(uint8)); index++)
        {
            QMgr->put(m_Data[index]);
        }
    }

    /* Enqueue the CRC */
    CRCLen = QMgr->get_num_elements() - sizeof(uint16);
    QMgr->put(CalculateCRC(TailPtr,CRCLen));

    return TRUE;
}

/*********************************************************************************
Used to deserialize the data elements of the object from a circular queue. This
excludes the class identifier.
*********************************************************************************/
boolean CErrEStd::deserialize_payload (uint8QManager * QMgr, uint32 Sz)
{
    /*These data pieces will need to be dequeued*/
    byte      BitField; 
    uint16    Version; 
    uint16    Size = 0; 
    byte      *pHeadPtr;
    uint32    index = 0;
    uint16    CalcCRC;
    uint16    StoredCRC;
    uint32    CRCSize;
    boolean   bResult = FALSE;

    /* Save the start of the byte stream for calculating the CRC */
    pHeadPtr = (byte*)(QMgr->GetHeadPtr());

    /* Calculate the CRC using just the payload and not the CRC Bytes*/
    CRCSize = QMgr->get_num_elements() - sizeof(uint16);
    CalcCRC = CalculateCRC(pHeadPtr, CRCSize);

    /* Index into the byte array to retrieve the stored CRC */
    StoredCRC = ReadInt16(&pHeadPtr[CRCSize]);

    /* Compare the Calculated and Stored CRC */
    if(CalcCRC == StoredCRC)
    {
        /* Dequeue the version */
        QMgr->get(&Version);

        if(Version <= CERR_OBJECT_VERSION)
        {
            /* Store the dequeued version */
            SetSrcVersion(Version);

            /* Dequeue the dirty State */
            QMgr->get(&BitField);

            SetDataBitField(BitField);

            /* Dequeue the static member struct size */
            QMgr->get(&Size);

            /* Dequeue only the static members of the Struct */
            if(Size <= (uint16)CERR_STATIC_STRUCT_SIZE)
            {
                deserialize_static_data(QMgr, Size);
#if defined(DEBUG_PRINT)
                if(Size < (uint16)CERR_STATIC_STRUCT_SIZE)
                {
                    SYS_PRINTF("\nThe source object is smaller than the destination. Some source data will be lost.\n\n");
                }
#endif
            }
            else
            {
                uint8   *NewBuffer;
                NewBuffer = (uint8*)SYS_MALLOC(Sz);

                if(NewBuffer != NULL)
                {
                    deserialize_static_data(QMgr, (uint16)Sz);
#if defined(DEBUG_PRINT)
                    SYS_PRINTF("\nThe Source object is larger than the destination. Some destination data will not be intialized.\n\n");
#endif
                    /* Dequeue the remaining extra bytes of the static struct */
                    QMgr->dequeue_array(NewBuffer, Size - CERR_STATIC_STRUCT_SIZE);

                    SYS_FREE(NewBuffer);
                }
            }

            if(((QMgr->get_num_used()) > 2) &&
                (CERR_VERSION_STATUS(CERR_Data)))
            {
                QMgr->get(&m_DataSize);
                if(m_DataSize > 0)
                {
                    /*Allocate memory for the new Buffer*/
                    m_Data = (uint8*)SYS_REALLOC(m_Data, m_DataSize);

                    if(m_Data != NULL)
                    {
                        for(index = 0; index < (m_DataSize/sizeof(uint8)); index++)
                        {
                            QMgr->get(&m_Data[index]);
                        }
                    }
                }
                else
                {
                    SYS_FREE(m_Data);
                    m_Data = NULL;
                }
            }

            bResult = TRUE;
        }
    }

    if(bResult == FALSE)
    {
        Reset(TRUE);
    }

    return bResult;
}
#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Writes the object into an XML file pointed to by the fhnd. Returns the number of
Bytes written into the file.
*********************************************************************************/
uint32 CErrEStd::serialize_to_XMLbuf(char *pBuf)
{
    char Buffer[XML_BUFSIZE];
    char *Output = Buffer;
    uint32 NewSize   = 0;
    uint32 FinalSize = 0;
    uint32 ZeroSize  = 0;
    uint32 *pSizeCount = &ZeroSize;
    uint32 index = 0;
    char *pEnumName = NULL;

    /* If pBuf is NULL, then we don't write anything to it, and just 
    return the potential size */
    if(pBuf != NULL)
    {
        Output = pBuf;
        pSizeCount = &NewSize;
    }

    NewSize = sprintf(Output,
            /*XML formatted Output to file*/
            "<DEFINITION class=\"CErrEStd\" version=\"%d\" "
                        "family=\"%d\" genus=\"%d\" species=\"%d\">\n",
            /*---------------------------------------------------------------*/
            /*Data for the related types above.
            uint16 representation Version*/
            getVersion(),
            family(),
            genus(),
            species());

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            /*---------------------------------------------------------------*/
            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"ErrClassID\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", m_structData.m_ErrClassID);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint16\" name=\"ErrorCode\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", m_structData.m_ErrorCode);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- ansichar pointer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"ansichar\" size=\"20\" name=\"Description\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(m_structData.m_Description[0] != 0)
            {
                NewSize = sprintf(Output, "%s", m_structData.m_Description);
                FinalSize += NewSize;
                Output += *pSizeCount;
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Pointer to Data Buffer --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" size=\"UNBOUNDED\" name=\"Data\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(m_Data != NULL)
            {
                for(index = 0; index < m_DataSize/sizeof(uint8); index++)
                {
                    NewSize = sprintf(Output, "%u;", m_Data[index]); 
                    FinalSize += NewSize;
                    Output += *pSizeCount;
                }
            }

            NewSize = sprintf(Output, "]]></VALUE>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Write the closing members tag*/
            NewSize = sprintf(Output, "</MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(IsValidEnum((MsgEntry*)TypAppErrorTbl,
                        CERR_TYPAPPERRORTBL_SIZE,
                        m_structData.m_ErrorCode))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"ErrorCode\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_ErrorCode)
                {
                    case 0:
                        pEnumName = "ERRORCODE_NONE";
                        break;
                    case 1:
                        pEnumName = "ERRORCODE_POST_FPROM";
                        break;
                    case 2:
                        pEnumName = "ERRORCODE_POST_SRAM";
                        break;
                    case 3:
                        pEnumName = "ERRORCODE_POST_EE_FACTORY";
                        break;
                    case 4:
                        pEnumName = "ERRORCODE_POST_EE_USER";
                        break;
                    case 5:
                        pEnumName = "ERRORCODE_POST_ADC";
                        break;
                    case 6:
                        pEnumName = "ERRORCODE_POST_SENSOR";
                        break;
                    case 7:
                        pEnumName = "ERRORCODE_POST_PRINTER";
                        break;
                    case 8:
                        pEnumName = "ERRORCODE_POST_RTC";
                        break;
                    case 9:
                        pEnumName = "ERRORCODE_POST_NO_CAL";
                        break;
                    case 10:
                        pEnumName = "ERRORCODE_POST_CAL_BAD";
                        break;
                    case 11:
                        pEnumName = "ERRORCODE_POST_VALVE";
                        break;
                    case 12:
                        pEnumName = "ERRORCODE_POST_HIGH";
                        break;
                    case 13:
                        pEnumName = "ERRORCODE_POST_LOG";
                        break;
                    case 14:
                        pEnumName = "ERRORCODE_POST_EE_PATIENTDATA";
                        break;
                    case 15:
                        pEnumName = "ERRORCODE_POST_MAX";
                        break;
                    case 16:
                        pEnumName = "ERRORCODE_POST_ERROR_CHECK";
                        break;
                    case 17:
                        pEnumName = "ERRORCODE_POST_NOT_RDY";
                        break;
                    case 18:
                        pEnumName = "ERRORCODE_WRITE_FAILED";
                        break;
                    case 19:
                        pEnumName = "ERRORCODE_ERASE_FAILED";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_ErrorCode);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CERR_APP_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            /*---------------------------------------------------------------*/

            /*Write the closing definition tag*/
            NewSize = sprintf(Output, "</DEFINITION>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

    return FinalSize+1;
}
#endif  /* #if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) */
#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
  The XML Parser makes a callback to this function whenever it encounters a start
  tag for an element. This function checks the string value of that element tag to
  decide what data it holds. It then sets the variable CurrentParsePos to point 
  at the data member corresponding with the tag string value. This CurrentParsePos 
  is used later by the parse_CharacterData() function to determine where the data 
  retrieved by parse_CharacterData() should be placed. 

  It also increments the DepthPtr for the current XML file. This value describes 
  the depth of the currently processed node.

 Ex: DepthPtr = 3:
 1 |-> <TAG1>
 2 |----> <TAG2>
 3 |-------> <TAG3>This element is 3 deep</TAG3>
          </TAG2>
      </TAG1>
*********************************************************************************/
void CErrEStd::parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts)
{
    TOUCH(Atts);
    XMLParserData *ParserData = (XMLParserData*)UserData;

    /*Increment DepthPtr to track node depth*/
    uint32 *DepthPtr = &ParserData->Depth;
    *DepthPtr += 1;

    if(!validXMLParseFlag)
        return;

#if(DEBUG_PRINT)
    /*Debug information that will print to terminal screen
     *Prints tabspaces matching the DepthPtr, the name of 
     *element tag, and then...(onto parse_CharacterData)*/
    uint32 i;
    fputc('\n', stderr);
    for(i = 0; i < *DepthPtr; i++) fputc('\t', stderr);
    fprintf(stderr, "%-16s", Name);
#endif

    /* This area checks the current encountered tag. if it matches one that was
     * written in the serialize_to_XMLfile() function, then check its attributes
     * and attribute values */
    if((!strcmp("DEFINITION", Name)) && (GetClassAttr() == NULL))
    {
        while (*Atts)
        {
            /*As we parse the XML data, we check to see if the Family, 
             *Genus and Species match the current object. If they do not, 
             *we set validXMLParseFlag to FALSE. This will stop the parser 
             *from handling the additional data, and clear any data 
             *already in our structure.*/
            if(!strcmp(*Atts, "family"))
            {
                if(family() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "genus"))
            {
                if(genus() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "species"))
            {                                     
                if(species() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "version"))
            {
                SrcVersion = (uint16)atol(*++Atts);
                Atts++;
            }
            else Atts += 2;
        }
    }
    /*---------------------------------------------------------------*/
    else if (!strcmp("MEMBER", Name) && (GetClassAttr() == NULL))
    {
        /*Loop through the MEMBER attributes and
         *extract the attribute values*/
        while (*Atts)
        {
            if(!strcmp(*Atts, "name"))
            {
                Atts++;
                if(!strcmp(*Atts, "ErrClassID"))
                {
                    CurrentParsePos = (void*)&m_structData.m_ErrClassID;
                }
                else if(!strcmp(*Atts, "ErrorCode"))
                {
                    CurrentParsePos = (void*)&m_structData.m_ErrorCode;
                }
                else if(!strcmp(*Atts, "Description"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Description;
                }
                else if(!strcmp(*Atts, "Data"))
                {
                    CurrentParsePos = (void*)&m_Data;
                }
                Atts++;
            }
            else Atts += 2;
        }
    }
    /*---------------------------------------------------------------*/
}
#endif/*TARGET_XML_SUPPORT*/

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
XML HELPER FUNCTION
  The XML Parser makes a callback to this function whenever it encounters
  character data after a start tag. This function also uses CurrentParsePos. This
  CurrentParsePos value has been set previously by the parse_StartElement
  function
*********************************************************************************/
void CErrEStd::parse_CharacterData(void *UserData, const XML_Char *sTag, int Len)
{
    TOUCH(UserData);
    TOUCH(sTag);
    TOUCH(Len);

    int i = 0;
    XML_Char *pBufStart;
    XML_Char *pBuf;

    /*Check to see if CurrentParsePos is NULL or points to something,
     *and if validXMLParseFlag is still true. If CurrentParsePos is
     *NULL, then this means we have encountered an element tag with 
     *no internal character data, and we pass it.*/
    if((CurrentParsePos && validXMLParseFlag) && (*sTag != '\n'))
    {
        if(CurrentParsePos == (void*)(&m_structData.m_ErrClassID))
        {
            SetErrClassID((uint32)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_ErrorCode))
        {
            SetErrorCode((uint16)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Description))
        {
            SetDescription((ansichar*)sTag, (uint16)Len);
        }
        else if(CurrentParsePos == (void*)(&m_Data))
        {
            uint8 *pTempBuffer = NULL;
            uint16 NumElements = 0;

            /*Calc Array Length*/
            NumElements = (uint16)CalcArrayLength(sTag, Len);

            pTempBuffer = (uint8*)SYS_MALLOC(NumElements*sizeof(uint8));

            if(pTempBuffer != NULL)
            {
                for(pBuf = (XML_Char*)sTag, pBufStart = (XML_Char*)sTag, i = 0; pBuf < sTag + Len; pBuf++)
                {
                    if(*pBuf == ';')
                    {
                        pTempBuffer[i] = (uint8)atol(pBufStart);
                        pBufStart = pBuf+1;
                        i++;
                    }
                }
            }

            SetData(pTempBuffer, NumElements);
            SYS_FREE(pTempBuffer);
        }
        /*---------------------------------------------------------------*/
#if(DEBUG_PRINT)
        /*(from parse_StartElement)...picks up from the start
         *element and prints the value following it*/
        fprintf(stderr, " = %s", sTag);
        if(!validXMLParseFlag)
            fprintf(stderr, " - Invalid Data: Stopping parse");
#endif
    }
}
#endif /*TARGET_XML_SUPPORT*/

/*================================================================================
Helper function for setting default values for the test functions
================================================================================*/
void CErrEStd::SetObjectProperties(CErrEStd *MyObjectSrc)
{/*Start SetObjectProperties()*/

    TOUCH(MyObjectSrc);
    /*
        MyObjectSrc->SetErrClassID();
        MyObjectSrc->SetErrorCode();
        MyObjectSrc->SetDescription();
        MyObjectSrc->SetData();
    */

}/*End SetObjectProperties()*/

/*================================================================================
CERRESTD_TEST_MAIN
================================================================================*/
#if defined(CERRESTD_TEST_MAIN)

FILE   *Stream;
uint8  *Buffer;
uint32 Size;
uint32 i;
int    Result, TestID;

CErrEStd *MyObjectSrc = new CErrEStd();
CErrEStd *MyObjectDest = new CErrEStd();

void XML_test();
void Serialize_All_test();

#if defined(_WIN32_WCE)
#if defined(_WCE_CONSOLE)
int WinEntry (void *Args)
{
    _newprintf = ((formatter*)Args)[0];
    _newscanf = ((formatter*)Args)[1];

#else
int WINAPI WinMain(HINSTANCE  hInstance,
                    HINSTANCE  hPrevInstance,
                    LPTSTR     lpCmdLine,
                    int  nCmdShow)
{
#endif
#else
int main(void)
{
#endif /*_WIN32_WCE*/

    SYS_PRINTF("1. Transfer XML from source object-->destination object.\n");
    SYS_PRINTF("2. Transfer complete byte stream: source object-->destination object.\n");
    SYS_PRINTF("Selection:");

    Result = scanf("%d", &TestID);

    MyObjectSrc->SetObjectProperties(MyObjectSrc);

    if(TestID == 1) XML_test();
    else if(TestID == 2)  Serialize_All_test();
    else{
        SYS_PRINTF("\n\nInvalid Selection.\n\n");
    }

    SYS_PRINTF("\n\nPress any character key and hit enter to continue.\n");
    Result = scanf("%d", &TestID);

    return 0;
}
/*================================================================================
Helper function for writing a byte Stream to a file
================================================================================*/
void WriteToFile(char *Buf, uint32 Size, char *Filename)
{
    FILE    *Fp;
    size_t  Bytes;

    if((Fp  = fopen(Filename, "w+b")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", Filename);
    }

    Bytes = fwrite(Buf, 1, Size, Fp);

    if(Bytes != Size)
    {
        SYS_PRINTF("Error: %d out of %d written to file %s\n", Bytes, strlen(Buf), Filename);
    }
    else
    {
        SYS_PRINTF("%s created\n", Filename);
    }

    if(fclose(Fp))
    {
        SYS_PRINTF("The file %s was not closed\n", Filename);
    }
}
/*================================================================================
Helper function for comparing the two generated xml files.
================================================================================*/
void CompareFiles(char *File1, char *File2)
{
    fpos_t    Pos;
    size_t    SrcLen;
    size_t    DestLen;
    FILE      *Fp1, *Fp2;
    char      *SrcBuf = NULL;
    char      *DestBuf = NULL;

    if((Fp1  = fopen(File1, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File1);
    }

    if((Fp2  = fopen(File2, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File2);
    }

    /*Get the current position of the file Stream*/
    fgetpos(Fp1, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp1, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    SrcLen = size_t(ftell(Fp1) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp1, &Pos);

    SrcBuf = (char*)SYS_REALLOC(SrcBuf, SrcLen);

    SrcLen = fread(SrcBuf, 1, SrcLen, Fp1);

    /*Get the current position of the file Stream*/
    fgetpos(Fp2, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp2, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    DestLen = size_t(ftell(Fp2) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp2, &Pos);

    DestBuf = (char*)SYS_REALLOC(DestBuf, DestLen);
    DestLen = fread(DestBuf, 1, DestLen, Fp2);

    if(DestLen == SrcLen)
    {
        for(i = 0; i < DestLen; i++)
        {
            if(DestBuf[i] != SrcBuf[i])
            {
                SYS_PRINTF("File mismatch at i=%d\n", i);
                break;
            }
        }
        if(i == DestLen)
            SYS_PRINTF("%s and %s comparison - PASSED!!!\n", File1, File2);
    }
    else
    {
        SYS_PRINTF("Error - File size mismatch\n");
    }

    if(fclose(Fp1))
    {
        SYS_PRINTF("The file %s was not closed\n",File2);
    }
    if(fclose(Fp2))
    {
        SYS_PRINTF("The file %s was not closed\n", File2);
    }

    SYS_FREE(SrcBuf);
    SYS_FREE(DestBuf);
}
/*================================================================================
XML_test
================================================================================*/
void XML_test()
{
    char   *XMLBuffer = NULL;
    uint32 BufferSize;

    if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = MyObjectSrc->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectSrc->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    /*Delete MyObjectSrc*/
    delete MyObjectSrc;

    /*Close the file*/
    if(fclose(Stream)) 
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    if((Stream  = fopen("XML_SerializeSrc.xml", "rb")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    fpos_t     Pos;

    /*Get the current position of the file Stream*/
    fgetpos(Stream, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Stream, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    BufferSize = (uint32)size_t(ftell(Stream) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Stream, &Pos);

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Return the bytes read in the file Stream to XMLBuffer*/
            fread(XMLBuffer, 1, BufferSize, Stream);

            /*Deserialize the XMLBuffer into MyObjectDest*/
            BufferSize = MyObjectDest->deserialize_from_XMLbuf(XMLBuffer, BufferSize);
        }
    }

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }
    if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
    }

    /*Get the size of MyObjectDest in an XML stream*/
    BufferSize = MyObjectDest->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectDest->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream,"</CMOIBObj>");

    /*Delete MyObjectDest*/
    delete MyObjectDest;

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
    }

    /*Compare the created XML files*/
    CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");

#endif
    /*Free Buffers*/
    SYS_FREE(XMLBuffer);
}
/*================================================================================
Serialize All
================================================================================*/
void Serialize_All_test()
{
    char    *XMLBuffer   = NULL;
    uint8   *ByteBuffer  = NULL;
    uint32  BufferSize;
    fpos_t  Pos;

    if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = MyObjectSrc->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectSrc->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    /*Get the size of MyObjectSrc*/
    Size = MyObjectSrc->size_all();

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_MALLOC(Size);

    /*Serialize MyObjectSrc*/
    MyObjectSrc->serialize_all(ByteBuffer);

    /*Write the serialized ByteBuffer into the Serialize_AllSrc.bytestream file*/
    WriteToFile((char*)ByteBuffer, Size, "Serialize_AllSrc.bytestream");

    /*Delete MyObjectSrc*/ 
    delete MyObjectSrc;

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }

    if((Stream  = fopen("Serialize_AllSrc.bytestream", "rb+")) == NULL) 
    {
        SYS_PRINTF("The file Serialize_AllSrc.bytestream was not opened\n");
    }

    /*Get the current position of the file Stream*/
    fgetpos(Stream, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Stream, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    BufferSize = (uint32)size_t(ftell(Stream) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Stream, &Pos);

    if(BufferSize)
    {
        ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
        if(ByteBuffer != NULL)
        {
            /*Return the bytes read in the file Stream to ByteBuffer*/
            fread(ByteBuffer, 1, BufferSize, Stream);

            /*Deserialize the ByteBuffer into MyObjectDest*/
            BufferSize = MyObjectDest->deserialize_all((uint8*)ByteBuffer);
        }
    }

    if(fclose(Stream))
    {
        SYS_PRINTF("The file Serialize_AllSrc.bytestream was not closed\n");
    }

    if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
    }

    /*Get the size of MyObjectDest in an XML stream*/
    BufferSize = MyObjectDest->size_XML();

    /*Print start tag of XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectDest in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectDest->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
    }

    /*Get the size of MyObjectDest*/
    Size = MyObjectDest->size_all();

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, Size);

    /*Serialize MyObjectDest*/
    MyObjectDest->serialize_all(ByteBuffer);

    /*Write the serialized ByteBuffer into the Serialize_AllDest.bytestream file*/
    WriteToFile((char*)ByteBuffer, Size, "Serialize_AllDest.bytestream");

    /*Delete MyObjectDest*/ 
    delete MyObjectDest;

    /*Free buffers*/
    SYS_FREE(XMLBuffer);
    SYS_FREE(ByteBuffer);

    /*Compare created XML files and bytestream files*/
    CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");
    CompareFiles("Serialize_AllSrc.bytestream", "Serialize_AllDest.bytestream");
}
#endif /*#if defined(CERRESTD_TEST_MAIN)*/
/* ---------------------------End of DataClass CErrEStd -------------------------------- */
