/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrEStd.h                                                        //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CERRESTD_H)
    #define  CERRESTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CERR_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    /* AppInternal Errors */
    typedef enum CERRtypAPPERROR {
        CERR_APP_NONE = 0, 
        CERR_APP_POST_FPROM, /*FPROM checksum error*/
        CERR_APP_POST_SRAM, /*SRAM test failure*/
        CERR_APP_POST_EE_FACTORY, /*Factory EEprom checksum error*/
        CERR_APP_POST_EE_USER, /*User EEprom checksum error*/
        CERR_APP_POST_ADC, /*A/D converter failure*/
        CERR_APP_POST_SENSOR, /*SENSOR module failure*/
        CERR_APP_POST_PRINTER, /*Printer problem*/
        CERR_APP_POST_RTC, /*Real time clock failure*/
        CERR_APP_POST_NO_CAL, /*No calibration signature*/
        CERR_APP_POST_CAL_BAD, /*Bad calibration*/
        CERR_APP_POST_VALVE, /*Stepper valve bad*/
        CERR_APP_POST_HIGH, /*8bit substitute for 16bit errors*/
        CERR_APP_POST_LOG, /*Error log checksum error*/
        CERR_APP_POST_EE_PATIENTDATA, /*Nonvolatile patient data lost*/
        CERR_APP_POST_MAX, /*POST queue full*/
        CERR_APP_POST_ERROR_CHECK, /*Validation check i.e. assert( code less than POST_ERROR_CHECK )*/
        CERR_APP_POST_NOT_RDY, /*POST error code not yet ready*/
        CERR_APP_WRITE_FAILED, /*Write Operation failed*/
        CERR_APP_ERASE_FAILED, /*Erase operation failed*/
        CERR_APP_MAX
    } CERR_APPLIST;

    /* WACP Stack Errors */
    typedef enum CERRtypSTACKERROR {
        CERR_NONE = 0,
        CERR_INVL_FAMILY,
        CERR_INVL_GENUS,
        CERR_INVL_SPECIES,
        CERR_OBJECT_ID,
        CERR_CRC_MISMATCH,  
        CERR_INVL_TBL_ENTRY,
        CERR_DUP_ENTRY,
        CERR_MAX
    } CERR_STACKLIST;

    /* WACP Message Processing Errors */
    typedef enum CERRtypPROCERROR {
        CERR_PROC_NONE = 0,
        CERR_PROC_UNIMPL,
        CERR_PROC_UNSUPPORTED,
        CERR_PROC_MEMORY,
        CERR_PROC_NO_PARAM,
        CERR_PROC_INVL_PARAM,
        CERR_PROC_INVL_PARAM_RANGE,
        CERR_PROC_NO_OBJECT,
        CERR_PROC_OBJECT_DESERIALIZE,
        CERR_PROC_OBJECT_SERIALIZE,
        CERR_PROC_CONTEXT,
        CERR_PROC_ITEM_NOT_AVAILABLE,
        CERR_PROC_MAX
    } CERR_PROCLIST;

    typedef  enum CERRtypSPECIES {
        CERR_SpERRNONE = 0, 
        CERR_SpERRWACPSTACK, 
        CERR_SpERRMSGPROC, 
        CERR_SpERRAPPINTERNAL, 
        CERR_SpMAX
    } CERR_SPECIES;

#define CERR_APP_STRING \
    (GetMsgString((MsgEntry*)TypAppErrorTbl, \
                 CERR_TYPAPPERRORTBL_SIZE, \
                 m_structData.m_ErrorCode))

#define CERR_STACK_STRING \
    (GetMsgString((MsgEntry*)TypStackErrorTbl, \
                 CERR_TYPSTACKERRORTBL_SIZE, \
                 m_structData.m_ErrorCode))

#define CERR_MSGPROC_STRING \
    (GetMsgString((MsgEntry*)TypMsgProcErrorTbl, \
                 CERR_TYPMSGPROCERRORTBL_SIZE, \
                 m_structData.m_ErrorCode))

#define CERR_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CERR_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CErrEStd Member's Version Enumerations*/
    typedef  enum CERRtypVERSIONS {
        CERR_ErrClassID,
        CERR_ErrorCode,
        CERR_Description,
        CERR_Data,
        CERR_MEMBER_MAX
    } CERR_VERSIONS;

#define CERR_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CERR_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CERRESTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CERRESTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CERRESTD_DLLAPI  __declspec(dllimport)
    #else
        #define CERRESTD_DLLAPI
    #endif
#endif

class CERRESTD_DLLAPI CErrEStd : public DtData
{
public:
    CErrEStd();
    ~CErrEStd();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint32 GetErrClassID();
    void SetErrClassID(uint32 new_ErrClassID);

    uint16 GetErrorCode();
    void SetErrorCode(uint16 new_ErrorCode);

    ansichar* GetDescription(uint16* pSize);
    void SetDescription(ansichar* pBuf, uint16 Length);

    uint8* GetData(uint16* pSize);
    void SetData(uint8* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CErrEStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_ErrClassID; /* ClassID of message or object that generated the error */
            uint16        m_ErrorCode; /* Error code from message */
            ansichar      m_Description[20]; /* Error code description */
    }ClassStruct_t;

#define CERR_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 20 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    uint8             *m_Data; /* Can contain any data for a received process. */
    uint16            m_DataSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypAppErrorTbl[];
    static const MsgEntry    TypStackErrorTbl[];
    static const MsgEntry    TypMsgProcErrorTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CERRESTD_H) */

/*---------------------------------------------------*/
/* End of File */
