/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrPGetError.h                                                   //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CERRPGETERROR_H)
    #define  CERRPGETERROR_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CERRPGER_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CERRPGERtypSPECIES {
        CERRPGER_SpGET_ERROR = 0, 
        CERRPGER_SpMAX
    } CERRPGER_SPECIES;

#define CERRPGER_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CERRPGER_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CErrPGetError Member's Version Enumerations*/
    typedef  enum CERRPGERtypVERSIONS {
        CERRPGER_ErrClassID,
        CERRPGER_Source,
        CERRPGER_ErrCode,
        CERRPGER_MEMBER_MAX
    } CERRPGER_VERSIONS;

#define CERRPGER_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CERRPGER_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CERRPGETERROR_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CERRPGETERROR_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CERRPGETERROR_DLLAPI  __declspec(dllimport)
    #else
        #define CERRPGETERROR_DLLAPI
    #endif
#endif

class CERRPGETERROR_DLLAPI CErrPGetError : public DtData
{
public:
    CErrPGetError();
    ~CErrPGetError();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint32 GetErrClassID();
    void SetErrClassID(uint32 new_ErrClassID);

    uint16 GetSource();
    void SetSource(uint16 new_Source);

    uint16 GetErrCode();
    void SetErrCode(uint16 new_ErrCode);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CErrPGetError *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_ErrClassID; /* Class ID of object or message ID which generated the error code */
            uint16        m_Source; /* Source from object or zero for message */
            uint16        m_ErrCode; /* Error code from object or message */
    }ClassStruct_t;

#define CERRPGER_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CERRPGETERROR_H) */

/*---------------------------------------------------*/
/* End of File */
