/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CModuleDExtStd.h                                                  //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CMODULEDEXTSTD_H)
    #define  CMODULEDEXTSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CMODDXTSTD_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CMODDXTSTDtypSPECIES {
        CMODDXTSTD_SpSTANDARD = 0, /*Indicates that this is an object describing the Finished Medical Device.*/
        CMODDXTSTD_SpHOST = 1, /*Indicates that this is an object describing a host (Compute Engine) subsystem.*/
        CMODDXTSTD_SpSENSOR = 2, /*Indicates that this is an object describing a sensor subsystem.*/
        CMODDXTSTD_SpMAX
    } CMODDXTSTD_SPECIES;

#define CMODDXTSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CMODDXTSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CModuleDExtStd Member's Version Enumerations*/
    typedef  enum CMODDXTSTDtypVERSIONS {
        CMODDXTSTD_ModuleContainer,
        CMODDXTSTD_MEMBER_MAX
    } CMODDXTSTD_VERSIONS;

#define CMODDXTSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CMODDXTSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CMODULEDEXTSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CMODULEDEXTSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CMODULEDEXTSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CMODULEDEXTSTD_DLLAPI
    #endif
#endif

class CMODULEDEXTSTD_DLLAPI CModuleDExtStd : public DtData
{
public:
    CModuleDExtStd();
    ~CModuleDExtStd();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    boolean    InitModuleContainer(uint32 Size);
    boolean    AppendModuleContainer(uint8 *pBuffer, uint32 Size, uint16 NumberElements);
    void       DeleteModuleContainer(void);
    uint8      *GetModuleContainerAt(uint16 Index, uint32 *pSize);
    uint8      *GetModuleContainer(uint32 *pSize);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CModuleDExtStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
    }ClassStruct_t;

#define CMODDXTSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

    /*Record Data*/
    uint8    *m_ModuleContainer;
    uint32   m_ModuleContainerSize;
    uint32   m_ModuleContainerMaxSize;
    uint16   m_ModuleContainerElements;
    boolean  bModuleContainerMaxSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CMODULEDEXTSTD_H) */

/*---------------------------------------------------*/
/* End of File */
