/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CModuleDStd.h                                                     //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CMODULEDSTD_H)
    #define  CMODULEDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CMODDSTD_OBJECT_VERSION 101

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CMODDSTDtypSPECIES {
        CMODDSTD_SpSTANDARD = 0, 
        CMODDSTD_SpHOST, /*The hosting subsystem (i.e Spot LXi or PVSM).*/
        CMODDSTD_SpHARDWARE, 
        CMODDSTD_SpBOOTLOADER, 
        CMODDSTD_SpBOOTRECOVERY, 
        CMODDSTD_SpNIBPMODULE = 16, /*The NIBP module (i.e MODPG)*/
        CMODDSTD_SpNIBPSAFETYALG, 
        CMODDSTD_SpNIBPSTEPALG, 
        CMODDSTD_SpNIBPFASTALG, 
        CMODDSTD_SpNIBPNEONATSTEPALG, 
        CMODDSTD_SpNIBPPOEMALG, 
        CMODDSTD_SpNIBPSTEPAOALG, 
        CMODDSTD_SpTEMPMODULE = 32, /*The Temperature module*/
        CMODDSTD_SpSURETEMPALG, 
        CMODDSTD_SpSPO2MODULE = 40, /*The SPO2 module (i.e SureTemp)*/
        CMODDSTD_SpECGMODULE = 48, /*The ECG module*/
        CMODDSTD_SpMEANS, 
        CMODDSTD_SpSPIROMETRY = 56, /*The Spirometry module*/
        CMODDSTD_SpFRONTEND = 192, 
        CMODDSTD_SpPPP, /*Printer and peripheral processor*/
        CMODDSTD_SpSECUREDIGITALCARD, 
        CMODDSTD_SpALL = 255, /*Indicates that all species are represented. Used solely for the species selector in the CModulePSelector object to request all Modules from the device.*/
        CMODDSTD_SpMAX
    } CMODDSTD_SPECIES;

#define CMODDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CMODDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CModuleDStd Member's Version Enumerations*/
    typedef  enum CMODDSTDtypVERSIONS {
        CMODDSTD_Version,
        CMODDSTD_Description,
        CMODDSTD_MEMBER_MAX
    } CMODDSTD_VERSIONS;

#define CMODDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CMODDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CMODULEDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CMODULEDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CMODULEDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CMODULEDSTD_DLLAPI
    #endif
#endif

class CMODULEDSTD_DLLAPI CModuleDStd : public DtData
{
public:
    CModuleDStd();
    ~CModuleDStd();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    ansichar* GetVersion(uint16* pSize);
    void SetVersion(ansichar* pBuf, uint16 Length);

    ansichar* GetDescription(uint16* pSize);
    void SetDescription(ansichar* pBuf, uint16 Length);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CModuleDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            ansichar      m_Version[16];
            ansichar      m_Description[32];
    }ClassStruct_t;

#define CMODDSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 48 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CMODULEDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
