/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CNumDStd.h                                                        //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CNUMDSTD_H)
    #define  CNUMDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CNUMDSTD_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CNUMDSTDtypSTATUSBITS {
        CNUMDSTD_StatusBits_ValidRange = 0, /*sensor specified.*/
        CNUMDSTD_StatusBits_OverRange = 1, /*+++, sensor specified.*/
        CNUMDSTD_StatusBits_UnderRange = 2, /*---, sensor specified.*/
        CNUMDSTD_StatusBits_UndeterminedRange = 3, /*???, sensor specified.*/
        CNUMDSTD_StatusBits_RangeMask = 1027, /*Bit map mask*/
        CNUMDSTD_StatusBits_NoAlarm = 1024, 
        CNUMDSTD_StatusBits_UpperLimitAlarm = 4, 
        CNUMDSTD_StatusBits_LowerLimitAlarm = 8, 
        CNUMDSTD_StatusBits_OtherAlarm = 12, 
        CNUMDSTD_StatusBits_AlarmTypeMask = 1036, /*Bit map mask*/
        CNUMDSTD_StatusBits_NumericActive = 16, 
        CNUMDSTD_StatusBits_Continuous = 2048, 
        CNUMDSTD_StatusBits_SpotOld = 32, 
        CNUMDSTD_StatusBits_SpotRecent = 64, 
        CNUMDSTD_StatusBits_SpotNew = 128, 
        CNUMDSTD_StatusBits_SpotMask = 224, /*Bit map mask*/
        CNUMDSTD_StatusBits_Dubious = 256, /*Sensor specified.*/
        CNUMDSTD_StatusBits_MAX
    } CNUMDSTD_STATUSBITS;

    typedef  enum CNUMDSTDtypSPECIES {
        CNUMDSTD_SpSTANDARD = 0, 
        CNUMDSTD_SpECGHR, 
        CNUMDSTD_SpHRPR, 
        CNUMDSTD_SpNIBPSYS, 
        CNUMDSTD_SpNIBPDIA, 
        CNUMDSTD_SpNIBPMAP, 
        CNUMDSTD_SpNIBPPR, 
        CNUMDSTD_SpIBP1SYS, 
        CNUMDSTD_SpIBP1DIA, 
        CNUMDSTD_SpIBP1MAP, 
        CNUMDSTD_SpIBP1PR, 
        CNUMDSTD_SpIBP2SYS, 
        CNUMDSTD_SpIBP2DIA, 
        CNUMDSTD_SpIBP2MAP, 
        CNUMDSTD_SpIBP2PR, 
        CNUMDSTD_SpIBP3SYS, 
        CNUMDSTD_SpIBP3DIA, 
        CNUMDSTD_SpIBP3MAP, 
        CNUMDSTD_SpIBP3PR, 
        CNUMDSTD_SpSPO2PR, 
        CNUMDSTD_SpSPO2SAT, 
        CNUMDSTD_SpSPO2PI, 
        CNUMDSTD_SpRESPRATE, 
        CNUMDSTD_SpRRBR, 
        CNUMDSTD_SpCO2ENDT, 
        CNUMDSTD_SpCO2INSP, 
        CNUMDSTD_SpCO2BR, 
        CNUMDSTD_SpTEMP1, 
        CNUMDSTD_SpTEMP2, 
        CNUMDSTD_SpDELTAT, 
        CNUMDSTD_SpALL, 
        CNUMDSTD_SpMAX
    } CNUMDSTD_SPECIES;

#define CNUMDSTD_STATUSBITS_STRING \
    (GetMsgString((MsgEntry*)TypStatusBitsTbl, \
                 CNUMDSTD_TYPSTATUSBITSTBL_SIZE, \
                 m_structData.m_StatusBits))

#define CNUMDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CNUMDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CNumDStd Member's Version Enumerations*/
    typedef  enum CNUMDSTDtypVERSIONS {
        CNUMDSTD_Value,
        CNUMDSTD_StatusBits,
        CNUMDSTD_MEMBER_MAX
    } CNUMDSTD_VERSIONS;

#define CNUMDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CNUMDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CNUMDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CNUMDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CNUMDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CNUMDSTD_DLLAPI
    #endif
#endif

class CNUMDSTD_DLLAPI CNumDStd : public DtData
{
public:
    CNumDStd();
    ~CNumDStd();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    int16 GetValue();
    void SetValue(int16 new_Value);

    uint16 GetStatusBits();
    void SetStatusBits(uint16 new_StatusBits);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CNumDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            int16         m_Value; /* numeric value */
            uint16        m_StatusBits; /* see enumerator */
    }ClassStruct_t;

#define CNUMDSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 1 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypStatusBitsTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CNUMDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
