/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRNDZDStd.h                                                       //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRNDZDSTD_H)
    #define  CRNDZDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CRDZDSTD_OBJECT_VERSION 101

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRDZDSTDtypSPECIES {
        CRDZDSTD_SpSTANDARD = 0, 
        CRDZDSTD_SpMAX
    } CRDZDSTD_SPECIES;

#define CRDZDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRDZDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRNDZDStd Member's Version Enumerations*/
    typedef  enum CRDZDSTDtypVERSIONS {
        CRDZDSTD_DeviceGUID,
        CRDZDSTD_DDSVersion,
        CRDZDSTD_Data,
        CRDZDSTD_MEMBER_MAX
    } CRDZDSTD_VERSIONS;

#define CRDZDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRDZDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRNDZDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRNDZDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRNDZDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CRNDZDSTD_DLLAPI
    #endif
#endif

class CRNDZDSTD_DLLAPI CRNDZDStd : public DtData
{
public:
    CRNDZDStd();
    ~CRNDZDStd();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint8* GetDeviceGUID(uint16* pSize);
    void SetDeviceGUID(uint8* pBuf, uint16 Length);

    uint16 GetDDSVersion();
    void SetDDSVersion(uint16 new_DDSVersion);

    uint8* GetData(uint16* pSize);
    void SetData(uint8* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CRNDZDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint8         m_DeviceGUID[16]; /* A value that represents the DDS GUID. */
            uint16        m_DDSVersion; /* A value that represents the DDS version. */
    }ClassStruct_t;

#define CRDZDSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 16 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    uint8             *m_Data; /* Reserved. A generic array to provide additional information. */
    uint16            m_DataSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRNDZDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
