/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespCCal.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPCCAL_H)
    #define  CRESPCCAL_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CRSPCCAL_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPCCALtypMETHOD {
        CRSPCCAL_Method_NONE = 0, /*None Specified*/
        CRSPCCAL_Method_REGULAR_CALIBRATION = 1, /*Regular Calibration*/
        CRSPCCAL_Method_SPECIAL_FACTORY_CALIBRATION = 2, /*Special Factory Calibration*/
        CRSPCCAL_Method_CALIBRATION_CHECK = 3, /*Calibration check*/
        CRSPCCAL_Method_MAX
    } CRSPCCAL_METHOD;

    typedef  enum CRSPCCALtypSTATUS {
        CRSPCCAL_Status_NONE = 0, /*None Specified*/
        CRSPCCAL_Status_IN_PROGRESS = 1, /*Calibration in progress*/
        CRSPCCAL_Status_NOT_READY = 2, /*Module not ready for Calibration*/
        CRSPCCAL_Status_CALCULATING = 3, /*Calculating - calibration gas can be removed*/
        CRSPCCAL_Status_COMPLETE_ERROR = 4, /*Calibration complete with error*/
        CRSPCCAL_Status_COMPLETE_SUCCESS = 5, /*Calibration complete successfully*/
        CRSPCCAL_Status_USER_ABORT = 6, /*Calibration aborted by user*/
        CRSPCCAL_Status_MEASUREMENT_ERROR = 9, /*Measurement error (Purging, FilterLine) - Check wave message*/
        CRSPCCAL_Status_AZ_FAIL = 10, /*AZ Fail*/
        CRSPCCAL_Status_GAS_CONCENTRATION_CHECK = 11, /*No gas or wrong gas concentration*/
        CRSPCCAL_Status_GAS_FLOW_UNSTABLE = 12, /*No stable gas flow*/
        CRSPCCAL_Status_CALIBRATION_FAILURE = 13, /*Calibration Failure*/
        CRSPCCAL_Status_MAX
    } CRSPCCAL_STATUS;

    typedef  enum CRSPCCALtypSPECIES {
        CRSPCCAL_SpCALIBRATION = 11, /*Default Species.*/
        CRSPCCAL_SpMAX
    } CRSPCCAL_SPECIES;

#define CRSPCCAL_METHOD_STRING \
    (GetMsgString((MsgEntry*)TypMethodTbl, \
                 CRSPCCAL_TYPMETHODTBL_SIZE, \
                 m_structData.m_Method))

#define CRSPCCAL_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypStatusTbl, \
                 CRSPCCAL_TYPSTATUSTBL_SIZE, \
                 m_structData.m_Status))

#define CRSPCCAL_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRSPCCAL_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRespCCal Member's Version Enumerations*/
    typedef  enum CRSPCCALtypVERSIONS {
        CRSPCCAL_Status,
        CRSPCCAL_Method,
        CRSPCCAL_GasConcentration,
        CRSPCCAL_MEMBER_MAX
    } CRSPCCAL_VERSIONS;

#define CRSPCCAL_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRSPCCAL_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRESPCCAL_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRESPCCAL_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRESPCCAL_DLLAPI  __declspec(dllimport)
    #else
        #define CRESPCCAL_DLLAPI
    #endif
#endif

class CRESPCCAL_DLLAPI CRespCCal : public DtData
{
public:
    CRespCCal();
    ~CRespCCal();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint16 GetStatus();
    void SetStatus(uint16 new_Status);

    uint8 GetMethod();
    void SetMethod(uint8 new_Method);

    uint8 GetGasConcentration();
    void SetGasConcentration(uint8 new_GasConcentration);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CRespCCal *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint16        m_Status; /* Enumerated value to indicate the calibration status. */
            uint8         m_Method; /* Enumerated value to indicate the calibration method */
            uint8         m_GasConcentration; /* In 0.1% units (This value should be set to 50 decimal (=32h) for 5 Vol% gas. Valid range is 40 to 60 */
    }ClassStruct_t;

#define CRSPCCAL_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 2 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypMethodTbl[];
    static const MsgEntry    TypStatusTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRESPCCAL_H) */

/*---------------------------------------------------*/
/* End of File */
