/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDCO2.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPDCO2_H)
    #define  CRESPDCO2_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif
#include "CNumDStd.h"


/*The following definition is the version.*/
#define CRSPDCO2_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPDCO2typSTATUS {
        CRSPDCO2_Status_NONE = 0, /*None specified*/
        CRSPDCO2_Status_INVALID_VALUE = 1, /*Invalid CO2 Value*/
        CRSPDCO2_Status_INITIALIZATION = 2, /*Initialization*/
        CRSPDCO2_Status_OVER_RANGE = 3, /*CO2 value over range*/
        CRSPDCO2_Status_SFM_REQUEST = 4, /*SFM request*/
        CRSPDCO2_Status_SFM_IN_PROGRESS = 5, /*SFM in progress*/
        CRSPDCO2_Status_PURGING_IN_PROGRESS = 6, /*Purging in progress*/
        CRSPDCO2_Status_FILTER_LINE_NO_CONNECT = 7, /*FilterLine not connected*/
        CRSPDCO2_Status_FAULT_BIT = 8, /*Fault Bit. Check Service codes*/
        CRSPDCO2_Status_MAX
    } CRSPDCO2_STATUS;

    typedef  enum CRSPDCO2typSPECIES {
        CRSPDCO2_SpCO2 = 4, /*Default Species.*/
        CRSPDCO2_SpMAX
    } CRSPDCO2_SPECIES;

#define CRSPDCO2_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypStatusTbl, \
                 CRSPDCO2_TYPSTATUSTBL_SIZE, \
                 m_structData.m_Status))

#define CRSPDCO2_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRSPDCO2_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRespDCO2 Member's Version Enumerations*/
    typedef  enum CRSPDCO2typVERSIONS {
        CRSPDCO2_SequenceNumber,
        CRSPDCO2_Status,
        CRSPDCO2_CO2,
        CRSPDCO2_MEMBER_MAX
    } CRSPDCO2_VERSIONS;

#define CRSPDCO2_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRSPDCO2_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRESPDCO2_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRESPDCO2_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRESPDCO2_DLLAPI  __declspec(dllimport)
    #else
        #define CRESPDCO2_DLLAPI
    #endif
#endif

class CRESPDCO2_DLLAPI CRespDCO2 : public DtData
{
public:
    CRespDCO2();
    ~CRespDCO2();

    /*---------------------------------
    Instances of Objects:
    ---------------------------------*/
    CNumDStd              CO2;

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint16 GetSequenceNumber();
    void SetSequenceNumber(uint16 new_SequenceNumber);

    uint8 GetStatus();
    void SetStatus(uint8 new_Status);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CRespDCO2 *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint16        m_SequenceNumber;
            uint8         m_Status;
    }ClassStruct_t;

#define CRSPDCO2_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 1 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypStatusTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRESPDCO2_H) */

/*---------------------------------------------------*/
/* End of File */
