/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDData.h                                                      //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPDDATA_H)
    #define  CRESPDDATA_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif
#include "CNumDStd.h"


/*The following definition is the version.*/
#define CRSPDDTA_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPDDTAtypSPECIES {
        CRSPDDTA_SpDATA = 1, /*Default species.*/
        CRSPDDTA_SpMAX
    } CRSPDDTA_SPECIES;

#define CRSPDDTA_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRSPDDTA_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRespDData Member's Version Enumerations*/
    typedef  enum CRSPDDTAtypVERSIONS {
        CRSPDDTA_EtCO2,
        CRSPDDTA_FiCO2,
        CRSPDDTA_RR,
        CRSPDDTA_MEMBER_MAX
    } CRSPDDTA_VERSIONS;

#define CRSPDDTA_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRSPDDTA_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRESPDDATA_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRESPDDATA_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRESPDDATA_DLLAPI  __declspec(dllimport)
    #else
        #define CRESPDDATA_DLLAPI
    #endif
#endif

class CRESPDDATA_DLLAPI CRespDData : public DtData
{
public:
    CRespDData();
    ~CRespDData();

    /*---------------------------------
    Instances of Objects:
    ---------------------------------*/
    CNumDStd              EtCO2; /*End Tidal CO2. In mmHg. (FF for invalid value, 100 for overrange. In case of extended CO2 range configuration, 151 for overrange.*/
    CNumDStd              FiCO2; /*Fraction of inspired CO2. In mmHg. (FF for invalid value, 100 for overrange. In case of extended CO2 range configuration, 151 for overrange.*/
    CNumDStd              RR; /*Respiration Rate per minute (FF for invalid value))*/

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    void Reset(boolean bResetAll);

    void SetObjectProperties(CRespDData *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
    }ClassStruct_t;

#define CRSPDDTA_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRESPDDATA_H) */

/*---------------------------------------------------*/
/* End of File */
