/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespDIPI.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPDIPI_H)
    #define  CRESPDIPI_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif
#include "CNumDStd.h"


/*The following definition is the version.*/
#define CRSPDIPI_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPDIPItypSPECIES {
        CRSPDIPI_SpPULMONARYINDEX = 2, /*Default species.*/
        CRSPDIPI_SpMAX
    } CRSPDIPI_SPECIES;

#define CRSPDIPI_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRSPDIPI_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRespDIPI Member's Version Enumerations*/
    typedef  enum CRSPDIPItypVERSIONS {
        CRSPDIPI_PulmonaryIndex,
        CRSPDIPI_MEMBER_MAX
    } CRSPDIPI_VERSIONS;

#define CRSPDIPI_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRSPDIPI_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRESPDIPI_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRESPDIPI_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRESPDIPI_DLLAPI  __declspec(dllimport)
    #else
        #define CRESPDIPI_DLLAPI
    #endif
#endif

class CRESPDIPI_DLLAPI CRespDIPI : public DtData
{
public:
    CRespDIPI();
    ~CRespDIPI();

    /*---------------------------------
    Instances of Objects:
    ---------------------------------*/
    CNumDStd              PulmonaryIndex; /*Integrated pulmonary index. Valid range: 0-10, FF for invalid value*/

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    void Reset(boolean bResetAll);

    void SetObjectProperties(CRespDIPI *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
    }ClassStruct_t;

#define CRSPDIPI_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRESPDIPI_H) */

/*---------------------------------------------------*/
/* End of File */
