/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRespPMsgArg.h                                                    //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CRESPPMSGARG_H)
    #define  CRESPPMSGARG_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CRSPPMSA_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRSPPMSAtypBTPS {
        CRSPPMSA_BTPS_NONE = 0, /*None specified*/
        CRSPPMSA_BTPS_NO_BTPS = 1, /*No BTPS*/
        CRSPPMSA_BTPS_BTPS = 2, /*BTPS*/
        CRSPPMSA_BTPS_MAX
    } CRSPPMSA_BTPS;

    typedef  enum CRSPPMSAtypPICK_MODE {
        CRSPPMSA_PICK_MODE_NONE = 0, /*None specified*/
        CRSPPMSA_PICK_MODE_BREATH_TO_BREATH = 1, /*Breath to breath*/
        CRSPPMSA_PICK_MODE_TEN_SECONDS = 2, /*10 Seconds*/
        CRSPPMSA_PICK_MODE_TWENTY_SECONDS = 3, /*20 Seconds*/
        CRSPPMSA_PICK_MODE_THIRTY_SECONDS = 4, /*30 Seconds*/
        CRSPPMSA_PICK_MODE_MAX
    } CRSPPMSA_PICK_MODE;

    typedef  enum CRSPPMSAtypMESSAGE_CONFIG {
        CRSPPMSA_MESSAGE_CONFIG_NONE = 0, /*None specified*/
        CRSPPMSA_MESSAGE_CONFIG_DISABLED = 1, /*Message disabled*/
        CRSPPMSA_MESSAGE_CONFIG_ENABLED = 2, /*Message enabled*/
        CRSPPMSA_MESSAGE_CONFIG_MAX
    } CRSPPMSA_MESSAGE_CONFIG;

    typedef  enum CRSPPMSAtypPUMP_CONTROL {
        CRSPPMSA_PUMP_CONTROL_NONE = 0, /*None specified*/
        CRSPPMSA_PUMP_CONTROL_DISABLED = 1, /*Pump Disabled*/
        CRSPPMSA_PUMP_CONTROL_ENABLED = 2, /*Pump enabled*/
        CRSPPMSA_PUMP_CONTROL_MAX
    } CRSPPMSA_PUMP_CONTROL;

    typedef  enum CRSPPMSAtypWAVE_INTERVAL {
        CRSPPMSA_WAVE_INTERVAL_NONE = 0, /*None specified*/
        CRSPPMSA_WAVE_INTERVAL_TWENTY_FIVE = 1, /*25 milliseconds*/
        CRSPPMSA_WAVE_INTERVAL_FIFTY = 2, /*50 milliseconds*/
        CRSPPMSA_WAVE_INTERVAL_ONE_HUNDRED = 4, /*100 milliseconds*/
        CRSPPMSA_WAVE_INTERVAL_MAX
    } CRSPPMSA_WAVE_INTERVAL;

    typedef  enum CRSPPMSAtypPATIENT_MODE {
        CRSPPMSA_PATIENT_MODE_NONE = 0, /*None specified*/
        CRSPPMSA_PATIENT_MODE_ADULT = 1, /*Adult*/
        CRSPPMSA_PATIENT_MODE_NEONATE = 2, /*Neonate*/
        CRSPPMSA_PATIENT_MODE_PEDIATRIC_1 = 3, /*Pediatric 1-3 years*/
        CRSPPMSA_PATIENT_MODE_PEDIATRIC_2 = 4, /*Pediatric 3-6 years*/
        CRSPPMSA_PATIENT_MODE_PEDIATRIC_3 = 5, /*Pediatric 6-12 years*/
        CRSPPMSA_PATIENT_MODE_MAX
    } CRSPPMSA_PATIENT_MODE;

    typedef  enum CRSPPMSAtypCO2_RANGE {
        CRSPPMSA_CO2_RANGE_NONE = 0, /*None specified*/
        CRSPPMSA_CO2_RANGE_NINETY_NINE_MAX = 1, /*0-99 mmHg*/
        CRSPPMSA_CO2_RANGE_ONE_HUNDRED_FIFTY_MAX = 2, /*0-150 mmHg*/
        CRSPPMSA_CO2_RANGE_MAX
    } CRSPPMSA_CO2_RANGE;

    typedef  enum CRSPPMSAtypCONFIG_ITEM {
        CRSPPMSA_CONFIG_ITEM_NONE = 0, /*None specified*/
        CRSPPMSA_CONFIG_ITEM_BTPS = 1, /*Configuration for the BTPS setting. The BTPS enumeration is used in the IOParameterB member.*/
        CRSPPMSA_CONFIG_ITEM_PICK_MODE = 2, /*Configuration for the Pick Mode.*/
        CRSPPMSA_CONFIG_ITEM_BREATH_MESSAGE = 3, /*Configuration for the distinguished breath message. The MESSAGE_CONFIG enumeration is used in the IOParameterB member to enable or disable the message.*/
        CRSPPMSA_CONFIG_ITEM_CO2_UNIT = 4, /*Configuration for the CO2 Units.*/
        CRSPPMSA_CONFIG_ITEM_BREATH_MESSAGE_INTERVAL = 5, /*Configuration for the breath message interval.*/
        CRSPPMSA_CONFIG_ITEM_WAVE_MEASURMENT_INTERVAL = 6, /*Configuration for the wave measurement interval. The WAVE_INTERVAL enumeration is used in the IOParameterB member.*/
        CRSPPMSA_CONFIG_ITEM_STANDBY = 7, /*Configuration for the standby mode.*/
        CRSPPMSA_CONFIG_ITEM_PATIENT_MODE = 8, /*Configuration for the patient mode. The PATIENT_MODE enumeration is used in the IOParameterB member.*/
        CRSPPMSA_CONFIG_ITEM_CO2_RANGE = 9, /*Configuration for the CO2 range. The CO2_RANGE enumeration is used in the IOParameterB member.*/
        CRSPPMSA_CONFIG_ITEM_PI_MESSAGE = 10, /*Configuration for the Integrated Pulmonary Index message. The MESSAGE_CONFIG enumeration is used in the IOParameterB member to enable or disable the message.*/
        CRSPPMSA_CONFIG_ITEM_MAX
    } CRSPPMSA_CONFIG_ITEM;

    typedef  enum CRSPPMSAtypEXTENDED_STATUS {
        CRSPPMSA_EXTENDED_STATUS_NONE = 0, /*None specified*/
        CRSPPMSA_EXTENDED_STATUS_CHECK_CALIBRATION = 1, /*Check Calibration*/
        CRSPPMSA_EXTENDED_STATUS_CHECK_FLOW = 2, /*Check Flow*/
        CRSPPMSA_EXTENDED_STATUS_OCCLUSION_GAS_INPUT = 3, /*Occlusion in gas input line*/
        CRSPPMSA_EXTENDED_STATUS_TEMP_OUT_RANGE = 4, /*Temperature out of range*/
        CRSPPMSA_EXTENDED_STATUS_MALFUNCTION = 8, /*Malfunction*/
        CRSPPMSA_EXTENDED_STATUS_PUMP_OFF = 9, /*Pump off*/
        CRSPPMSA_EXTENDED_STATUS_MAX
    } CRSPPMSA_EXTENDED_STATUS;

    typedef  enum CRSPPMSAtypSPECIES {
        CRSPPMSA_SpMSG_ARGUMENTS = 1, /*Default species. Generic Message Argument*/
        CRSPPMSA_SpSELECTOR = 2, /*Species Selector*/
        CRSPPMSA_SpSERVICE_TIME = 3, /*Used for remaining hours to service*/
        CRSPPMSA_SpCALIBRATION_TIME = 4, /*Used for maximum remaining operating hours to calibration*/
        CRSPPMSA_SpSERVICE_CODE = 5, /*Used for service codes. IOParameterA contains the Service Code, IOParameterB contains Time of Service Code occurence (relative to operating hours)*/
        CRSPPMSA_SpPRESSURE = 6, /*Used for ambient pressure. IOParameterA contains the Ambient pressure, IOParameterB is reserved.*/
        CRSPPMSA_SpMODULE = 7, /*Used for Module Configuration. IOParamterA contains the CONFIG_ITEM enumeration, IOParameterB is used for the value of the CONFIG_ITEM*/
        CRSPPMSA_SpPUMP = 8, /*Used to enable or disable the pump. IOParameterA contains the PUMP_CONTROL enumeration. IOParamterB is reserved.*/
        CRSPPMSA_SpEXTSTATUS = 9, /*Used for Extended Status. IOParameterA contains the EXTENDED_STATUS enumeration. IOParamterB is reserved.*/
        CRSPPMSA_SpMAX
    } CRSPPMSA_SPECIES;

#define CRSPPMSA_BTPS_STRING \
    (GetMsgString((MsgEntry*)TypBTPSTbl, \
                 CRSPPMSA_TYPBTPSTBL_SIZE, \
                 m_structData.m_BTPS))

#define CRSPPMSA_PICK_MODE_STRING \
    (GetMsgString((MsgEntry*)TypPICK_MODETbl, \
                 CRSPPMSA_TYPPICK_MODETBL_SIZE, \
                 m_structData.m_PICK_MODE))

#define CRSPPMSA_MESSAGE_CONFIG_STRING \
    (GetMsgString((MsgEntry*)TypMESSAGE_CONFIGTbl, \
                 CRSPPMSA_TYPMESSAGE_CONFIGTBL_SIZE, \
                 m_structData.m_MESSAGE_CONFIG))

#define CRSPPMSA_PUMP_CONTROL_STRING \
    (GetMsgString((MsgEntry*)TypPUMP_CONTROLTbl, \
                 CRSPPMSA_TYPPUMP_CONTROLTBL_SIZE, \
                 m_structData.m_PUMP_CONTROL))

#define CRSPPMSA_WAVE_INTERVAL_STRING \
    (GetMsgString((MsgEntry*)TypWAVE_INTERVALTbl, \
                 CRSPPMSA_TYPWAVE_INTERVALTBL_SIZE, \
                 m_structData.m_WAVE_INTERVAL))

#define CRSPPMSA_PATIENT_MODE_STRING \
    (GetMsgString((MsgEntry*)TypPATIENT_MODETbl, \
                 CRSPPMSA_TYPPATIENT_MODETBL_SIZE, \
                 m_structData.m_PATIENT_MODE))

#define CRSPPMSA_CO2_RANGE_STRING \
    (GetMsgString((MsgEntry*)TypCO2_RANGETbl, \
                 CRSPPMSA_TYPCO2_RANGETBL_SIZE, \
                 m_structData.m_CO2_RANGE))

#define CRSPPMSA_CONFIG_ITEM_STRING \
    (GetMsgString((MsgEntry*)TypCONFIG_ITEMTbl, \
                 CRSPPMSA_TYPCONFIG_ITEMTBL_SIZE, \
                 m_structData.m_CONFIG_ITEM))

#define CRSPPMSA_EXTENDED_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypEXTENDED_STATUSTbl, \
                 CRSPPMSA_TYPEXTENDED_STATUSTBL_SIZE, \
                 m_structData.m_EXTENDED_STATUS))

#define CRSPPMSA_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRSPPMSA_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRespPMsgArg Member's Version Enumerations*/
    typedef  enum CRSPPMSAtypVERSIONS {
        CRSPPMSA_IOParameterA,
        CRSPPMSA_IOParameterB,
        CRSPPMSA_MEMBER_MAX
    } CRSPPMSA_VERSIONS;

#define CRSPPMSA_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRSPPMSA_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRESPPMSGARG_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRESPPMSGARG_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRESPPMSGARG_DLLAPI  __declspec(dllimport)
    #else
        #define CRESPPMSGARG_DLLAPI
    #endif
#endif

class CRESPPMSGARG_DLLAPI CRespPMsgArg : public DtData
{
public:
    CRespPMsgArg();
    ~CRespPMsgArg();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint16 GetIOParameterA();
    void SetIOParameterA(uint16 new_IOParameterA);

    uint16 GetIOParameterB();
    void SetIOParameterB(uint16 new_IOParameterB);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CRespPMsgArg *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint16        m_IOParameterA; /* Generic parameter used for species selector to retrieve a configuration module. */
            uint16        m_IOParameterB; /* Generic parameter used for */
    }ClassStruct_t;

#define CRSPPMSA_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypBTPSTbl[];
    static const MsgEntry    TypPICK_MODETbl[];
    static const MsgEntry    TypMESSAGE_CONFIGTbl[];
    static const MsgEntry    TypPUMP_CONTROLTbl[];
    static const MsgEntry    TypWAVE_INTERVALTbl[];
    static const MsgEntry    TypPATIENT_MODETbl[];
    static const MsgEntry    TypCO2_RANGETbl[];
    static const MsgEntry    TypCONFIG_ITEMTbl[];
    static const MsgEntry    TypEXTENDED_STATUSTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRESPPMSGARG_H) */

/*---------------------------------------------------*/
/* End of File */
