/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CServerStub.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CSERVERSTUB_H)
    #define  CSERVERSTUB_H

#include "Common.h"
#include "CMOMPBaseClass.h"
#include "CFamilyEnum.h"
#include "CFamilyStub.h"
#include <list>

using namespace std;

    struct ConnStruct
    {
        CFamilyStub *pClass;
        char        *pSourceID;
        CWACPApp    *pWACPAppPtr;
    };

    typedef list < ConnStruct > CONNECTION_LIST;

class CServerStub : public CMOMPBaseClass
{ 
private:


    CONNECTION_LIST   ConnList;
    uint8             ConnCount;

public:
    CServerStub();
    ~CServerStub();

    CMOMPBaseClass* AppInit(CWACPApp *pWACPAppRef, boolean bSvrFlag, char *pServerSourceID);
    uint32 AppEnd(CWACPApp *pWACPAppRef);
    uint32 RecvMessage(char *pSourceID, uint32 ClassID, uint8 *pBuffer);
    uint32 RecvError(char *pSourceID, uint8 ErrorType, uint32 ClassID, uint8 *pBuffer);
    uint32 RecvConnection(char *pSourceID, uint8 ConnType, uint8 *pBuffer);

    uint32 GetConnCount();
    uint32 DisplayConnections();
    char*  GetConnSourceID(uint32 Index);
    CFamilyStub* GetConnFamilyStub(uint32 Index);

    boolean TerminateConn(uint32 Index);
    boolean TerminateAll();
    CFamilyStub* TestByPass();

};


#endif /* #if !defined(CSERVERSTUB_H) */

/*---------------------------------------------------*/
/* End of File */

