/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CSpO2DData.h                                                      //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_PCO2.xml version 0.1.0
'*-E************************************************************************/

#if !defined(CSPO2DDATA_H)
    #define  CSPO2DDATA_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif
#include "CNumDStd.h"


/*The following definition is the version.*/
#define CSP2DDTA_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CSP2DDTAtypSOURCE {
        CSP2DDTA_Source_NONE = 0, 
        CSP2DDTA_Source_UNKNOWN, 
        CSP2DDTA_Source_NONIN = 10, 
        CSP2DDTA_Source_NELLCOR_MP205, 
        CSP2DDTA_Source_NELLCOR_MP506, 
        CSP2DDTA_Source_MASIMO_MS11, 
        CSP2DDTA_Source_NELLCOR_NELL3, 
        CSP2DDTA_Source_NELLCOR_NELL1, 
        CSP2DDTA_Source_MAX
    } CSP2DDTA_SOURCE;

    typedef  enum CSP2DDTAtypSTATUS {
        CSP2DDTA_Status_NONE = 0, 
        CSP2DDTA_Status_SEARCHING_FOR_BOARD, /*Identifying SpO2 board*/
        CSP2DDTA_Status_NO_PROBE, /*Sensor is not attached*/
        CSP2DDTA_Status_INCORRECT_PROBE, /*Incorrect sensor is attached*/
        CSP2DDTA_Status_SEARCHING_FOR_PULSE, /*Searching for pulse*/
        CSP2DDTA_Status_PULSE_FOUND, /*Pulse detected*/
        CSP2DDTA_Status_MAX
    } CSP2DDTA_STATUS;

    typedef  enum CSP2DDTAtypSPECIES {
        CSP2DDTA_SpDATA = 1, 
        CSP2DDTA_SpMAX
    } CSP2DDTA_SPECIES;

#define CSP2DDTA_SOURCE_STRING \
    (GetMsgString((MsgEntry*)TypSourceTbl, \
                 CSP2DDTA_TYPSOURCETBL_SIZE, \
                 m_structData.m_Source))

#define CSP2DDTA_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypStatusTbl, \
                 CSP2DDTA_TYPSTATUSTBL_SIZE, \
                 m_structData.m_Status))

#define CSP2DDTA_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CSP2DDTA_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CSpO2DData Member's Version Enumerations*/
    typedef  enum CSP2DDTAtypVERSIONS {
        CSP2DDTA_STime,
        CSP2DDTA_Status,
        CSP2DDTA_Source,
        CSP2DDTA_Sat,
        CSP2DDTA_HR,
        CSP2DDTA_PI,
        CSP2DDTA_MEMBER_MAX
    } CSP2DDTA_VERSIONS;

#define CSP2DDTA_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CSP2DDTA_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CSPO2DDATA_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CSPO2DDATA_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CSPO2DDATA_DLLAPI  __declspec(dllimport)
    #else
        #define CSPO2DDATA_DLLAPI
    #endif
#endif

class CSPO2DDATA_DLLAPI CSpO2DData : public DtData
{
public:
    CSpO2DData();
    ~CSpO2DData();

    /*---------------------------------
    Instances of Objects:
    ---------------------------------*/
    CNumDStd              Sat; /*O2 Saturation {in % units}*/
    CNumDStd              HR; /*SpO2 Heart Rate {in BPM (Beats/Minute) units}*/
    CNumDStd              PI; /*SpO2 Perfusion Index {in % units}*/

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    MOIB_TIME GetSTime();
    void SetSTime(MOIB_TIME new_STime);

    uint16 GetStatus();
    void SetStatus(uint16 new_Status);

    uint16 GetSource();
    void SetSource(uint16 new_Source);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CSpO2DData *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            MOIB_TIME     m_STime; /* Time reading was taken. Host specified. Not Sensor. */
            uint16        m_Status; /* DATA_NOT_AVAIL, DATA_COMPLETE, etc. Sensor Specified. */
            uint16        m_Source; /* Source of data. Sensor Specified. */
    }ClassStruct_t;

#define CSP2DDTA_STATIC_STRUCT_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypSourceTbl[];
    static const MsgEntry    TypStatusTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CSPO2DDATA_H) */

/*---------------------------------------------------*/
/* End of File */
