// Copyright in this code is held by Dr B. R. Gladman but free direct or
// derivative use is permitted subject to acknowledgement of its origin.
// There are no guarantees of correctness or fitness for purpose.
// Dr B. R. Gladman <brg@gladman.me.uk>
#ifndef AES_H
#define AES_H

#include "target.h"
#if defined(ENCRYPTION_ON)

    const int n_row = 4; // the number or rows in the state
    const int n_col = 4; // the number or columns in the state
    const int n_maxr = 14; // the maximum number of cipher rounds
    typedef unsigned char aes_elem; // a finite field element in GF(256)
    typedef aes_elem aes_col[n_row]; // a column of four GF(256) elements
    typedef aes_col aes_state[n_col];// an array of columns for the state
class AESCrypt
{
    aes_state key_sch[n_maxr + 1]; // the key schedule
    int key_len;
    public:
        AESCrypt(void) : key_len(0) {};
        bool aes_key(const void *key, int keylen);
        bool aes_encrypt(const void* pt, void* ct) const;
        bool aes_decrypt(const void* ct, void* pt) const;
};

#endif /* #if defined(ENCRYPTION_ON) */

#endif

