/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CAESWrapper.cpp:                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#include "CAESWrapper.h"

#if defined(ENCRYPTION_ON)

void ChunkAESEncrypt(const uint8* Key, const uint8* Plaintext, uint8* Ciphertext, uint32 MsgLen)
{
    AESCrypt Enc;

    /*setup the key*/
    Enc.aes_key(Key,AES_KEY_BITS);

    uint32 i,j,NumChunks;
    uint32 ChunkIndex=0;
    uint8 ThisChunk[16];
    uint8 ThisEncChunk[16];

    /* Determine number of 16 byte chunks in the message */
    NumChunks = MsgLen / (uint32)16;

    /*Encrypt data from Plaintext in 16 byte chunks*/
    for(i=0;i<NumChunks;i++)
    { 
        for(j=0;j<16;j++)
            ThisChunk[j]=Plaintext[ChunkIndex+j];
        Enc.aes_encrypt(ThisChunk,ThisEncChunk);
        for(j=0;j<16;j++)
            Ciphertext[ChunkIndex+j]=ThisEncChunk[j];
        ChunkIndex=ChunkIndex+16;
    }
    
}

void ChunkAESDecrypt(const uint8* Key, const uint8* CipherText, uint8* PlainText, uint32 MsgLen)
{
    AESCrypt Dec;

    /*setup the key*/
    Dec.aes_key(Key,AES_KEY_BITS);

    uint32 i,j,NumChunks;
    uint32 ChunkIndex=0;
    uint8 ThisChunk[16];
    uint8 ThisDecChunk[16];

    /* Determine number of 16 byte chunks in the message */
    NumChunks = MsgLen / (uint32)16;

    /*Decrypt data from msg in 16 byte chunks*/
    for(i=0;i<NumChunks;i++)
    {
        for(j=0;j<16;j++)
            ThisChunk[j]=CipherText[ChunkIndex+j];
        Dec.aes_decrypt(ThisChunk,ThisDecChunk);
        for(j=0;j<16;j++)
            PlainText[ChunkIndex+j]=ThisDecChunk[j];
        ChunkIndex=ChunkIndex+16;
    }

}
#endif /* #if defined(ENCRYPTION_ON) */


