/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataObjSvr.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CDATAOBJSVR_H)
    #define  CDATAOBJSVR_H

#include "CObjSvr.h"
#include "CMsgSvr.h"
#include "CTrapObjSvr.h"
#include "CTraceSvr.h"

class CDataObjSvr : public CObjSvr
{
/*================================================================================
MODULE Members: Public, Private, and Protected
================================================================================*/
private:
    CMsgSvr     MsgSvrIn;
    CMsgSvr     MsgSvrOut;

    CTrapObjSvr *pTrapServer;
    CTraceSvr *pTraceServer;

    /*================================================================================
    MODULE Utility - Callback Function pointers
    ================================================================================*/
    DataFuncPtr         pMessageHandler;
    SendPacketFuncPtr   pSendMsg;

    char *pSemName;
    LinkStruct *pLnkStruct;

public:
    /*================================================================================
    MODULE Start up: All available servers are instantiated here. i.e Command Servers,
    Request Servers, Response Servers, etc.
    ================================================================================*/
    CDataObjSvr();
    ~CDataObjSvr();

    void Init(CTrapObjSvr *pTrapObjSvr,
              CTraceSvr *pTraceSvr,
              boolean (*SendPacket)(char*, char*, uint8*, uint32),
              LinkStruct *pLinkStruct);

    boolean SetCallbacks(va_list vList);

    /*================================================================================
    MODULE Message
    ================================================================================*/
    boolean SetMessageFunc(uint32 (*RxMessage)(char*, uint32, uint8*, void *));
    
    /*================================================================================
    MODULE Command, Response, and Request Routing  
    ================================================================================*/
    boolean TxMsg(char *pSourceID, CMsgSvr *pMsgSvr, uint16 Family, uint8 Genus, 
                  uint8 Species, uint8* Payload,uint32 Size, boolean bEncryptionOn);
    boolean RecvMsgHandler(char *pSourceID, uint8 *pBuffer, void *pRouter);
    boolean SendMsgHandler(char *pSourceID, uint16 Family, uint8 Genus, uint8 Species, 
                           uint8 *pBuffer, uint32 Size, boolean bEncryptionOn);

};
#endif /* #if !defined(CDATAOBJSVR_H) */

/*---------------------------------------------------*/
/* End of File */
