/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CEncryption.h  :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CENCRYPTION_H)
    #define  CENCRYPTION_H

#include "target.h"
#if defined(ENCRYPTION_ON)

#include "AESCrypt.h"
#include "StdVarTyp.h"
#include "CAESWrapper.h"

#define AES_ENCRYPTION_KEY_SIZE 16

class CEncryption
{
    public:
        CEncryption();
        ~CEncryption();

        void AESEncrypt(uint8* Key, uint8* Plaintext, uint8* Ciphertext, uint32 MsgLen);
        void AESDecrypt(uint8* Key, uint8* Ciphertext, uint8* Plaintext, uint32 MsgLen);
        void GenerateAESKey(uint8* Key);  
};

#endif /* #if defined(ENCRYPTION_ON) */

#endif /* #if !defined(CENCRYPTION_H) */
/*---------------------------------------------------*/
/* End of File */


