/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrSvr.h      :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CERRSVR_H)
    #define  CERRSVR_H

#include "DtData.h"

/*The following definition is the version.*/
#define CES_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/

    typedef  enum CEStypSPECIES {
        CES_SpNONE = 0,
        CES_SpWACPSTACK,
        CES_SpERRMSGPROC,
        CES_SpERRAPPINTERNAL,
        CES_SpLOOPBACK,
        CES_SpMAX
    } CES_SPECIES;

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
#define CES_SPECIES_STRING      TypSpeciesTbl[species()]

class CErrSvr : public DtData
{
public:
    CErrSvr(uint8 genus);
    CErrSvr();
    ~CErrSvr();

    /*---------------------------------
    Functions:
    ---------------------------------*/
    void    SetClassID(uint32 NewID);
    uint32  GetClassID();

    void    SetData(uint8* NewData, uint32 Size);
    uint8*  GetData(uint32 *Size);

    /*---------------------------------
      Inherited/Overidden functions:
      Functions derived from DtData
    ---------------------------------*/
    boolean is_Extended(uint8* pBuffer);
    boolean is_Extended(uint32 ClassID);

#if ((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif


/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /* Static Data */
        uint32  ClassID;
    }ClassStruct_t;

    /* Dynamic Data */
    uint8       *Data;
    uint32      DataSize;

#define CES_STATIC_STRUCT_SIZE (sizeof(uint32))

protected:
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32  get_payload_size ( void );
    boolean serialize_payload ( uint8QManager * QMgr  );
    boolean deserialize_payload ( uint8QManager * QMgr, uint32 Sz );

    /*---------------------------------
    Enumeration related String tables.
    ---------------------------------*/
    static const char   *TypSpeciesTbl[CES_SpMAX];
/*---------------------------------------------------*/
private:

#if ((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void serialize_static_data(uint8QManager * QMgr);
    void deserialize_static_data(uint8QManager *QMgr);

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t       m_structData;
};
#endif /* #if !defined(CERRSVR_H) */

/*---------------------------------------------------*/
/* End of File */



