/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFamilyEnum.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CFAMILYENUM_H)
    #define  CFAMILYENUM_H

    /* FmDEVICE Message Enumerations */
    typedef enum DEVICECCMDtypSPECIES{
        DEVICE_CCMD_SpWRITE_CONFIG,/*Requires a CDeviceCStd object or CDeviceCAudio object.*/
        DEVICE_CCMD_SpWRITE_DEVICEDESCRIPTION,/*Writes the CDeviceDStd object. ATE only. Requires a CDeviceDStd if a single object is written or a CDeviceDExtStd object containing 1 or more CDeviceDStd objects. The species of the CDeviceDStd objects should be set with the appropriate subsystem (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor ). A legacy messge formerly labeled as 'WRITE_DATA'*/
        DEVICE_CCMD_SpENABLE_DISPLAY,/*Display control. Toggles the display on/off with no message argument.*/
        DEVICE_CCMD_SpSTART_DISPLAY_TEST,/*Sets the device display. Requires a CDeviceCLCD that has the enumerated state of within LCD*/
        DEVICE_CCMD_SpRESET,/*Resets the device to use the current configuration settings.*/
        DEVICE_CCMD_SpPOWER,/*Sets the device power state. Requires a CDevPMsgArguments with the IOParameterA set to a PowerControl value. PowerControl should be published by the devices since different control variables may exist*/
        DEVICE_CCMD_SpBEEP,/*Sounds the device speakers. Requires a CDeviceCAudio.*/
        DEVICE_CCMD_SpSAVE_CONFIG,/*Save the current user configuration settings to non-volatile memory*/
        DEVICE_CCMD_SpRESTORE_CONFIG,/*Restore user configuration settings to their factory defaults*/
        DEVICE_CCMD_SpENABLE_AUTO_POWER_DOWN,/*Enable or disable device auto power down*/
        DEVICE_CCMD_SpSET_DISPLAY_CONTRAST,/*Sets display configuration for contrast. Requires a CDeviceCLCD.*/
        DEVICE_CCMD_SpSET_BACKLIGHT,/*Sets the display configuration for backlight level. Requires a CDeviceCLCD.*/
        DEVICE_CCMD_SpSTART_DIGITAL_TEST,/*Sets the Digital Output Lines. Requires a CDevPMsgArguments with IOParameterA set a value indicating the bits correlating to digital lines to signal. The bit-to-digital line representation is published by each subsystem.*/
        DEVICE_CCMD_SpSET_DEVICE_MODE,/*Sets the device mode. Requires a CDevPMsgArguments with IOParameterA set with the device mode enumeration.*/
        DEVICE_CCMD_SpMAX
    } DEVICE_CCMD_SPECIES;

    typedef enum DEVICECRSTtypSPECIES{
        DEVICE_CRST_SpGET_DEVICEDESCRIPTION,/*May contain a CDevPMsgArguments with the SpeciesSelector set to indicate what subsystem's CDeviceDStd object to retrieve (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor | SpALL = All subsytems).*/
        DEVICE_CRST_SpGET_CONFIG,/*Requires a CDevPMsgArguments with the SpeciesSelector set to indicate what configuration object to retrieve (SpeciesSelector: SpSTANDARD = CDeviceCStd | SpAUDIO = CDeviceCAudio | SpLCD = CDeviceCLCD)*/
        DEVICE_CRST_SpGET_POST,/*May contain a CDevPMsgArguments with the SpeciesSelector set to indicate the subsystem to retrieve the post status. (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor | SpALL = All subsytems)*/
        DEVICE_CRST_SpGET_DIGITAL_STATE,/*Gets the Digital Input State of the device.*/
        DEVICE_CRST_SpGET_DEVICE_MODE,/*Requests the current device mode from the device. No object required in payload.*/
        DEVICE_CRST_SpMAX
    } DEVICE_CRST_SPECIES;

    typedef enum DEVICECRSPtypSPECIES{
        DEVICE_CRSP_SpPUT_DEVICEDESCRIPTION,/*May contain a CDeviceDExtStd object containing 1 or more CDeviceDStd object or a single CDeviceDStd object. The CDeviceDStd objects must be set with the proper Species for the subsystem (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor)*/
        DEVICE_CRSP_SpPUT_CONFIG,/*Requires a CDeviceCStd object or CDeviceCAudio object.*/
        DEVICE_CRSP_SpPUT_POST,/*Requires a CDeviceDExtStd containing 1 or more CDevDPOST object or a single CDevDPOST object. The CDevDPOST object must contain the post status of the requested subsytems*/
        DEVICE_CRSP_SpPUT_DIGITAL_STATE,/*Returns the Gets the Digital Input State of device. Requires a CDevPMsgArguments with IOParameterA set a value indicating the bits correlating to digital lines to signal. The bit-to-digital line representation is published by each subsystem.*/
        DEVICE_CRSP_SpPUT_DEVICE_MODE,/*Returns the current device mode from the device. A CDevPMsgArguments object is required with IOParameterA set with the device mode published by the device.*/
        DEVICE_CRSP_SpMAX
    } DEVICE_CRSP_SPECIES;

    /* FmMODULE Message Enumerations */
    typedef enum MODULECCMDtypSPECIES{
        MODULE_CCMD_SpWRITE_CONFIG,/*Legacy message.*/
        MODULE_CCMD_SpWRITE_MODULE_DESC,/*Requires a CModuleDStd object.*/
        MODULE_CCMD_SpMAX
    } MODULE_CCMD_SPECIES;

    typedef enum MODULECRSTtypSPECIES{
        MODULE_CRST_SpGET_MODULE_DESC,/*Requires a CModulePSelector object.*/
        MODULE_CRST_SpMAX
    } MODULE_CRST_SPECIES;

    typedef enum MODULECRSPtypSPECIES{
        MODULE_CRSP_SpPUT_MODULE_DESC,/*Requires a Record containing CModuleDExtStd objects.*/
        MODULE_CRSP_SpMAX
    } MODULE_CRSP_SPECIES;

    /* FmERROR Message Enumerations */
    typedef enum ERRORCRSTtypSPECIES{
        ERROR_CRST_SpGET_ERROR,/*Requires a CErrPGetError object*/
        ERROR_CRST_SpMAX
    } ERROR_CRST_SPECIES;

    typedef enum ERRORCRSPtypSPECIES{
        ERROR_CRSP_SpPUT_ERROR,/*Requires a CErrDExtStd object.*/
        ERROR_CRSP_SpMAX
    } ERROR_CRSP_SPECIES;

    typedef enum ERRORCSStypSPECIES{
        ERROR_CSS_SpREPORT_ERROR,/*Requires a CErrEStd object. Used to push error messages during changes of state.*/
        ERROR_CSS_SpMAX
    } ERROR_CSS_SPECIES;

    /* FmRESPIRATION Message Enumerations */
    typedef enum RESPIRATIONCCMDtypSPECIES{
        RESPIRATION_CCMD_SpRESTART_BREATH_ALG,/*Sent when the host determines that there is a 'no breath detected' condition in order to ensure correct EtCO2, FiCO2, and RR calculations upon resumption of breathing.*/
        RESPIRATION_CCMD_SpSET_CALIBRATION_DATE,/*A message to set the calibration date. Requires a CRespCDate object.*/
        RESPIRATION_CCMD_SpSTART_CALIBRATION,/*A message to start the calibration. Requires a CRespCCal object.*/
        RESPIRATION_CCMD_SpSTOP_CALIBRATION,/*A message to stop the calibration. No object required in payload.*/
        RESPIRATION_CCMD_SpFORCE_SFM,/*A command to force SFM. No object required in payload*/
        RESPIRATION_CCMD_SpPUMP_CONTROL,/*A command to enable or disable the pump. Requires a CRespPMsgArg object with species set to SpPUMP*/
        RESPIRATION_CCMD_SpMAX
    } RESPIRATION_CCMD_SPECIES;

    typedef enum RESPIRATIONCRSTtypSPECIES{
        RESPIRATION_CRST_SpGET_BREATH,/*A request to get the breath measurement. No object required in payload*/
        RESPIRATION_CRST_SpGET_AMBIENT_PRESSURE,/*A request to get the ambient pressure. No object required in the payload.*/
        RESPIRATION_CRST_SpGET_MODULE_CONFIG,/*A request to get a module configuration. Requires a CRespPMsgArg object with species set to SpMODULE and IOParameterA set to CONFIG_ITEM to return*/
        RESPIRATION_CRST_SpGET_CALIBRATION_DATE,/*A message to request the calibration date. No object required in payload.*/
        RESPIRATION_CRST_SpGET_CALIBRATION,/*A message to request the calibration status. No object required in payload.*/
        RESPIRATION_CRST_SpGET_EXTENDED_STATUS,/*A message to request the extended status. No object required in payload.*/
        RESPIRATION_CRST_SpGET_CAL_TIME,/*A message to request the remaining hours for calibration. No object required in payload.*/
        RESPIRATION_CRST_SpGET_SERVICE_TIME,/*A message to request the remaining hours for calibration. No object required in payload.*/
        RESPIRATION_CRST_SpGET_LAST_SERVICE_CODE,/*A message to request the last service code. No object required in payload.*/
        RESPIRATION_CRST_SpGET_SERVICE_CODES,/*A message to request the last service code. No object required in payload.*/
        RESPIRATION_CRST_SpMAX
    } RESPIRATION_CRST_SPECIES;

    typedef enum RESPIRATIONCRSPtypSPECIES{
        RESPIRATION_CRSP_SpPUT_BREATH,/*A response to the GET_BREATH message. Returns the breath measurement. Requires a CRespDData object.*/
        RESPIRATION_CRSP_SpPUT_AMBIENT_PRESSURE,/*A response to the GET_AMBIENT_PRESSURE message. Requires a CRespDPressure object.*/
        RESPIRATION_CRSP_SpPUT_MODULE_CONFIG,/*A response to the GET_MODULE_CONFIG message. Requires a CRespPMsgArg object with species set to SpMODULE and IOParameterA set to the CONFIG_ITEM and IOParameterB set to the CONFIG_ITEM value.*/
        RESPIRATION_CRSP_SpPUT_CALIBRATION_DATE,/*A response to the PUT_CALIBRATION_DATE message. Requires a CRespCDate*/
        RESPIRATION_CRSP_SpPUT_CALIBRATION,/*A response to the PUT_CALIBRATION message. Requires a CRespCCal*/
        RESPIRATION_CRSP_SpPUT_EXTENDED_STATUS,/*A response to the PUT_EXTENDED_STATUS message. Requires a CRespPMsgArg with the species set to SpEXTSTATUS.*/
        RESPIRATION_CRSP_SpPUT_CAL_TIME,/*A response to the GET_CAL_TIME message. Requires a CRespPMsgArg object with the appropriate species set (Hours to calibration = SpCALIBRATION_TIME) and IOParameterA contains the calibration time.*/
        RESPIRATION_CRSP_SpPUT_SERVICE_TIME,/*A response to the GET_SERVICE_TIME message. Requires a CRespPMsgArg object with the appropriate species set (Hours to service = SpSERVICE) and IOParameterA contains the service time.*/
        RESPIRATION_CRSP_SpPUT_LAST_SERVICE_CODE,/*A response to the GET_LAST_SERVICE_CODE message. Requires a CRespPMsgArg object with species set to SpSERVICE_CODE*/
        RESPIRATION_CRSP_SpPUT_SERVICE_CODES,/*A response to the GET_SERVICE_CODES message. Requires a CRespDExtStd containing 1 or more CRespPMsgArg objects*/
        RESPIRATION_CRSP_SpMAX
    } RESPIRATION_CRSP_SPECIES;

    typedef enum RESPIRATIONCSStypSPECIES{
        RESPIRATION_CSS_SpREPORT_BREATH_DETECT,/*A message to indicate a breath measurement after a significant breath detection. Requires a CRespDData object*/
        RESPIRATION_CSS_SpREPORT_BREATH,/*A periodic message to indicate a breath measurement. Requires a CRespDData object.*/
        RESPIRATION_CSS_SpREPORT_PI,/*A periodic message (once per second) to indicate a pulmonary index measurement. Requires a CRespDIPI object.*/
        RESPIRATION_CSS_SpMAX
    } RESPIRATION_CSS_SPECIES;

    typedef enum RESPIRATIONCSTRtypSPECIES{
        RESPIRATION_CSTR_SpSTREAM_CO2,
        RESPIRATION_CSTR_SpMAX
    } RESPIRATION_CSTR_SPECIES;

    /* FmSPO2 Message Enumerations */
    typedef enum SPO2CCMDtypSPECIES{
        SPO2_CCMD_SpSTART_ACQUIRE,/*Command to start sending SpO2 reading.*/
        SPO2_CCMD_SpSTOP_ACQUIRE,/*Command to stop sending SpO2 reading.*/
        SPO2_CCMD_SpMAX
    } SPO2_CCMD_SPECIES;

    typedef enum SPO2CRSTtypSPECIES{
        SPO2_CRST_SpGET_SPO2,/*Requests the last SpO2 reading.*/
        SPO2_CRST_SpGET_CONFIG,/*Requests the SpO2 confguration.*/
        SPO2_CRST_SpMAX
    } SPO2_CRST_SPECIES;

    typedef enum SPO2CRSPtypSPECIES{
        SPO2_CRSP_SpPUT_SPO2,/*Returns the last SpO2 reading. Requires a CSpO2DData object.*/
        SPO2_CRSP_SpPUT_CONFIG,/*Returns the SpO2 confguration. Requires a CSpO2CData object.*/
        SPO2_CRSP_SpMAX
    } SPO2_CRSP_SPECIES;

    typedef enum SPO2CSStypSPECIES{
        SPO2_CSS_SpREPORT_SPO2,/*Returns the last SpO2 reading. Requires a CSpO2DData object.*/
        SPO2_CSS_SpMAX
    } SPO2_CSS_SPECIES;

    typedef enum SPO2CSTRtypSPECIES{
        SPO2_CSTR_SpSTREAM_SPO2,
        SPO2_CSTR_SpMAX
    } SPO2_CSTR_SPECIES;

#endif /* #if !defined(CFAMILYENUM_H) */

/*---------------------------------------------------*/
/* End of File */
