/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmRouter.cpp  :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CFMROUTER_H)
    #define  CFMROUTER_H

#include "Common.h"
#include "DtSupport.h"
#include "CObjSvr.h"
#include "CTraceSvr.h"
#include "CTrapObjSvr.h"
#include "Dt.h"

typedef enum typObjSvr{
    OBJSVR_RNDZ = 0,
    OBJSVR_TRAP,
    OBJSVR_CONN,
    OBJSVR_DATA,
    OBJSVR_MAX
}OBJSVR;

class CFmRouter
{
/*================================================================================
CFmRouter Members: Public, Private, and Protected
================================================================================*/
private:
    CObjSvr *ObjSvrList[OBJSVR_MAX];
    
    /* Pointer to the CWACPApp instance */
    CTraceSvr   *pTraceSvr;
    CTrapObjSvr *pTrapSvr;
    void        *pWACPApp;

    /* Trace Log Counts */
    uint32      MsgInCount;
    uint32      MsgOutCount;

public:
    /*================================================================================
    NIBP Start up: All available servers are instantiated here. i.e Command Servers,
    Request Servers, Response Servers, etc.
    ================================================================================*/
    CFmRouter();
    ~CFmRouter();

    void Init(CTraceSvr *pCTraceSvr, CTrapObjSvr *pCTrapObjSvr, void *pWACPApp);

    /*================================================================================
    FmRouter Register object servers  
    ================================================================================*/
    boolean registerServer(FAMILY Family, CObjSvr* pObjSvr);
    boolean registerCallbacks(FAMILY Family, va_list vList);

    /*================================================================================
    FmRouter Command, Response, and Request Routing  
    ================================================================================*/
    boolean RecvMsg(char *pSourceID, uint8 *pBuffer, uint32 Size);
    boolean SendMsg(char *pSourceID, uint16 Family, uint8 Genus, uint8 Species, 
                     uint8 *pBuffer, uint32 Size, boolean EncryptionOn);
};
#endif /* #if !defined(CFMROUTER_H) */

/*---------------------------------------------------*/
/* End of File */





