/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CLinkTable.h   :                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CLINKTABLE_H)
    #define  CLINKTABLE_H

#include "Target.h"
#include "Common.h"

class CLinkTable
{
/*================================================================================
CLinkTable Members: Public, Private, and Protected
================================================================================*/
public:
    CLinkTable();
    ~CLinkTable();
    
    boolean  AddEntry(ConnArgs* pConnArgs);
    boolean  RemoveEntry(ConnArgs* pConnArgs);
    int32    GetEntryIndex(char* pSourceID);
    ConnArgs* GetEntry(char* pSourceID);
    void     GetSourceList(char** pSourceList);
    
private:
    uint16    Count;

public:
    ConnArgs* Connection[MAX_CONNECTIONS];
};
#endif /* #if !defined(CLINKTABLE_H) */

/*---------------------------------------------------*/
/* End of File */





