/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CTraceSvr.h    :                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CTRACESVR_H)
    #define  CTRACESVR_H

#include "SysUtil.h"
#include "Common.h"
#include <stdarg.h>

#define PRINT_TO_FILE_MASK 0x01
#define PRINT_TO_SCREEN_MASK 0x02

#define DEFAULT_FILENAME "TraceLog_DEFAULT.xml"
#define DEFAULT_XSL_REFERENCE "TraceTransform.xsl"
#define DEFAULT_UNIQUEID_STRING "GENERIC UNIQUE ID"

#define TRACE_TRANSFORM_XSL \
"<?xml version='1.0'?>\n" \
"<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">\n" \
"<xsl:output method=\"html\"/>\n" \
"\n" \
"<xsl:template name=\"replaceChar\">\n" \
"\t<xsl:param name=\"string\" />\n" \
"\t<xsl:param name=\"character\" />\n" \
"\t<xsl:param name=\"replaceString\" />\n" \
"\t<xsl:choose>\n" \
"\t\t<xsl:when test=\"contains($string, $character)\">\n" \
"\t\t\t<xsl:value-of select=\"substring-before($string, $character)\" />\n" \
"\t\t\t<xsl:value-of select=\"$replaceString\" />\n" \
"\t\t\t<xsl:call-template name=\"replaceChar\">\n" \
"\t\t\t\t<xsl:with-param name=\"string\" select=\"substring-after($string, $character)\" />\n" \
"\t\t\t\t<xsl:with-param name=\"character\" select=\"$character\" />\n" \
"\t\t\t\t<xsl:with-param name=\"replaceString\" select=\"$replaceString\" />\n" \
"\t\t\t</xsl:call-template>\n" \
"\t\t</xsl:when>\n" \
"\t\t<xsl:otherwise>\n" \
"\t\t\t<xsl:value-of select=\"$string\" />\n" \
"\t\t</xsl:otherwise>\n" \
"\t</xsl:choose>\n" \
"</xsl:template>\n" \
"\n" \
"<xsl:template match=\"/\">\n" \
"<html>\n" \
"<head>\n" \
"<title>Trace Log</title>\n" \
"<style>\n" \
"\t.noBorders{\t\n" \
"\t\tFONT-Size: 12px; \n" \
"\t\tCOLOR: #012d96; \n" \
"\t\tFONT-FAMILY: arial;\n" \
"\t\tborder-top-width:0;\n" \
"\t\tborder-left-width:0;\n" \
"\t\tborder-right-width:0;\n" \
"\t\tborder-bottom-width:0\n" \
"\t}\n" \
"\t.button{\n" \
"\t\tborder-style: solid; \n" \
"\t\tborder-color: #000000;\n" \
"\t\tborder-width: 1;\n" \
"\t\tcursor: default;\n" \
"\t\tbackground-color:#c6cfe7;\n" \
"\t}\n" \
"</style>\n" \
"</head>\n" \
"<SCRIPT>\n" \
"\tfunction toggleRows(check, type)\n" \
"\t{\n" \
"\t\tvar entryCount = document.getElementById('entryTable').children[0].children.length;\n" \
"\t\tfor(var i = 2; i &lt; entryCount; i++)\n" \
"\t\t{\n" \
"\t\t\tif(document.getElementById('entryTable').children[0].children[i].children[2].style.color == check)\n" \
"\t\t\t{\n" \
"\t\t\t\tif(document.getElementById('entryTable').children[0].children[i].style.display == 'none')\n" \
"\t\t\t\t{\n" \
"\t\t\t\t\tdocument.getElementById('entryTable').children[0].children[i].style.display = 'block';\n" \
"\t\t\t\t}\n" \
"\t\t\t\telse\n" \
"\t\t\t\t{\n" \
"\t\t\t\t\tdocument.getElementById('entryTable').children[0].children[i].style.display = 'none';\n" \
"\t\t\t\t}\n" \
"\t\t\t}\n" \
"\t\t}\n" \
"\t\tif(document.getElementById(type).innerText == 'Hide')\n" \
"\t\t{\n" \
"\t\t\tdocument.getElementById(type).innerText = 'Show';\n" \
"\t\t}\n" \
"\t\telse\n" \
"\t\t{\n" \
"\t\t\tdocument.getElementById(type).innerText = 'Hide';\n" \
"\t\t}\n" \
"\t}\n" \
"</SCRIPT>\n" \
"<body bgcolor=\"FFFFF0\">\n" \
"<table id=\"entryTable\" class=\"noBorders\" cellpadding=\"3\" border=\"1\" borderColor=\"#000000\" width=\"100%%\">\n" \
"\t<tr>\n" \
"\t<td colspan=\"6\" bgcolor=\"#d6dff7\">\n" \
"\t\t<table class=\"noBorders\" cellpadding=\"3\" width=\"100%%\">\n" \
"\t\t\t<tr>\n" \
"\t\t\t<td width=\"180\">\n" \
"\t\t\t<b>Unique Identifier for this Log:</b>\n" \
"\t\t\t</td>\n" \
"\t\t\t<td>\n" \
"\t\t\t\"<xsl:value-of select=\"TRACE_LOG/UNIQUE_ID\"/>\"\n" \
"\t\t\t</td>\n" \
"\t\t\t<td width=\"160\" align=\"center\" class=\"button\"\n" \
"\t\t\t\tonmouseover=\"this.style.backgroundColor='#FFFFFF';\"\n" \
"\t\t\t\tonmouseout=\"this.style.backgroundColor='#c6cfe7';\"\n" \
"\t\t\t\tonclick=\"toggleRows('#ff0000','txtErrors');\">\n" \
"\t\t\t<span id=\"txtErrors\">Hide</span> ERROR Entries\n" \
"\t\t\t</td>\n" \
"\t\t\t</tr>\n" \
"\t\t\t<tr>\n" \
"\t\t\t<td width=\"180\" rowspan=\"3\" valign=\"top\">\n" \
"\t\t\t<b>Number of logged entries:</b>\n" \
"\t\t\t</td>\n" \
"\t\t\t<td rowspan=\"3\" valign=\"top\">\n" \
"\t\t\t<xsl:value-of select=\"count(TRACE_LOG/ENTRY)\"/>\n" \
"\t\t\t</td>\n" \
"\t\t\t<td width=\"160\" align=\"center\" class=\"button\"\n" \
"\t\t\t\tonmouseover=\"this.style.backgroundColor='#FFFFFF';\"\n" \
"\t\t\t\tonmouseout=\"this.style.backgroundColor='#c6cfe7';\"\n" \
"\t\t\t\tonclick=\"toggleRows('#009900','txtStatus');\">\n" \
"\t\t\t<span id=\"txtStatus\">Hide</span> STATUS Entries\n" \
"\t\t\t</td>\n" \
"\t\t\t</tr>\n" \
"\t\t\t<tr>\n" \
"\t\t\t<td width=\"160\" align=\"center\" class=\"button\"\n" \
"\t\t\t\tonmouseover=\"this.style.backgroundColor='#FFFFFF';\"\n" \
"\t\t\t\tonmouseout=\"this.style.backgroundColor='#c6cfe7';\"\n" \
"\t\t\t\tonclick=\"toggleRows('#ee7700','txtRecv');\">\n" \
"\t\t\t<span id=\"txtRecv\">Hide</span> RECEIVE Entries\n" \
"\t\t\t</td>\n" \
"\t\t\t</tr>\n" \
"\t\t\t<tr>\n" \
"\t\t\t<td width=\"160\" align=\"center\" class=\"button\"\n" \
"\t\t\t\tonmouseover=\"this.style.backgroundColor='#FFFFFF';\"\n" \
"\t\t\t\tonmouseout=\"this.style.backgroundColor='#c6cfe7';\"\n" \
"\t\t\t\tonclick=\"toggleRows('#0000aa','txtSend');\">\n" \
"\t\t\t<span id=\"txtSend\">Hide</span> SEND Entries\n" \
"\t\t\t</td>\n" \
"\t\t\t</tr>\n" \
"\t\t</table> \n" \
"\t</td>\n" \
"\t</tr>\n" \
"\t<tr>\n" \
"\t<td align=\"center\" bgcolor=\"#d6dff7\" colspan=\"3\" width=\"20%%\">Entry Type</td>\n" \
"\t<td align=\"center\" bgcolor=\"#d6dff7\" width=\"20%%\">Entry Origin</td>\n" \
"\t<td align=\"center\" bgcolor=\"#d6dff7\" width=\"10%%\">Class ID</td>\n" \
"\t<td align=\"center\" bgcolor=\"#d6dff7\" width=\"50%%\">Description</td>\n" \
"\t</tr>\n" \
"<xsl:for-each select=\"TRACE_LOG/ENTRY\">\n" \
"\t<tr>\n" \
"\t\t<xsl:attribute name=\"style\">\n" \
"\t\t\t<xsl:if test=\"position() mod 2 &gt; 0\">\n" \
"\t\t\t\tbackground-color:#DDDDD0;\n" \
"\t\t\t</xsl:if>\n" \
"\t\t</xsl:attribute>\n" \
"\t<td class=\"noBorders\" align=\"center\" valign=\"top\" width=\"3%%\">\n" \
"\t\t<xsl:value-of select=\"position()\"/>\n" \
"\t</td>\n" \
"\t<td class=\"noBorders\" align=\"center\" valign=\"top\" width=\"7%%\">\n" \
"\t\t<xsl:value-of select=\"TIME\"/>\n" \
"\t</td>\n" \
"\t<td class=\"noBorders\" align=\"center\" valign=\"top\" width=\"10%%\">\n" \
"\t\t<xsl:attribute name=\"style\">\n" \
"\t\t\t<xsl:choose>\n" \
"\t\t\t\t<xsl:when test=\"TYPE = 'ERROR'\">\n" \
"\t\t\t\t\tcolor:#ff0000;\n" \
"\t\t\t\t</xsl:when>\n" \
"\t\t\t\t<xsl:when test=\"TYPE = 'STATUS'\">\n" \
"\t\t\t\t\tcolor:#009900;\n" \
"\t\t\t\t</xsl:when>\n" \
"\t\t\t\t<xsl:when test=\"TYPE = 'RECEIVE'\">\n" \
"\t\t\t\t\tcolor:#ee7700;\n" \
"\t\t\t\t</xsl:when>\n" \
"\t\t\t\t<xsl:when test=\"TYPE = 'SEND'\">\n" \
"\t\t\t\t\tcolor:#0000aa;\n" \
"\t\t\t\t</xsl:when>\n" \
"\t\t\t\t<xsl:otherwise>\n" \
"\t\t\t\t\tcolor:#000000;\n" \
"\t\t\t\t</xsl:otherwise>\n" \
"\t\t\t</xsl:choose>\n" \
"\t\t</xsl:attribute>\n" \
"\t\t<xsl:value-of select=\"TYPE\"/>\n" \
"\t</td>\n" \
"\t<td class=\"noBorders\" valign=\"top\" width=\"20%%\">\n" \
"\t\t<xsl:value-of select=\"CLASS_NAME\"/>::\n" \
"\t\t<xsl:value-of select=\"FUNCTION_NAME\"/>\n" \
"\t</td>\n" \
"\t<td class=\"noBorders\" valign=\"top\" width=\"10%%\">\n" \
"\t\t<xsl:value-of select=\"FAMILY\"/> \n" \
"\t\t: <xsl:value-of select=\"GENUS\"/> \n" \
"\t\t: <xsl:value-of select=\"SPECIES\"/>\n" \
"\t</td>\n" \
"\t<td class=\"noBorders\" valign=\"top\" width=\"50%%\">\n" \
"\t\t<xsl:variable name=\"outputDesc\">\n" \
"\t\t\t<xsl:call-template name=\"replaceChar\">\n" \
"\t\t\t\t<xsl:with-param name=\"string\">\n" \
"\t\t\t\t\t<xsl:call-template name=\"replaceChar\">\n" \
"\t\t\t\t\t\t<xsl:with-param name=\"string\">\n" \
"\t\t\t\t\t\t\t<xsl:call-template name=\"replaceChar\">\n" \
"\t\t\t\t\t\t\t\t<xsl:with-param name=\"string\" select=\"DESCRIPTION\" />\n" \
"\t\t\t\t\t\t\t\t<xsl:with-param name=\"character\" select=\"'&#x0a;'\" />\n" \
"\t\t\t\t\t\t\t\t<xsl:with-param name=\"replaceString\" select=\"'&lt;br/&gt;'\" />\n" \
"\t\t\t\t\t\t\t</xsl:call-template>\n" \
"\t\t\t\t\t\t</xsl:with-param>\n" \
"\t\t\t\t\t\t<xsl:with-param name=\"character\" select=\"'&#xae;'\" />\n" \
"\t\t\t\t\t\t<xsl:with-param name=\"replaceString\" select=\"'&lt;span style=&#x22;FONT-FAMILY: courier new, courier, terminal;&#x22;&gt;'\" />\n" \
"\t\t\t\t\t</xsl:call-template>\n" \
"\t\t\t\t</xsl:with-param>\n" \
"\t\t\t\t<xsl:with-param name=\"character\" select=\"'&#xaf;'\" />\n" \
"\t\t\t\t<xsl:with-param name=\"replaceString\" select=\"'&lt;/span&gt;'\" />\n" \
"\t\t\t</xsl:call-template>\n" \
"\t\t</xsl:variable>\n" \
"\t\t<xsl:value-of select=\"$outputDesc\" disable-output-escaping=\"yes\" />\n" \
"\t</td>\n" \
"\t</tr>\n" \
"</xsl:for-each>\n" \
"</table>\n" \
"</body>\n" \
"</html>\n" \
"</xsl:template>\n" \
"</xsl:stylesheet>"


#if !defined __TRACELOGENUM
    #define  __TRACELOGENUM
    
    typedef  enum TRACETypes {
        TRACE_Type_ERROR = 0,
        TRACE_Type_STATUS,
        TRACE_Type_RECEIVE,
        TRACE_Type_SEND,
        TRACE_Type_MAX
    } TRACE_TYPES;

#endif //    __TRACELOGENUM

class CTraceSvr
{
public:
    CTraceSvr();
    ~CTraceSvr();

    boolean OpenFile(const ansichar* Filename = DEFAULT_FILENAME,
                     const ansichar* uniqueID = DEFAULT_UNIQUEID_STRING,
                     const ansichar* XSLReference = DEFAULT_XSL_REFERENCE);

    boolean CloseFile();

    boolean EnableLogging(boolean PrintToFile, boolean PrintToScreen);
    boolean DisableLogging();

    uint32 tprintf(TRACE_TYPES traceType,
                   ansichar* className, ansichar* functionName,
                   uint16 Family, uint8 Genus, uint8 Species, 
                   ansichar* descriptionFormat, ...);

    boolean GenerateXSLFile(const ansichar* XSLReference = DEFAULT_XSL_REFERENCE);

    static const char* TypTraceTbl[TRACE_Type_MAX];

private:
    FILE*   Stream;
    char*   mFileName;
    uint8   PrintOptions;

    time_t  TimeBase;

    static void StripFileName(ansichar* Filename);
    uint32 printfStripOff(FILE* Stream, const ansichar* string, va_list vList);
};
#endif /* #if !defined(CTRACESVR_H) */

/*---------------------------------------------------*/
/* End of File */





