/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPEvent.cpp :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#include "CWACPEvent.h"

/*================================================================================
    CONSTRUCTORS / DESTRUCTORS
================================================================================*/
/*********************************************************************************
  Default constructor
    CWACPEvent Start up: 

*********************************************************************************/
CWACPEvent::CWACPEvent()
{
    hHandle = CreateEvent(NULL,FALSE,FALSE,NULL);
}

CWACPEvent::CWACPEvent(char *pName, boolean bManualReset)
{
    hHandle = CreateEvent(NULL,bManualReset,FALSE,pName);
}

CWACPEvent::~CWACPEvent()
{
    CloseHandle(hHandle);
}


/*********************************************************************************
CWACPEvent::Raise - returns the hHandle
*********************************************************************************/
HANDLE CWACPEvent::GetHandle()
{
    return(hHandle);
}

/*********************************************************************************
CWACPEvent::Raise - Triggers the event pointed to by hHandle
*********************************************************************************/
void CWACPEvent::Raise()
{
    SetEvent(hHandle);
}

/*********************************************************************************
CWACPEvent::Raise - Triggers the event pointed to by hHandle
*********************************************************************************/
void CWACPEvent::Reset()
{
    ResetEvent(hHandle);
}

/*********************************************************************************
CWACPEvent::Wait- Waits for an event to fire
*********************************************************************************/
int CWACPEvent::Wait(uint32 Timeout)
{
    int Result;
    
    Result = WaitForSingleObject(hHandle, Timeout);

    return(Result);
}


/* End of File */





