/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPMutex.cpp :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#include "CWACPMutex.h"

/*================================================================================
    CONSTRUCTORS / DESTRUCTORS
================================================================================*/
/*********************************************************************************
  Default constructor
    CWACPMutex Start up: 

*********************************************************************************/
CWACPMutex::CWACPMutex(char *Name)
{
    hMutex = CreateMutex( NULL, FALSE, Name );
}
CWACPMutex::CWACPMutex()
{
    hMutex = CreateMutex( NULL, FALSE, NULL );
}

CWACPMutex::~CWACPMutex()
{
    CloseHandle(hMutex);
}

/*********************************************************************************
CWACPMutex::Lock - Waits for the lock on the mutex
*********************************************************************************/
uint32 CWACPMutex::Lock(uint32 TimeOut)
{
    uint32 MutexResult;

    MutexResult = WaitForSingleObject( hMutex, TimeOut );

    return(MutexResult);
}

/*********************************************************************************
CWACPMutex::Lock - Releases the lock on the mutex
*********************************************************************************/
boolean CWACPMutex::Release()
{
    boolean Result;

    Result = (boolean)ReleaseMutex( hMutex );

    return(Result);
}
    

/* End of File */





