/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPSemaphore.cpp:                                               //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#include "CWACPSemaphore.h"

CWACPSemaphore::CWACPSemaphore(ansichar *pName, uint16 InitCount, uint16 MaxCount)
{
    hHandle = CreateSemaphore(NULL,InitCount,MaxCount,pName);
    bOwner  = GetLastError() != ERROR_ALREADY_EXISTS ? TRUE: FALSE;
}

CWACPSemaphore::~CWACPSemaphore()
{
    CloseHandle(hHandle);
}

void CWACPSemaphore::Raise()
{
    int Result;

    /* Only increment the semaphore count by 1 */
    Result = ReleaseSemaphore(hHandle, 1, NULL);

#if defined(TRACE_SERVER_ON)
    if ( Result == 0 )
        SYS_PRINTF("ReleaseSemaphore ret. err %d\n", GetLastError());
#endif
}

int CWACPSemaphore::Wait(uint32 Timeout)
{
    int Result;
    Result = WaitForSingleObject(hHandle, Timeout);

#if defined(TRACE_SERVER_ON)
    if ( Result == WAIT_FAILED )
        SYS_PRINTF("WaitForSingleObject ret. err %d\n", GetLastError());
#endif

    return(Result);
}


