/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPStack.cpp :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#include "CWACPStack.h"

CWACPStack::CWACPStack(uint16 RNDZPort, uint16 WACPPort, int32 ThreadPriority, void *pCallback)
{   
    LinkLayer.Init(RNDZPort, WACPPort, ThreadPriority, pCallback);
}

CWACPStack::~CWACPStack()
{
}

/*================================================================================
CWACPStack StartClient: Starts up a Client session based on the configuration set
    by the GetConfig() method.
================================================================================*/
void CWACPStack::StartClient()
{
    /* Start the Client session via StartThreads.*/
    LinkLayer.StartClient();
}

/*================================================================================
CWACPStack StartHost: Starts up a Host session.
================================================================================*/
const void CWACPStack::StartServer(ConnArgs **pConnList, uint8 NumConnections)
{
    /* Start the Host session via StartThreads */
    LinkLayer.StartServer(pConnList, (uint8)NumConnections);
}


