/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPThread.cpp:                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#include "CWACPThread.h"

typedef unsigned (WINAPI* WACP_THREAD_PROC)(
    LPVOID lpThreadParameter
);

/*================================================================================
================================================================================*/
/*********************************************************************************
  Default constructor
    CWACPThread Start up: 

*********************************************************************************/
CWACPThread::CWACPThread()
{
    hHandle = NULL;
}

CWACPThread::~CWACPThread()
{
}

/*********************************************************************************
CWACPThread::StartThread - Starts the thread.
*********************************************************************************/
boolean CWACPThread::StartThread(uint32 (WACPAPI* StartAddress)(void*), void* ArgList, 
                                 int32 ThreadPriority)
{
    boolean Result = FALSE;

    TOUCH(ThreadPriority);

    hHandle = (HANDLE)_beginthreadex(NULL, 0, (WACP_THREAD_PROC)StartAddress, ArgList, 0, NULL);
    if (hHandle)
    {
        Result = (boolean)SetThreadPriority(hHandle, ThreadPriority);
        CloseHandle(hHandle);
    }

    return (Result);
}

/*********************************************************************************
CWACPThread::EndThread - Ends the thread. This is not to be used.
*********************************************************************************/
void CWACPThread::EndThread()
{
    /* _endthreadex(0); */
}
    
/* End of File */






