/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2003-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// DtData.cpp                                                        //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** 
'*-E************************************************************************/

#include "DtData.h"

#if((TARGET_XML_SUPPORT != XML_NONE))
const char *DtData::FmStringTable[FmMAX] = 
{   
    "FmARCH",
    "FmECG",
    "FmIP",
    "FmTEMP",
    "FmSPO2",
    "FmNIBP",
    "FmICG",
    "FmHEMODYNAMICS",
    "FmCO2",
    "FmIBP",
    "FmCARDIACOUTPUT",
    "FmUI",
    "FmBARCODE",
    "FmCTR",
    "FmPATIENT",
    "FmUSER",
    "FmGLUCOSE",
    "FmBODYMASSINDEX",
    "FmRESPIRATION",
    "FmWEIGHT",
    "FmINSURANCE",
    "FmPHYSICIAN",
    "FmSITE",
    "FmSESSION",
    "FmDEVICE",
    "FmINTERPRETATION",
    "FmHEIGHT",
    "FmSPIRO",
    "FmTRAP",
    "FmRENDEZVOUS",
    "FmCONNECTION",
    "FmWAVESAMPLE",
    "FmWAVE",
    "FmDEV01", 
    "FmDEV02", 
    "FmDEV03", 
    "FmDEV04", 
    "FmDEV05", 
    "FmDEV06", 
    "FmDEV07", 
    "FmDEV08", 
    "FmDEV09", 
    "FmDEV10", 
    "FmDEV11", 
    "FmDEV12", 
    "FmDEV13", 
    "FmDEV14", 
    "FmDEV15", 
    "FmDEV16", 
    "FmDEV17", 
    "FmDEV18", 
    "FmDEV19", 
    "FmDEV20", 
    "FmDEV21", 
    "FmDEV22", 
    "FmDEV23", 
    "FmDEV24", 
    "FmDEV25", 
    "FmDEV26", 
    "FmDEV27", 
    "FmDEV28", 
    "FmDEV29", 
    "FmDEV30", 
    "FmDEV31", 
    "FmDEV32", 
    "FmDEV33", 
    "FmDEV34", 
    "FmDEV35", 
    "FmDEV36", 
    "FmDEV37", 
    "FmDEV38", 
    "FmDEV39", 
    "FmDEV40", 
    "FmDEV41", 
    "FmDEV42", 
    "FmDEV43", 
    "FmDEV44", 
    "FmDEV45", 
    "FmDEV46", 
    "FmDEV47", 
    "FmDEV48", 
    "FmDEV49", 
    "FmDEV50",
    "FmGLOBALMEASUREMENTS",
    "FmLEADIMPEDANCEARRAY",
    "FmLEADIMPEDANCE",
    "FmMEASUREMENTMATRIX",
    "FmLEADMEASUREMENT",
    "FmQRSANNOTARRAY",
    "FmQRSCOMPLEX",
    "FmPACERARRAY",
    "FmPACERINFO",
    "FmDTCOLLECTION",
    "FmWACP",
    "FmFLASH",
    "FmVERSION",
    "FmPRINTER",
    "FmRECORD",
    "FmTCPIP",
    "FmLOCATIONID",
    "FmPAIN",
    "FmCLINICIAN",
    "FmCALIBRATION",
    "FmPATIENTLIST",
    "FmFAX",
    "FmMODULE",
    "FmMODEM",
    "FmNETWORK",
    "FmTEST",
    "FmENCRYPTION",
    "FmTOC",
    "FmBATTERY",
    "FmFILESYS",
    "FmMOIBSTRING",
    "FmERROR",
    "FmCOMMAND_LINE",
    "FmDICTIONARY",
    "FmNUMERIC",
    "FmCHANNEL",
};

const char *DtData::GnStringTable[GnMAX] = 
{   
    "GnDATA",
    "GnCOMMAND",
    "GnEVENT",
    "GnERROR",
    "GnRESERVE_A",
    "GnSTATUS",
    "GnNUMERIC",
    "GnRESERVE_B",
    "GnCONFIG",
    "GnRESERVE_C",
    "GnRESERVE_D",
    "GnREQUEST",
    "GnRESERVE_E",
    "GnRESERVE_F",
    "GnRESERVE_G",
    "GnRESPONSE",
    "GnPARAMETER",
    "GnSTREAM",
    "GnDATAEXT"
};
#endif /*#if((TARGET_XML_SUPPORT != XML_NONE))*/

/*********************************************************************************
Returns string from the MsgString table
*********************************************************************************/
ansichar *GetMsgString(MsgEntry * msg_list, uint16 msg_entry_count, uint16 msg_id)
{
    uint16 i;
    /* Note: "static" keyword makes this function non-reentrant */
    static ansichar buf[256];

    /* Search through the message list for a match to the id */
    for(i = 0; i<msg_entry_count; i++) {
        if (msg_id == msg_list[i].msg_id) {
            return(msg_list[i].msg_text);
        }
    }

    /* No match to error code, create an "unknown code" message */
    sprintf(buf, "Unknown code: %d", msg_id);
    return (buf);
} 
/*********************************************************************************
Returns TRUE if the enumeration value exists in the MsgString table
*********************************************************************************/
boolean IsValidEnum(MsgEntry *msg_list, uint16 msg_entry_count, uint16 msg_id)
{
    uint16 i;

    /* Search through the message list for a match to the id */
    for(i = 0; i < msg_entry_count; i++) {
        if (msg_id == msg_list[i].msg_id) {
            return(TRUE);
        }
    }
    return FALSE;
}
/*********************************************************************************
Returns the class identifier. The class identifier is used to determine the type of
DataClass. This is used when messages are received by components to determine how
to interpret the message (usually to determine the type to recast the message object).
It is also used when messages are in serial format to determine what type of object
should be used to deserialize the data.
*********************************************************************************/
uint32 DtData::id()
{
    return classIdentifier;
}

/*********************************************************************************
Returns the family sub-code of the class identifier.
*********************************************************************************/
uint16 DtData::family()
{
    return GetFamily(classIdentifier);
}

/*********************************************************************************
 Set function for family
*********************************************************************************/
void DtData::set_Family(uint16 new_Family)
{
    classIdentifier = MakeClassID(new_Family, genus(), species());
}
/*********************************************************************************
Returns the genus sub-code of the class identifier.
*********************************************************************************/
uint8 DtData::genus()
{
    return GetGenus(classIdentifier);
}

/*********************************************************************************
 Set function for genus
*********************************************************************************/
void DtData::set_Genus(uint8 new_Genus)
{
    classIdentifier = MakeClassID(family(), new_Genus, species());
}

/*********************************************************************************
Returns the species sub-code of the class identifier.
*********************************************************************************/
uint8 DtData::species()
{
    return GetSpecies(classIdentifier);
}

/*********************************************************************************
Set function for species
*********************************************************************************/
void DtData::set_Species(uint8 new_Species)
{
    classIdentifier = MakeClassID(family(), genus(), new_Species);
}
/*********************************************************************************
Set function for the SrcVersion data member
*********************************************************************************/
void DtData::SetSrcVersion(uint16 new_SrcVersion)
{
    SrcVersion = new_SrcVersion;
}

/*********************************************************************************
Returns the SrcVersion 
*********************************************************************************/
uint16 DtData::GetSrcVersion()
{
    return SrcVersion;
}
/*********************************************************************************
Set function for the DataBitField data member
*********************************************************************************/
void DtData::SetDataBitField(uint8 new_DataBitField)
{
    DataBitField = new_DataBitField;
}

/*********************************************************************************
Returns the DataBitField
*********************************************************************************/
uint8 DtData::GetDataBitField()
{
    return DataBitField;
}

/*********************************************************************************
Returns a boolean value representing the state of the dirtyFlag bit
*********************************************************************************/
boolean DtData::isdirty()
{
    return (DataBitField & DIRTY_FLAG_MASK);
}

/*********************************************************************************
Sets the dirtyFlag bit 
*********************************************************************************/
void DtData::setdirty(boolean new_dirtyFlag)
{
    if(new_dirtyFlag)
        DataBitField |=  DIRTY_FLAG_MASK;       /* Sets the dirtyFlag bit to 1 */
    else
        DataBitField &= ~DIRTY_FLAG_MASK;       /* Sets the dirtyFlag bit to 0 */
}

/*********************************************************************************
Returns a boolean value representing the state of the validFlag bit
*********************************************************************************/
boolean DtData::isvalid()
{
    return (DataBitField & VALID_FLAG_MASK);
}

/*********************************************************************************
Sets the valid data bit
*********************************************************************************/
void DtData::setvalid(boolean new_validFlag)
{
    if(new_validFlag)
        DataBitField |=  VALID_FLAG_MASK;       /* Sets the validFlag bit to 1 */
    else
        DataBitField &= ~VALID_FLAG_MASK;       /* Sets the validFlag bit to 0 */
}

/*********************************************************************************
Virtual Function: Returns the object version
*********************************************************************************/
uint16 DtData::getVersion()
{
    return 0;
}

/*********************************************************************************
This method places the class identifier into the Buffer in big endian, followed
by the size of the Payload, followed by the serialized object itself. Returns the
total size required from the Buffer. The calling code must make sure that the
Buffer has enough space to hold the serialized object. This can be done through
the size_all method.
*********************************************************************************/
uint32 DtData::serialize_all(uint8 *pBuffer)
{
    uint32 Result = 0;

    if(pBuffer != NULL)
    {
        uint8QManager QMgr(pBuffer, size_all());
        QMgr.put(classIdentifier);

        if(is_Extended(pBuffer))
        {
            QMgr.put(get_payload_size());
        }
        else
        {
            QMgr.put((uint16)get_payload_size());
        }
        serialize_payload(&QMgr);
        Result = size_all();
    }

    return Result;
}

/*********************************************************************************
The counterpart to serialize_all. This method returns the total number of Bytes
deserialized. This method checks that the class identifier stored in the
serialized Buffer matches that returned from the id() method. If they do not
match, 0 is returned. The binary object is deserialized in the 
deserialize_payload method. If deserialize_payload returns false, 0 is returned.
*********************************************************************************/
uint32 DtData::deserialize_all(const uint8 *pBuffer)
{
    uint32 Result  = 0;
    uint32 ActSize = 0;
    uint32 ClassID = 0;
    
    if(pBuffer != NULL)
    {  
        /*Because we have the ability to support variable sized objects
        grab the size of the data from the acutual size found in the 
        Buffer.*/
#if (MEDIA_ENDIANNES == BIG_ENDIAN)
        if(is_Extended((uint8*)pBuffer))
        {
            ActSize = ((((uint32)pBuffer[4])<<24) | 
                       (((uint32)pBuffer[5])<<16) | 
                       (((uint32)pBuffer[6])<<8 ) | 
                       (((uint32)pBuffer[7]))) + sizeof(uint32) + sizeof(uint32);
        }
        else
        {
            ActSize = ((((uint8)pBuffer[4])<<8) | 
                       (((uint8)pBuffer[5])))+ sizeof(uint32) + sizeof(uint16);
                        
        }
#else
        if(is_Extended((uint8*)pBuffer))
        {
            ActSize = ((((uint32)pBuffer[7])<<24) | 
                       (((uint32)pBuffer[6])<<16) | 
                       (((uint32)pBuffer[5])<<8 ) | 
                       (((uint32)pBuffer[4]))) + sizeof(uint32) + sizeof(uint32);
        }
        else
        {
            ActSize = ((((uint8)pBuffer[5])<<8) | 
                       (((uint8)pBuffer[4])))+ sizeof(uint32) + sizeof(uint16);
        }
#endif

        /* Need to cast away const, QManager does not know that Buffer is not modified */
        uint8QManager QMgr((uint8 *)pBuffer, ActSize, TRUE);

        /*Retrieve the ClassID*/
        QMgr.get(&ClassID);

        /*Compare the Buffer's and the Object's ClassID */
        if ((ClassID & 0xFFFFFF00)== (id() & 0xFFFFFF00))
        {
            /* Update the species */
            set_Species((uint8)ClassID);
            if(is_Extended((uint8*)pBuffer))
            {
                uint32 Sz = 0;
                QMgr.get(&Sz);
                if (deserialize_payload(&QMgr, Sz))
                {
                    Result = ActSize;
                }
            }
            else
            {
                uint16 Sz = 0;
                QMgr.get ( &Sz );
                if (deserialize_payload(&QMgr, Sz))
                {
                    Result = ActSize;
                }
            }
        }
    }
    return Result;
}

/*********************************************************************************
Helper function to enqueue MOIB_TIME struct
*********************************************************************************/
void DtData::Put_MOIBTIME(uint8QManager *QMgr, MOIB_TIME sDateTime)
{
    QMgr->put(sDateTime.year);
    QMgr->put(sDateTime.month);
    QMgr->put(sDateTime.day);
    QMgr->put(sDateTime.hour);
    QMgr->put(sDateTime.minute);
    QMgr->put(sDateTime.second);
    QMgr->put(sDateTime.format);
}

/*********************************************************************************
Helper function to dequeue MOIB_TIME struct
*********************************************************************************/
MOIB_TIME DtData::Get_MOIBTIME(uint8QManager *QMgr)
{
    MOIB_TIME sDateTime;

    QMgr->get(&sDateTime.year);
    QMgr->get(&sDateTime.month);
    QMgr->get(&sDateTime.day);
    QMgr->get(&sDateTime.hour);
    QMgr->get(&sDateTime.minute);
    QMgr->get(&sDateTime.second);
    QMgr->get(&sDateTime.format);

    return sDateTime;
}

/*********************************************************************************
Returns the total number of Bytes that would be used by the serialize_all or
deserialize_all methods.
*********************************************************************************/
uint32 DtData::size_all(void)
{
    uint32 Size = sizeof(uint16);

    if(is_Extended(MakeClassID(family(), genus(), species())))
    {
        Size = sizeof(uint32);
    }

    return get_payload_size() + sizeof(uint32) + Size;
}
/*********************************************************************************
Virtual Function: Used to place the data elements of the object into a circular 
queue. This excludes the class identifier. This method is to be overridden by
classes that inherit from this class to serialize any new data elements.
*********************************************************************************/
boolean DtData::serialize_payload(uint8QManager *QMgr)
{
    TOUCH(QMgr);
    return true;
}
/*********************************************************************************
Virtual Function: Used to deserialize the data elements of the object from a 
circular queue. This excludes the class identifier. This method is to be 
overridden by class that inherit from this class to deserialize any new data 
elements.
*********************************************************************************/
boolean DtData::deserialize_payload(uint8QManager *QMgr, uint32 Sz)
{
    TOUCH(QMgr);
    TOUCH(Sz);
    return true;
}

/*********************************************************************************
Virtual Function: Returns the number of Bytes that would be used by the 
serialize_payload and deserialize_payload methods.
*********************************************************************************/
uint32 DtData::get_payload_size(void)
{
    return 0;
}

/*********************************************************************************
Returns the total number of Bytes that would be XML stream
*********************************************************************************/
uint32 DtData::size_XML(void)
{
    return serialize_to_XMLbuf(NULL);
}

/*********************************************************************************
Virtual Function: Returns number of bytes written to XML Stream
*********************************************************************************/
uint32 DtData::serialize_to_XMLbuf(char *pBuf)
{
    TOUCH(pBuf);
    return 0;
}

/*********************************************************************************
Helper Function:
Peforms a comparison between the SrcVersion and the version span in the 
VersionEntry table. Returns TRUE if the SrcVersion falls within the version span
*********************************************************************************/
boolean DtData::GetVersionStatus(VersionEntry * pEntryList, uint16 EntryCount, uint16 MemberEnum)
{
    /* Verify that the MemberEnum is less than the EntryCount*/
    if(MemberEnum < EntryCount)
    {
        /*Return TRUE if SrcVersion is between min and max versions*/
        if((GetSrcVersion() >= pEntryList[MemberEnum].min_version) &&
           (GetSrcVersion() <= pEntryList[MemberEnum].max_version))
            return(TRUE);        
    }

    return (FALSE);
}
/*********************************************************************************
Virtual Function: Returns TRUE if a serialized object has a uint32 size identifier
*********************************************************************************/
boolean DtData::is_Extended(uint8* pBuffer)
{   
    return is_Extended(ReadInt32(pBuffer));
}
/*********************************************************************************
Virtual Function: Returns TRUE if a serialized object has a uint32 size identifier
*********************************************************************************/
boolean DtData::is_Extended(uint32 ClassID)
{
    boolean Result = FALSE;

    if((GetFamily(ClassID) == FmSESSION && GetGenus(ClassID) != GnPARAMETER)
       || GetFamily(ClassID) == FmDTCOLLECTION
       || GetGenus (ClassID) == GnDATAEXT
       || ClassID == MakeClassID(FmSPIRO, GnDATA, 0)          /*0 = SpSTANDARD*/
       || ClassID == MakeClassID(FmECG, GnDATA, 0)            /*0 = SpPACER*/
       || ClassID == MakeClassID(FmCALIBRATION, GnDATA, 128)  /*128 = SpSPIRO*/
       || ClassID == MakeClassID(FmTEST, GnDATA, 255))        /*255 = SpSESSION - Test ClassID Only*/
    {
        Result = TRUE;
    }

    return Result;
}
/*********************************************************************************
Helper Function to calculate a serialized object's size
*********************************************************************************/
uint32 DtData::MOIBSerialSize(uint8* pBuffer, uint8* SizeWidthOut)
{   
    uint32 l_Value = 0;

    /*Check for uint32 Size exceptions*/
    if(is_Extended(pBuffer))
    {
        /*Increment Buffer past ClassID*/
        pBuffer += sizeof(uint32);

        /*Grab 4 byte size identifier with proper endianess*/
        l_Value = ReadInt32(pBuffer);

        /*Add 4 bytes to l_Value*/
        l_Value += sizeof(uint32);

        if(SizeWidthOut)
            *SizeWidthOut = sizeof(uint32);
    }
    else
    {
        /*Increment Buffer past ClassID*/
        pBuffer += sizeof(uint32);

        /*Grab 2 byte size identifier with proper endianess*/
        l_Value = ReadInt16(pBuffer);

        /*Add 2 bytes to l_Value*/
        l_Value += sizeof(uint16);

        if(SizeWidthOut)
            *SizeWidthOut = sizeof(uint16);
    }

    /*Return l_Value + length of ClassID*/
    return l_Value + sizeof(uint32);
}
/*********************************************************************************
Helper Function to calculate the Number of Elements(Serialized Objects) in a 
byte stream.
*********************************************************************************/
uint16 DtData::MOIBSerialElements(uint8* pBuffer, uint32 Size)
{
    uint8 pSize = 0;
    uint16 TotalElements = 0;
    uint32 TempSize = 0;

    while(Size > 0)
    {
         TempSize = MOIBSerialSize(pBuffer, &pSize);
         pBuffer += TempSize;
         Size -= TempSize;
         TotalElements++;
    }

    return TotalElements;
}
#if ((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Helper Function for meta data types (not used for low level objects).
*********************************************************************************/
uint32 DtData::deserialize_from_XMLbuf(const char *Buf, uint32 Size)
{
    XML_Parser    parser = XML_ParserCreate(NULL);
    uint32        bytesRead = 0;
    XMLParserData parserData;

    /* If we enter this function, then we can assume that the related object
       is the overall parent object of an aggregate. We initialize the 
       handler object to this, and the returnObject to this as the default */
    parserData.Object = returnObject = this;
    parserData.Depth = returnDepth = 0;
    parserData.ParentObject = NULL;

    /* Initialize the values for the parser and the callback functions */
    XML_SetUserData(parser, &parserData);
    XML_SetElementHandler(parser, (XML_StartElementHandler)parse_StartElementWrapper, (XML_EndElementHandler)parse_EndElementWrapper);
    XML_SetCharacterDataHandler(parser, (XML_CharacterDataHandler)parse_CharacterDataWrapper);
    validXMLParseFlag = TRUE;

    /* Parse this Buffer. XML_Parse returns 0 if it operated correctly,
        -1 if there was a system error, and an integer value greater than
        0 if the parser encountered an end tag before it reached the 
        specified Len */
    bytesRead = XML_Parse(parser, Buf, (int)Size, TRUE);
    if (!bytesRead) {

#ifdef DEBUG_PRINT
        fprintf(stderr, " %s at line %d\n",
        XML_ErrorString(XML_GetErrorCode(parser)),
        XML_GetCurrentLineNumber(parser));
#endif
        /* We finished parsing prematurely, so return the number of Bytes
            parsed plus the number we have already parsed */
        return bytesRead;
    }

    XML_ParserFree(parser);

    /* If validXMLParseFlag is true, then we didn't encounter our own problems,
       so we can return the number of Bytes parsed. Otherwise, there was an error
       and we return FALSE (0) */
    return (uint32)(validXMLParseFlag ? Size : FALSE);
}

/*********************************************************************************
 -->ENTER COMMENT HERE <--
*********************************************************************************/
void DtData::parse_StartElement(void *UserData, const XML_Char *Name, 
                                const XML_Char **Atts)
{
    int *DepthPtr = (int*)UserData;
    *DepthPtr += 1;
    CurrentParsePos = NULL;
    TOUCH(Name);
    TOUCH(Atts);
}

/*********************************************************************************
XML HELPER FUNCTION
  The XML Parser makes a callback to this function whenever it encounters an end
  tag for an element. All this does is decrement the DepthPtr to keep track of 
  the nodes being processed.
*********************************************************************************/
void DtData::parse_EndElement(void *UserData, const XML_Char *Name)
{
    XMLParserData *parserData = (XMLParserData*)UserData;

    /*decrement DepthPtr to track node depth*/
    uint32 *DepthPtr = &parserData->Depth;
    *DepthPtr -= 1;

    /*reset the CurrentParsePos to NULL so we don't handle
     *end tags in parse_CharacterData*/
    CurrentParsePos = NULL;

    /* Check to see if the ending tag we just encountered was for this COOA object.
       If it was, then we point the parser to our parent object, if aggregate. If
       this object is not a child of an aggregate, then point it back to ourself 
       to handle the rest. */
    if(returnDepth > *DepthPtr)
    {
        parserData->Object = returnObject;
        returnObject = this;
        returnDepth = 0;
    }

#if DEBUG_PRINT
    if (*DepthPtr == 0){fputc('\n', stderr);fputc('\n', stderr);}
#endif

    TOUCH(Name);
}

/*********************************************************************************
 -->ENTER COMMENT HERE <--
*********************************************************************************/
void DtData::parse_CharacterData(void *UserData, const XML_Char *sTag, int Len)
{
    TOUCH(UserData);
    TOUCH(sTag);
    TOUCH(Len);
}
/*********************************************************************************
XML HELPER FUNCTION
    The SetClassAttr is used to store the value of the class attribute 
    that will be used by the parse_StartElement().
*********************************************************************************/
void DtData::SetClassAttr(char *pNewClassAttr)
{
    pClassAttr = (char*)SYS_REALLOC(pClassAttr, strlen(pNewClassAttr) + 1);
    memset(pClassAttr, 0, strlen(pNewClassAttr) + 1);
    memcpy(pClassAttr, pNewClassAttr, strlen(pNewClassAttr));
}
/*********************************************************************************
XML HELPER FUNCTION
    The GetClassAttr is used to retrieve a value of a class attribute that will be 
    used by the parse_StartElement().
*********************************************************************************/
char *DtData::GetClassAttr(void)
{
    return pClassAttr;
}
/*********************************************************************************
XML HELPER FUNCTION
    The ResetXMLAttr is used free the XML Attribute Member pClassAttr 
*********************************************************************************/
void DtData::ResetXMLAttr(void)
{
    SYS_FREE(pClassAttr);
    pClassAttr = NULL;
}
#endif /*#if ((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))*/

/*---------------------------End of DataClass DtData-------------------------------------*/
/* End of File */





