/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// MiscUtil.h     :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(MISCUTIL_H)
    #define  MISCUTIL_H

#include "target.h"
#include "StdVarTyp.h"

#include <string.h>
#if ((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
#include "xmlparse.h"
#include "SysUtil.h"
#endif 

/* Conversion macros taken from the Standard C library headers. They have been
added due to a lack of support in the CE environment*/
#define BTOWC(x) ((wchar_t)(ansichar)(x)) 
#define WCTOB(x) ((x > 255) ? 0 : (ansichar)(x))

#define GUID_STR_SIZE (16*2+4+2+1)

/*================================================================================
Helper function: 16-bit CCITT CRC function
=================================================================================*/
uint16 CalculateCRC(uint8 *pBuf, uint32 BufSize);

/*================================================================================
Convert binary GUID to a string 
=================================================================================*/
ansichar* GUIDToStr(uint8* guid, ansichar* Output, uint16 Size);

/*================================================================================
Convert a string to binary GUID 
=================================================================================*/
uint8* StrToGuid(ansichar *GUIDString, unsigned short GuidSize, uint8 *Output, unsigned short OutputSize);

/*================================================================================
Helper function to convert a nibble to a char
=================================================================================*/
ansichar nibble_to_char(uint8 nibble);

#if ((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*================================================================================
XML HELPER FUNCTION
Converts data pointed at by src to wide character data pointed at by dest.
=================================================================================*/
wchar_t* strtowcs(wchar_t* dest, const ansichar* src, size_t size);

/*================================================================================
XML HELPER FUNCTION
Converts XML data into a MOIB_TIME struct 
=================================================================================*/
boolean xmltotime(const XML_Char *sTag, MOIB_TIME &sDateTime);

/*================================================================================
XML HELPER FUNCTION
Calculates the number of numeric elements in XML string
=================================================================================*/
uint32 CalcArrayLength(const XML_Char *sTag, uint32 Len);

#endif /*#if ((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))*/

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*================================================================================
XML HELPER FUNCTION
Converts data pointed at by src to ansichar character data pointed at by dest.
=================================================================================*/
ansichar* wcstostr(ansichar* dest, const wchar_t* src, size_t size);

/*================================================================================
XML HELPER FUNCTION
Converts a MOIB_TIME struct to a string
=================================================================================*/
char* timetostr(MOIB_TIME& sDateTime, char* Output);

#endif /*#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))*/

#endif  /* #if !defined(MISCUTIL_H) */

/*---------------------------------------------------*/
/* End of File */
